//---------------------------------------------------------------------------
#include <string.h>
#include <sys/stat.h>
#include "mycsv.h"
//---------------------------------------------------------------------------
__fastcall TCSVTable::Initialize(void)
{
    Buffer = NULL;
    LineCount = 0;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TCSVTable::LoadFromFile(const char *file)
{
    struct stat st;
    FILE *fp;
    char *buf,*line;
    int byte,size;

    if(stat(file,&st) == -1)
        return -1;
    size = st.st_size;
    Buffer = (char *)malloc(size+1);
    if(!Buffer)
        return -1;

    fp = fopen(file,"r");
    if(!fp)
        return -1;

    buf = Buffer;
    for(;;){
        // ̉s܂ł̃oCg߂B
        byte = GetNeedByte(fp);
        // t@C̏IȂIB
        if(byte == -1)
            break;
        if(LineCount >= CSVTABLE_ROWMAX)
            break;
        line = buf;
        // +1 ̓k^[~l[^̕B
        buf += byte+1;
/*
        line = AllocateLine(byte+1);
        if(line<0)
            return -1;
*/
        fread(line,1,byte+1,fp);
        line[byte] = '\0';
        Lines[LineCount] = line;
        LineLength[LineCount] = byte;
        LineCount++;
    }
    fclose(fp);
    return 0;
}
//---------------------------------------------------------------------------
// Xg[ŁA݈ʒu玟̉s܂ł̃oCg߂B
// ߂l̓oCgis͊܂܂ȂjBt@CIȂ -1
// ̏ꍇ݈ʒu͓ȂB
__fastcall TCSVTable::GetNeedByte(FILE *fp)
{
    int c,offset,byte=0;

    offset = ftell(fp);
    for(;;byte++){
        c = fgetc(fp);
        if(c == EOF || c == '\n')
            break;
    }
    fseek(fp,offset,SEEK_SET);
    if(c == EOF)
        return -1;
    return byte;
}
//---------------------------------------------------------------------------
/*
// VsЂƂmۂBΊmۂꂽsԍ, sȂ -1
__fastcall TCSVTable::AllocateLine(int size)
{
    if(LineCount >= CSVTABLE_ROWMAX)
        return -1;
    Lines[LineCount] = (char *)malloc(size);
    if(Lines[LineCount] == NULL)
        return -1;
    Lines[LineCount][0] = '\0';
    LineCount++;
    return LineCount-1;
}
*/
//---------------------------------------------------------------------------
// si[Ă郁SĉB
__fastcall TCSVTable::FreeLines(void)
{
/*
    for(int i=0;i<LineCount;i++){
        free(Lines[i]);
        Lines[i] = NULL;
    }
*/
    free(Buffer);
    LineCount = 0;
    return 0;
}
//---------------------------------------------------------------------------
// ڂ̃Z̕w肵čs𓾂B
// ƃZ͌ɔrBႦΎ̑gݍ킹͈vȂB
// Fcell_123
// s@@Fcell_1234,cell5678,cell..
// ','ƕ̃ZrB
// ߂l͌΍sCfbNXAȂ -1
__fastcall TCSVTable::GetRowByName(const char *name)
{
    int index,len;

    len = strlen(name);
    for(index=0;index<LineCount;index++){
        if(len > LineLength[index])
            continue;
        char *p = Lines[index];
        // ZvȂI[LiJ}j̈ʒuɂ锤B
        if(p[len] != ',' && p[len] != '\0')
            continue;
        // ̔rɂB
        if(!strncmp(p,name,len))
            return index;
    }
    return -1;
}
//---------------------------------------------------------------------------
// sƕw肵ăZ̗CfbNX𓾂B
// sɓZQȏ゠͍ŏɌB
// ߂l͌ΗCfbNXAȂ -1
__fastcall TCSVTable::GetCellColumnByName(int row,const char *name)
{
    int index=0,len;
    char *p;

    if(row >= LineCount)
        return -1;
    p = Lines[row];
    len = strlen(name);
    for(;;index++){
        // Z̓evIB
        if(!strncmp(p,name,len)){
            // I[LriZe̊SvjB
            if(*(p+len) == ',' || *(p+len) == '\0')
                break;
        }
        // ̃[vGetCell()ƓȂ̂ŋʉcB
        // J}o܂Ń|C^i߂B
        for(;;){
            if(*p == '\0')
                return -1;
            if(*p == ',')
                break;
            p++;
        }
        p++; // J}΂B
    }
    return index;
}
//---------------------------------------------------------------------------
// col = (keyrow s key ɈvZ̗CfbNX) ƂA
// row s col ̃Z cell Ɋi[B
__fastcall TCSVTable::GetCellByKeyRow(int keyrow,const char *key,
    int row,char *cell,int cellsize)
{
    int col = GetCellColumnByName(keyrow,key);
    if(col == -1)
        return -1;
    return GetCellByXY(col,row,cell,cellsize);
}
//---------------------------------------------------------------------------
// l GetCellByXY(int,int,int *) ƓB
__fastcall TCSVTable::GetCellByKeyRow(int keyrow,const char *key,
    int row,int *value)
{
    const int cellsize=64;
    char cell[cellsize];

    *value = 0;
    if(GetCellByKeyRow(keyrow,key,row,cell,cellsize) == -1)
        return -1;
    if(sscanf(cell,"%d",value) != 1)
        return -1;
    return 0;
}
//---------------------------------------------------------------------------
// Ww肵ăZe擾B{IɃZ𒼐ڈ̂͂̊֐B
// size ͗pӂꂽʁB
// ߂l͐ȂZ̃oCgB
// W͈͊OEȂꍇ͎sA-1
__fastcall TCSVTable::GetCellByXY(int x,int y,char *cell,int size)
{
    char *p;
    bool packed;
    int i,byte;

    if(y >= LineCount)
        return -1;
    // ړĨZ܂Ń|C^i߂B
    p = Lines[y];
    for(i=0;i<x;i++){
        packed = false;
        // ؂Lo܂Ń|C^i߂B
        for(;;){
            if(*p == '\0')
                return -1;
            if((*p==',' || *p==' ' || *p=='\t') && !packed)
                break;
            // ptO𗧂āAȌxpo܂
            // ؂L𖳎B
            // poȂ܂܂ɍsɗ疳ɃG[ɂȂB
            if(*p == '"')
                packed = !packed;
            p++;
        }
        p++; // J}΂B
    }
    // ړĨZpɈ͂܂Ă炱΂B
    packed = (*p == '"');
    if(packed){
        p++;
    }
    // Z̓eRs[B
    for(byte=0;;byte++){
        if(byte >= size-1)
            return -1;
        *cell = *p;
        if(*cell=='\0')
            break;
        if(packed){
            if(*cell=='"')
                break;
        }else{
            if(*cell==',' || *cell==' ' || *cell=='\t')
                break;
        }
        cell++;
        p++;
    }
    *cell = '\0';
    return byte;
}
//---------------------------------------------------------------------------
// ZɐĂƉ肵ēǂݍށB
// Z̓ǂݍ݂Ɏs^Z̓ełȂ *value=0 ƂȂB
__fastcall TCSVTable::GetCellByXY(int x,int y,int *value)
{
    const int cellsize=64;
    char cell[cellsize];

    *value = 0;
    if(GetCellByXY(x,y,cell,cellsize) == -1)
        return -1;
    if(sscanf(cell,"%d",value) != 1)
        return -1;
    return 0;
}
//---------------------------------------------------------------------------

