//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <sys/stat.h>

#include "table.h"

#define MAX_INTSTR_LENGTH 32 //int̕\̍ő咷
//---------------------------------------------------------------------------
//eLXgt@C̓ǂݏoB 0As-1
int __fastcall TStringTable::LoadFromFile(const char *file)
{
    std::ifstream i;

    i.open(file);
    if(!i.is_open())
        return -1;

    std::istreambuf_iterator<char> istr(i), eof;
    Lines.clear();
    std::string s;
    s.reserve(1024);
    for(; istr!=eof; istr++){
        if(*istr != '\n'){
            s.push_back(*istr);
        }
        else{
            Lines.push_back(s);
            s.clear();
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//eLXgt@Cւ̏oB 0As-1
int __fastcall TStringTable::SaveToFile(const char *file) const
{
    std::ofstream o;

    o.open(file);
    if(!o.is_open())
        return -1;

    for(std::vector<std::string>::const_iterator itr = Lines.begin(); itr != Lines.end(); itr++){
        //o<<(*itr)<<"\n";
        o<<(itr->c_str())<<"\n";
    }
    o.close();
    return 0;
}
//---------------------------------------------------------------------------
// ̍ŌɈsǉB
int __fastcall TStringTable::Append(const std::string& s)
{
    Lines.push_back(s);
    return 0;
}
//---------------------------------------------------------------------------
//eLXgt@CǂݍŃJeS[̃CfbNX𓾂B
int __fastcall TDataTable::LoadFromFile(const char *file)
{
    if(StrList.LoadFromFile(file) == -1)
        return -1;
    GetCatIndex();
    CurrentCategory = 0;
    CurrentIndex = 0;
    return 0;
}
//---------------------------------------------------------------------------
//eLXgt@CɃe[u̓eށB
int __fastcall TDataTable::SaveToFile(const char *file) const
{
	StrList.SaveToFile(file);
    return 0;
}
//---------------------------------------------------------------------------
//JeS̃CfbNX𓾂B
int __fastcall TDataTable::GetCatIndex(void)
{
    int count = StrList.GetLineCount();
    CtNames.clear();
    CtLocate.clear();
    for(int i=0;i<count;i++){
        const std::string& line = StrList.GetLine(i);
        if(line[0] == '['){
            std::string s(line, 1, line.size()-2);  // '[',']'͔
            CtNames.push_back(s);
            CtLocate.push_back(i);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//e[uɐVJeSݒ肷B
//JeS𕶎񃊃Xg̖ɕtB
//JeSݒ肳Ă鎞AL[̓JeSł̂݉B
int __fastcall TDataTable::SetCategory(const char *category)
{
    std::string s("[");
    s.append(category);
    s.append("]");
    StrList.Append(s);
    return 0;
}
//---------------------------------------------------------------------------
//ǂݏõJeSw肷B
//YJeS΍ŏ̃JeSw肳ꂽ̂ƂB
//߂l̓JeS 0A -1
int __fastcall TDataTable::GetCategory(const char *category)
{
    int count = CtNames.size();

    // OqbgTB
    for(int i=CurrentCategory;i<count;i++){
        if(!CtNames[i].compare(category)){
            CurrentCategory = i;
            CurrentIndex = CtLocate[i];
            return CtLocate[i];
        }
    }
    // ΍ŏTB
    for(int i=0;i<CurrentCategory;i++){
        if(!CtNames[i].compare(category)){
            CurrentCategory = i;
            CurrentIndex = CtLocate[i];
            return CtLocate[i];
        }
    }
    return -1;
}
//---------------------------------------------------------------------------
//e[uɐVL[ƒl̃Zbgi[
//ɓL[Ă͓
int __fastcall TDataTable::Put(const char *key,const char *value)
{
    std::string s(key);
    s.append("=");
    s.append(value);
    StrList.Append(s);
    return 0;
}
//---------------------------------------------------------------------------
//PutintŁBboolintɃLXgČĂяo΂B
int __fastcall TDataTable::Put(const char *key,int value)
{
    char str[MAX_INTSTR_LENGTH];

    sprintf(str,"%d",value);
    return Put(key,str);
}
//---------------------------------------------------------------------------
//e[uAL[Ƀ}bvꂽloB 0
//GetCategory()Ŏw肳ĂJeSTB
//lȂ΁ANULL
const char* __fastcall TDataTable::Get(const char *key) const
{
    int len = strlen(key);
    int count = StrList.GetLineCount();
    for(int i=CurrentIndex+1; i<count; i++){
        const std::string& line = StrList.GetLine(i);
        if(line[0] == '[') //JeS̏IĩJeSj
            break;
        const char *p = line.c_str();
        if(!strncmp(p, key, len) && p[len] == '=')
            return p + len + 1;
    }
    return NULL;
}
//---------------------------------------------------------------------------
int __fastcall TDataTable::Get(const char *key, std::string& value) const
{
    const char *p = Get(key);
    if(p != NULL){
        value.assign(p);
    }
    else{
        value.assign("");
        return -1;
    }
    return 0;
}
//---------------------------------------------------------------------------
//e[uAL[Ƀ}bvꂽloB 0
//lȂ΁A -1
int __fastcall TDataTable::Get(const char *key, char *value) const
{
    const char *p = Get(key);
    if(p != NULL){
        strcpy(value, p);
    }
    else{
        value[0] = '\0';
        return -1;
    }
    return 0;
}
//---------------------------------------------------------------------------
//GetintŁB𐮐ɒB\łȂ0ƂB
int __fastcall TDataTable::Get(const char *key, int *value) const
{
    const char *p = Get(key);
    if(p != NULL){
        int i = sscanf(p, "%d", value);
        if(i != 1)
            *value = 0;
    }
    else{
        *value = 0;
        return -1;
    }
    return 0;
}
//---------------------------------------------------------------------------
//GetboolŁBbooleanlɒB
int __fastcall TDataTable::Get(const char *key, bool *value) const
{
    int i;

    if(Get(key, &i) == -1)
        return -1;
    *value = (i!=0);
    return 0;
}
//---------------------------------------------------------------------------
//intz܂Ƃ߂ĂЂƂ̃L[Ɋ蓖ĂBcountvaluȇ傫B
// 0Bl񂪒Ȃ肷ꍇAs -1
int __fastcall TDataTable::PutValues(const char *key,const int value[],int count)
{
    char str[MAX_INTSTR_LENGTH];
    std::string s;

    for(int i=0;i<count;i++){
        sprintf(str, "%d", value[i]);
        s.append(str);
        if(i < count-1)
            s.append(",");
    }
    return Put(key, s.c_str());
}
//---------------------------------------------------------------------------
//intzЂƂ̃L[ǂݍށBlengthvaluȇ傫B
//߂l͓ǂݍ񂾒l̐Bs -1
int __fastcall TDataTable::GetValues(const char *key,int value[],int length) const
{
    const char *str = Get(key);
    if(str == NULL)
        return -1;

    char intstr[MAX_INTSTR_LENGTH];
    int count = 0;
    for(int i=0;i<length;i++){
        int chrcount = 0;
        while(*str != ',' && *str != '\0'){
            // 񂪒ΎsB
            if(chrcount >= MAX_INTSTR_LENGTH-1)
                return -1;
            intstr[chrcount] = *str;
            chrcount++;
            str++;
        }
        if(!chrcount)
            break;
        intstr[chrcount] = '\0';
        int scan = sscanf(intstr, "%d", &value[i]);
        if(scan != 1)
            value[i] = 0;
        count++;
        if(*str == ','){
            str++;
        }
        else{
            break;
        }
    }
    return count;
/*
    char str[MAX_VALUE_LENGTH],s[MAX_INTSTR_LENGTH];
    int i,j,index=0,oldindex=0;

    if(Get(key,str) == -1)
        return -1;
    if(str[0] == '\0')  //󕶎Ȃǂݍ񂾒l̐ 0Ƃ
        return 0;
    for(i=0;i<count;i++){
        while(str[index] != ','){    //J}T
            if(str[index] == '\0'){  //ȂΏI
                count = i+1; //ǂݍ߂L
                break;
            }
            index++;
        }

        //񂪒Ύs
        if(index-oldindex+1 >= MAX_INTSTR_LENGTH-1)
            return -1;
        for(j=oldindex; j<index; j++) //lo
            s[j-oldindex] = str[j];
        s[j-oldindex] = '\0';
        value[i] = atoi(s);
        index++;                    //J}̎̕Ɉړ
        oldindex = index;
    }
    return count;
*/
}
//---------------------------------------------------------------------------
int __fastcall TDataTable::PutValues(const char *key, const std::vector<int>& vec)
{
    char str[MAX_INTSTR_LENGTH];
    std::string s;
    bool first=true;

    for(std::vector<int>::const_iterator itr=vec.begin(); itr!=vec.end(); itr++){
        if(first){
            first = false;
        }else{
            s.append(",");
        }
        sprintf(str, "%d", *itr);
        s.append(str);
    }
    return Put(key, s.c_str());
}
//---------------------------------------------------------------------------
// int[]ł̃RsyB
int __fastcall TDataTable::GetValues(const char *key, std::vector<int>& vec) const
{
    const char *str = Get(key);
    if(str == NULL)
        return -1;

    vec.clear();
    char intstr[MAX_INTSTR_LENGTH];
    int count = 0;
    for(;;){
        int chrcount = 0;
        while(*str != ',' && *str != '\0'){
            // 񂪒ΎsB
            if(chrcount >= MAX_INTSTR_LENGTH-1)
                return -1;
            intstr[chrcount] = *str;
            chrcount++;
            str++;
        }
        if(!chrcount)
            break;
        intstr[chrcount] = '\0';
        int val;
        int scan = sscanf(intstr, "%d", &val);
        if(scan != 1)
            val = 0;
        vec.push_back(val);
        count++;
        if(*str == ','){
            str++;
        }
        else{
            break;
        }
    }
    return count;
}
//---------------------------------------------------------------------------
//QintЂƂ̃L[Ɋ蓖ĂBzg܂łȂl̃Zbgp
// 0 AsȂ -1
int __fastcall TDataTable::PutTwoValues(const char *key,int v1,int v2)
{
    int values[2] = {v1, v2};
    return PutValues(key,values,2);
}
//---------------------------------------------------------------------------
//PutTwoValuesŊi[loB 0 AsȂ -1
int __fastcall TDataTable::GetTwoValues(const char *key,int *v1,int *v2) const
{
    const char *p = Get(key);
    if(p == NULL)
        return -1;
    if(sscanf(p,"%d,%d",v1,v2) != 2)
        return -1;
    return 0;
}
//---------------------------------------------------------------------------
//ЂƂ̃L[Recti[B 0 AsȂ -1
int __fastcall TDataTable::PutRect(const char *key,TRect r)
{
    int values[4] = {r.Left, r.Top, r.Right, r.Bottom};
    return PutValues(key,values,4);
}
//---------------------------------------------------------------------------
//PutRectŊi[loB 0 AsȂ -1
int __fastcall TDataTable::GetRect(const char *key,TRect *r) const
{
    const char *p = Get(key);
    if(p == NULL)
        return -1;

    int x1,y1,x2,y2;
    if(sscanf(p, "%d,%d,%d,%d", &x1, &y1, &x2, &y2) != 4)
        return -1;
    r->Left = x1;
    r->Top = y1;
    r->Right = x2;
    r->Bottom = y2;
    return 0;
}
//---------------------------------------------------------------------------
// ̃L[ƒl̃yAoB
// ߂l̓yA0, -1
const char* __fastcall TDataTable::GetNext(void)
{
    int count = StrList.GetLineCount();
    if(CurrentIndex >= count)
        return NULL;
    CurrentIndex++;
    const std::string& line = StrList.GetLine(CurrentIndex);
    if(line[0] == '[') //JeS̏IĩJeSj
        return NULL;
    return line.c_str();
}
//---------------------------------------------------------------------------
// ̃L[ƒl̃yAoB
// ߂l̓yA0, -1
int __fastcall TDataTable::GetNext(char *key,char *value)
{
    const char *str = GetNext();
    if(str == NULL)
        return -1;

    char *p = key;
    while(*str != '=' && *str != '\0'){
        *p = *str;
        p++;
        str++;
    }
    *p = '\0';
    if(*str != '\0')
        strcpy(value, str+1);
    return 0;
}
//---------------------------------------------------------------------------
int __fastcall TDataTable::GetNext(char *key,int *value)
{
    const char *str = GetNext();
    if(str == NULL)
        return -1;
    sscanf(str,"%d",value);
    return 0;
}
//---------------------------------------------------------------------------
