//---------------------------------------------------------------------------
#ifndef tableH
#define tableH

#define LN_BUFFER (64*1024)  // sobt@̏e
#define CT_BUFFER (32*1024)  // JeSobt@̏e

#include <vcl.h>
#include <stdlib.h>
#include <vector>
#include <fstream>
#include <iostream>
#include <iterator>
#include <algorithm>
//#if !defined(__fastcall)
//#define __fastcall
//#endif

//---------------------------------------------------------------------------
//񃊃XgǗAeLXgt@Cւ̓o͂sB
//TStringList͍@\ǂݏo삪xׁAȈՂȑ֕iB
class TStringTable
{
private:
    std::vector<std::string> Lines;
public:
    TStringTable(int lsize=LN_BUFFER) : Lines(lsize) {
        Lines.clear();
    }
    virtual ~TStringTable(void){
    }
    int __fastcall LoadFromFile(const char *file);
    int __fastcall SaveToFile(const char *file) const;
    int __fastcall Append(const std::string& s);
    int __fastcall GetLineCount(void) const { return Lines.size(); };
    const std::string& __fastcall GetLine(int index) const { return Lines[index]; };
};
//---------------------------------------------------------------------------
// L[lɑΉliji[e[uB
// xɃf[^oAxɃf[^ǂݍނ߂̕Ȃ̂
// IɃf[^XV悤ȗprɂ͎gȂB
// ڂJeS폜悤ȋ@\ȂB
// eXVꂽAǂݍށiGet()jGetCatIndex()Kv
class TDataTable
{
private:
    TStringTable StrList;               // key=valuě`ŕi[
    int CurrentCategory;                // ݂̃JeS[̔ԍ
    int CurrentIndex;                   // L[n߂CfbNX
    std::vector<std::string> CtNames;   // JeS̖Oiconst char* ɂȂĂȂ̂[]̂߁j
    std::vector<int>         CtLocate;  // JeS̃CfbNX
public:
    TDataTable(void) : StrList(), CtNames(CT_BUFFER), CtLocate(CT_BUFFER),
                       CurrentCategory(0), CurrentIndex(0){
        CtNames.clear();
        CtLocate.clear();
    }
    virtual ~TDataTable(void){
    }
    int __fastcall LoadFromFile(const char *file);
    int __fastcall SaveToFile(const char *file) const;
private:
    int __fastcall GetCatIndex(void);
public:
    int __fastcall SetCategory(const char *category);
    int __fastcall GetCategory(const char *category);
    int __fastcall Put(const char *key, const std::string& str){ return Put(key, str.c_str()); };
    int __fastcall Put(const char *key, const char *value);
    int __fastcall Put(const char *key, int value);
    const char* __fastcall Get(const char *key) const;
    int __fastcall Get(const char *key, std::string& value) const;
    int __fastcall Get(const char *key, char *value) const;
    int __fastcall Get(const char *key, int *value) const;
    int __fastcall Get(const char *key, bool *value) const;
    int __fastcall PutValues(const char *key,const int value[],int count);
    int __fastcall GetValues(const char *key,int value[],int count) const;
    int __fastcall PutValues(const char *key, const std::vector<int>& vec);
    int __fastcall GetValues(const char *key, std::vector<int>& vec) const;
    int __fastcall PutTwoValues(const char *key,int v1,int v2);
    int __fastcall GetTwoValues(const char *key,int *v1,int *v2) const;
    int __fastcall PutRect(const char *key,TRect rect);
    int __fastcall GetRect(const char *key,TRect *rect) const;
    const char* __fastcall GetNext(void);
    int __fastcall GetNext(char *key,char *value);
    int __fastcall GetNext(char *key,int *value);
};
//---------------------------------------------------------------------------
#endif

