//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#include <Clipbrd.hpp>
#pragma hdrstop

#include "gbwedit1.h"
#include "ksfunc.h"
#include "ksmapprp.h"
#include "ksdrawhdc.h"

#define VERSIONSTRING "ǒn헪}bvGfB^ for Ver.2.283"
#define MAPDEFAULTWIDTH  32
#define MAPDEFAULTHEIGHT 32
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cgauges"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    Image_Map->ControlStyle = Image_Map->ControlStyle << csOpaque;
    Image_Viewport->ControlStyle = Image_Viewport->ControlStyle << csOpaque;
    PanelX=-1;
    Option.Initialize();
    Option.Load();
    FileHistory_Update();

    Form_UnitProperty = new TForm_UnitProperty(this);

    KSImageData = new TKSImageData();
    GBW_LoadSystemGraphic(KSImageData, &Option);

    FieldScreen1=new FieldScreen();
    FieldScreen1->DefineImageList(KSImageData, 0);

    BaseData1=new BaseData();
    BaseData1->SetDefault();

    KSDrawHDC_Init();
//    Script_Initialize(MainInstance, Application->Handle, this);
    // LuȁB
//    KSLua_Initialize();

    NowRunning=true;
    Show();
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1(void)
{
    delete Form_UnitProperty;
    if(Map != NULL)
        delete Map;
    if(MapBackup != NULL)
        delete MapBackup;
    delete KSImageData;
    delete FieldScreen1;
    delete BaseData1;
    if(RangeLayer != NULL)
        delete RangeLayer;
    if(Container != NULL){
        delete Container;
    }
    NowRunning=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1Show(TObject *Sender)
{
    Option.GetWindowState(&Option.WindowState_ksedit, this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1Close(TObject *Sender, TCloseAction &Action)
{
    if(!MapModifiedCheck())
        Action=caNone;

    Option.SetWindowState(&Option.WindowState_ksedit, this);
    Option.Save();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1Paint(TObject *Sender)
{
    DefocusControl(ScrollBox_Pen,false);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1CanResize(TObject *Sender, int &NewWidth,
      int &NewHeight, bool &Resize)
{
    Image_Map->Width = NewWidth - Panel1->Width - ScrollBox_Pen->Width - 8;
    Image_Loading->Height = Image_Viewport->Top - 312 - 5;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1ConstrainedResize(TObject *Sender,
      int &MinWidth, int &MinHeight, int &MaxWidth, int &MaxHeight)
{
    MinWidth = Panel1->Width + ScrollBox_Pen->Width + 32;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Resize(TObject *Sender)
{
    Graphics::TBitmap *bitmap = Image_Map->Picture->Bitmap;
    bitmap->Width  = Image_Map->Width;
    bitmap->Height = Image_Map->Height;
    bitmap->Canvas->Brush->Color = clBlack;
    bitmap->Canvas->FillRect(TRect(0, 0, bitmap->Width, bitmap->Height));
    if(NowRunning && Map != NULL){
        MapSizeSet();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch(Key){
    case VK_LEFT:
        ScrollBox_Pen->HorzScrollBar->Position -= FieldScreen1->GraphDegree;
        break;
    case VK_UP:
        ScrollBox_Pen->VertScrollBar->Position -= FieldScreen1->GraphDegree;
        break;
    case VK_RIGHT:
        ScrollBox_Pen->HorzScrollBar->Position += FieldScreen1->GraphDegree;
        break;
    case VK_DOWN:
        ScrollBox_Pen->VertScrollBar->Position += FieldScreen1->GraphDegree;
        break;
    case VK_CONTROL:
        System.ControlPushed = true;
        ChangeNavigateMessage(0,0);
        break;
    case VK_SHIFT:
        System.ShiftPushed = true;
        ChangeNavigateMessage(0,0);
        break;
    }
    if(Shift * (TShiftState()<<ssCtrl) != TShiftState()){
        switch(Key){
        case 'O':
        case 'o':
            if(MI_Open->Enabled)
                MI_OpenClick(Sender);
            break;
        case 'S':
        case 's':
            if(MI_Save->Enabled)
                MI_SaveClick(Sender);
            break;
        case 'P':
        case 'p':
            if(MI_Property->Enabled)
                MI_PropertyClick(Sender);
            break;
        case 'U':
        case 'u':
            if(MI_Undo->Enabled)
                MI_UndoClick(Sender);
            break;
        case 'C':
        case 'c':
            if(MI_Copy->Enabled)
                MI_CopyClick(Sender);
            break;
        case 'V':
        case 'v':
            if(MI_Paste->Enabled)
                MI_PasteClick(Sender);
            break;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch(Key){
    case VK_CONTROL:
        System.ControlPushed = false;
        ChangeNavigateMessage(0,0);
        break;
    case VK_SHIFT:
        System.ShiftPushed = false;
        ChangeNavigateMessage(0,0);
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1MouseWheel(TObject *Sender,
      TShiftState Shift, int WheelDelta, TPoint &MousePos, bool &Handled)
{
    if(Map == NULL)
        return;
    if(WheelDelta > 0){
        SlideViewport(0, -FieldScreen1->GraphDegree);
        Handled = true;
    }
    else if(WheelDelta < 0){
        SlideViewport(0, +FieldScreen1->GraphDegree);
        Handled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnImage_MapMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if(Map == NULL)
        return;
    if(Button == mbLeft && FieldScreen1->NoticeMouseDownToViewport(X, Y)){
        DrawAllAndUpdateMapView();
        return;
    }

    if(System.ShowRange){ //˒͈͏
        System.ShowRange=false;
        FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
        ChangeNavigateMessage(X,Y);
        FieldScreen1->ClearSpriteList();
        DrawAllAndUpdateMapView();
        return;
    }

    switch(Button){
    case mbLeft:
        System.LeftButton=true;
        if(Shift * (TShiftState()<<ssCtrl) != TShiftState()){
            ShowUnitPropertyDialog(X,Y);
        }
        else if(Shift * (TShiftState()<<ssShift) != TShiftState()){
            SetLoadUnit(X,Y);
        }
        else{
            PenLeftDown(X,Y);
        }
        break;
    case mbRight:
        System.RightButton=true;
        PenRightDown(X,Y);
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnImage_MapMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if(Map == NULL)
        return;
    if(FieldScreen1->NoticeMouseMoveToViewport(X, Y)){
        DrawAllAndUpdateMapView();
        return;
    }

    if(System.LeftButton)
        PenLeftDrag(X,Y);
    else
        PenMove(X,Y);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnImage_MapMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if(Map == NULL)
        return;
    switch(Button){
    case (TMouseButton)mbLeft:
        System.LeftButton=false;
        if(FieldScreen1->NoticeMouseUpToViewport()){
            DrawAllAndUpdateMapView();
            return;
        }
        PenLeftUp(X,Y);
        break;
    case (TMouseButton)mbRight:
        System.RightButton=false;
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_ViewportMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    SetViewportLeftTop(X*FieldScreen1->GraphDegree, Y*FieldScreen1->GraphDegree);
    System.LButtonDownedOnViewport = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_ViewportMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if(System.LButtonDownedOnViewport){
        SetViewportLeftTop(X*FieldScreen1->GraphDegree, Y*FieldScreen1->GraphDegree);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_ViewportMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    System.LButtonDownedOnViewport = false;
}
//---------------------------------------------------------------------------
// n`Ejbg̑IB
// Image_Pen̑傫͒n`/jbgɑ΂ēK؂ɐݒ肳Ă̂ƂB
void __fastcall TForm1::Image_PenMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    int zx = X/GRAPHDEGREE_N;
    int zy = Y/GRAPHDEGREE_N;

    if(Button != mbLeft)
        return;

    switch(System.DrawMode){
    case MODE_DRAWGROUND:
        if(BaseData1->GetMapChipByType(zy).IsBuilding &&
           zx < BaseData1->Sides+1){
            System.Pen_Side = zx-1;
            System.Pen_Type = zy;
        }else if(zx==0){
            System.Pen_Side = 0;
            System.Pen_Type = zy;
        }
        else{
            System.Pen_Side = 0;
            System.Pen_Type = BaseData1->GetGroundTypeIndex(-1);
        }
        break;
    case MODE_DRAWUNIT: // ܂Isjbg͖B
        System.Pen_Side = zx;
        System.Pen_Type = zy;
        break;
    }
    PenStatusPut();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer_InputRepeatTimer(TObject *Sender)
{
    if(FieldScreen1->NoticeTimerToViewport()){
        DrawAllAndUpdateMapView();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MI_NewClick(TObject *Sender)
{
    if(!MapModifiedCheck())
        return;
    Situation.Initialize();
    KS_ResizeSideStatusArray(SideStatus1, BaseData1->Sides);
    for(int side=0; side<BaseData1->Sides; side++){
        SideStatus1[side].Initialize();
    }
    if(Map != NULL)
        delete Map;
    Map = new MapData(MAPDEFAULTWIDTH, MAPDEFAULTHEIGHT);
    MapPropertyDialog(true);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_OpenClick(TObject *Sender)
{
    if(!MapModifiedCheck())
        return;
    OpenDialog1->InitialDir = Option.Folder_Map;
    if(OpenDialog1->Execute()){
        LoadMap(OpenDialog1->FileName.c_str());
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_SaveClick(TObject *Sender)
{
    int i=1;

    SaveDialog1->InitialDir = Option.Folder_Map;
    if(!strcmp(System.EditFile,NEWFILENAME))
        i=SaveNameDialog();
    if(i)
        SaveMap(System.EditFile);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_SaveAsClick(TObject *Sender)
{
    if(SaveNameDialog())
        SaveMap(System.EditFile);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_UndoClick(TObject *Sender)
{
    Map->Assign(*MapBackup);
    DrawAllAndUpdateMapView();
    Enabled_Undo(false);
    System.MapModified=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MI_PropertyClick(TObject *Sender)
{
    MapPropertyDialog(false);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_ExitClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MI_VersionClick(TObject *Sender)
{
    ShowMessage(VERSIONSTRING);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_PenMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    DefocusControl(ScrollBox_Pen,false);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GraphNormalClick(TObject *Sender)
{
    FieldScreen1->DefineImageList(KSImageData, 0);
    MapSizeSet();
    DrawAll();
    MI_GraphNormal->Checked=true;
    MI_GraphSmall->Checked=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GraphSmallClick(TObject *Sender)
{
    int i;

    FieldScreen1->DefineImageList(KSImageData, 1);
    MapSizeSet();
    DrawAll();
    MI_GraphNormal->Checked=false;
    MI_GraphSmall->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MenuGraphNormalClick(TObject *Sender)
{
    SpeedButton_GraphNormal->Click();
    SpeedButton_GraphNormal->Down=true;
    SpeedButton_GraphSmall->Down=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MenuGraphSmallClick(TObject *Sender)
{
    SpeedButton_GraphSmall->Click();
    SpeedButton_GraphNormal->Down=false;
    SpeedButton_GraphSmall->Down=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrawGroundClick(TObject *Sender)
{
    if(System.DrawMode==MODE_DRAWGROUND)
        return;
    System.DrawMode=MODE_DRAWGROUND;
    if(System.ShowRange){
        DrawAllAndUpdateMapView();
        System.ShowRange=false;
    }
    StartGroundEdit();
    SpeedButton_DrawGround->Down=true;
    SpeedButton_DrawUnit->Down=false;
    MI_DrawGround->Checked=true;
    MI_DrawUnit->Checked=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_DrawUnitClick(TObject *Sender)
{
    if(System.DrawMode==MODE_DRAWUNIT)
        return;
    System.DrawMode=MODE_DRAWUNIT;
    StartUnitEdit();
    SpeedButton_DrawGround->Down=false;
    SpeedButton_DrawUnit->Down=true;
    MI_DrawGround->Checked=false;
    MI_DrawUnit->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_Edit_PenClick(TObject *Sender)
{
    DrawGroundClick(Sender);
    MI_Edit_Pen->Checked=true;
    SpeedButton_Pen->Down=true;
    MI_Edit_BoxFill->Checked=false;
    SpeedButton_BoxFill->Down=false;
    MI_Edit_BoxSelect->Checked=false;
    SpeedButton_BoxSelect->Down=false;
    System.DrawGroundMode = DGMODE_PEN;
    StartPenMode();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_Edit_BoxFillClick(TObject *Sender)
{
    DrawGroundClick(Sender);
    MI_Edit_Pen->Checked=false;
    SpeedButton_Pen->Down=false;
    MI_Edit_BoxFill->Checked=true;
    SpeedButton_BoxFill->Down=true;
    MI_Edit_BoxSelect->Checked=false;
    SpeedButton_BoxSelect->Down=false;
    System.DrawGroundMode = DGMODE_BOXFILL;
    StartBoxFillMode();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_Edit_BoxSelectClick(TObject *Sender)
{
    DrawGroundClick(Sender);
    MI_Edit_Pen->Checked=false;
    SpeedButton_Pen->Down=false;
    MI_Edit_BoxFill->Checked=false;
    SpeedButton_BoxFill->Down=false;
    MI_Edit_BoxSelect->Checked=true;
    SpeedButton_BoxSelect->Down=true;
    System.DrawGroundMode = DGMODE_BOXSELECT;
    StartBoxSelectMode();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_CopyClick(TObject *Sender)
{
    if(System.DrawGroundMode == DGMODE_BOXSELECT)
        if(SelectedRect.AreaSelected() && System.SelectDecided)
            Container->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MI_PasteClick(TObject *Sender)
{
    if(Container->PasteFromClipboard()==-1){
        ShowMessage("Nbv{[hɓe܂B");
        return;
    }
    if(System.DrawMode==MODE_DRAWGROUND && System.DrawGroundMode==DGMODE_BOXSELECT)
        PenRightDown(0,0); //I𑀍Ă\Ή
    else{
        MI_Edit_BoxSelectClick(Sender);
    }
    SelectedRect = Container->ContainRect;
    SelectedRect.Move(-Container->ContainRect.Left, -Container->ContainRect.Top);
    SelectedRect.Normalize();
    Container->ShowBuffer(Map, RangeLayer, SelectedRect.Left, SelectedRect.Top, FieldScreen1);
    DrawAllAndUpdateMapView();
    System.SelectDecided = true;
}
//---------------------------------------------------------------------------
// t@CIƂ̏B
void __fastcall TForm1::MenuItem_HistoryClick(TObject *Sender)
{
    TMenuItem *menu = static_cast<TMenuItem *>(Sender);
    char file[MAX_PATH];

    strcpy(file, MI_File->Items[menu->MenuIndex]->Caption.c_str());
    LoadMap(file);
}
//---------------------------------------------------------------------------
__fastcall TForm1::FileHistory_Add(const char *name)
{
    Option.History_ksedit.Add(name);
    FileHistory_Update();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::FileHistory_Update(void)
{
    const int len=10;
    char *list[len];
    int count;

    count = Option.History_ksedit.GetHistory(list,len);
    UpdateHistoryMenu(MI_File,MI_N_File_HistoryTop,MI_N_File_HistoryBottom,
                      list,count,MenuItem_HistoryClick);
    return 0;
}
//---------------------------------------------------------------------------
// S`悩S]B̏͂ƂĂ̂ŁB
__fastcall TForm1::DrawAllAndUpdateMapView(void)
{
    DrawAll();
    UpdateMapViewAll();
    FieldScreen1->DrawViewportToTCanvas(Image_Viewport->Canvas, Image_Viewport->Width, Image_Viewport->Height);
    Image_Viewport->Refresh();
    return 0;
}
//---------------------------------------------------------------------------
// }bv\Ŝ`悷B
__fastcall TForm1::DrawAll(void)
{
    FieldScreen1->DrawMap(Map, RangeLayer, NULL, SideStatus1);
    return 0;
}
//---------------------------------------------------------------------------
// }bv̈ꕔXV`悷B
__fastcall TForm1::DrawMapPartial(int zx1, int zy1, int zx2, int zy2)
{
    FieldScreen1->DrawMap(Map, RangeLayer, NULL, SideStatus1, zx1, zy1, zx2, zy2);
    return 0;
}
//---------------------------------------------------------------------------
// FieldScreeñrbg}bvImage1ɓ]B
__fastcall TForm1::UpdateMapViewAll(void)
{
    if(!NowRunning)
        return 0;
    FieldScreen1->DrawScrollBars();
    FieldScreen1->CopyToTCanvas(Image_Map->Canvas);

    const TSize& s = FieldScreen1->GetViewportOuterSize();
    if(Image_Map->Width > s.cx){
        Image_Map->Canvas->Brush->Color = clBlack;
        Image_Map->Canvas->FillRect(TRect(s.cx, 0, Image_Map->Width, Image_Map->Height));
    }
    if(Image_Map->Height > s.cy){
        Image_Map->Canvas->Brush->Color = clBlack;
        Image_Map->Canvas->FillRect(TRect(0, s.cy, Image_Map->Width, Image_Map->Height));
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bv摜̈ꕔXV
__fastcall TForm1::UpdateMapView(int x1,int y1,int x2,int y2)
{
    UpdateMapView(TRect(x1,y1,x2,y2));
    return 0;
}
//---------------------------------------------------------------------------
//}bv摜̈ꕔXViRectŁj
__fastcall TForm1::UpdateMapView(const TRect& r)
{
    FieldScreen1->CopyToTCanvas(Image_Map->Canvas, r);
    return 0;
}
//---------------------------------------------------------------------------
// }bv摜PubNXVi_WŎwj
__fastcall TForm1::UpdateMapViewBlock(int zx, int zy)
{
    int x,y;

    FieldScreen1->XY_MapToPhy(zx,zy,&x,&y);
    UpdateMapView(TRect(x,y,x+FieldScreen1->GraphDegree,y+FieldScreen1->GraphDegree));
    return 0;
}
//---------------------------------------------------------------------------
// }bv摜XVi_WŎwj
__fastcall TForm1::UpdateMapViewBlock(int zx1, int zy1, int zx2, int zy2)
{
    int x1, y1, x2, y2;

    FieldScreen1->XY_MapToPhy(zx1, zy1, &x1, &y1);
    FieldScreen1->XY_MapToPhy(zx2, zy2, &x2, &y2);
    UpdateMapView(TRect(x1 - FieldScreen1->GraphDegree/2, y1, x2 + FieldScreen1->GraphDegree + FieldScreen1->GraphDegree/2, y2 + FieldScreen1->GraphDegree));
    return 0;
}
//---------------------------------------------------------------------------
//eLXg`Ń}bvZ[uB
__fastcall TForm1::SaveMap(const char *file)
{
    FileHistory_Add(file);
    GBW_SaveGame(file,Map,&Situation,SideStatus1,BaseData1);
    System.MapModified=false;
    return 0;
}
//---------------------------------------------------------------------------
// }bvt@C̃[hBjbgf[^default.csvgpB
__fastcall TForm1::LoadMap(const char *file)
{
    strcpy(System.EditFile, file);
    FileHistory_Add(file);
    if(Map != NULL){
        delete Map;
        Map = NULL;
    }
    GBW_LoadGame(file, &Map, &Situation, SideStatus1, BaseData1, &Option, KSImageData, false);
    InitializeMapEdit();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SaveNameDialog(void)
{
    int r;

    SaveDialog1->FileName=System.EditFile;
    r=SaveDialog1->Execute();
    if(r)
        if(!access(SaveDialog1->FileName.c_str(),0))
            if(MessageDlg("̃t@C͊ɑ݂܂B㏑܂H", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)==mrNo)
                r=false;
    if(r)
        strcpy(System.EditFile,SaveDialog1->FileName.c_str());

    return r;
}
//---------------------------------------------------------------------------
__fastcall TForm1::ModifiedSaveDialog(void)
{
    int r;

    r=MessageDlg("ύXĂ܂Bۑ܂H", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo << mbCancel, 0);
    return r;
}
//---------------------------------------------------------------------------
//݂̃}bvύXĂZ[u₢킹B
//[U[LZI񂾂߂lfalseB
__fastcall TForm1::MapModifiedCheck(void)
{
    int i;
    bool r=true;

    if(System.MapModified){
        i=ModifiedSaveDialog();
        switch(i){
        case mrYes:
            i=SaveNameDialog();
            if(i)
                SaveMap(System.EditFile);
            else
                r=false;
            break;
        case mrNo:
            break;
        case mrCancel:
            r=false;
            break;
        }
    }
    return (int)r;
}
//---------------------------------------------------------------------------
// VK}bvE}bv̓ǂݍ݁EvpeB̕ύX̌ɍsB
__fastcall TForm1::InitializeMapEdit(void)
{
    Image_Map->Enabled = false;
    Image_Pen->Visible = false;

    // jbg̃CtȂǂB
    for(int side=0;side<BaseData1->Sides;side++){
        for(int num=0;num<SideStatus1[side].UnitCount;num++){
            UnitStatus *unitp = &SideStatus1[side].Unit[num];
            // 蓮Œlݒ肳Ăꍇ͕ێB
            int life = unitp->Life;
            int fuel = unitp->Fuel;
            int level = unitp->Level;
            int load = unitp->Load;
            BaseData1->InitializeUnitStatus(unitp,side,unitp->Type);
            if(life){
                unitp->Life = life;
                unitp->Fuel = fuel;
                unitp->Level = level;
                unitp->Load = load;
            }
        }
    }
    BaseData1->ApplyIDToAll(Map,SideStatus1);
    Map->InitVisible(1);
    Map->UpdateShade();
    if(Container != NULL)
        delete Container;
    Container = new MapContainer(Map->GetWidth(), Map->GetHeight());
    if(MapBackup != NULL)
        delete MapBackup;
    MapBackup=new MapData(Map->GetWidth(), Map->GetHeight());
    MapBackup->Initialize();

    // ̒MapSizeSet()Ă΂iForm1Resize邩jB
    if(System.DrawMode==MODE_DRAWGROUND)
        StartGroundEdit();
    else if(System.DrawMode==MODE_DRAWUNIT)
        StartUnitEdit();

    System.MapModified=false;
    Enabled_Undo(false);
    Image_Map->Enabled = true;
    Image_Pen->Visible = true;
    Enabled_Save(true);
    Enabled_SaveAs(true);
    Enabled_Property(true);
    Enabled_Edit(true);
    return 0;
}
//---------------------------------------------------------------------------
//}bṽTCYƃrbg}bṽTCY킹
__fastcall TForm1::MapSizeSet(void)
{
    if(RangeLayer != NULL)
        delete RangeLayer;
    RangeLayer = new TRangeLayer(Map->GetWidth(), Map->GetHeight());
    FieldScreen1->SetViewportSize(Map, Image_Map->Picture->Bitmap->Width, Image_Map->Picture->Bitmap->Height);
    SetViewportLeftTop(0, 0);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SetViewportLeftTop(int x, int y)
{
    FieldScreen1->SetViewportLeftTop(x, y);
    DrawAllAndUpdateMapView();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SlideViewport(int x, int y)
{
    FieldScreen1->SlideViewport(x, y);
    DrawAllAndUpdateMapView();
    return 0;
}
//---------------------------------------------------------------------------
//}bv̊Oɂ郆jbg폜iTCYύXj
__fastcall TForm1::CheckOutOfMap(void)
{
    int mw = Map->GetWidth();
    int mh = Map->GetHeight();
    for(int side=0; side<BaseData1->Sides; side++){
        for(int unum=0; unum<SideStatus1[side].UnitCount; unum++){
            UnitStatus& unit = SideStatus1[side].Unit[unum];
            if(unit.X >= mw || unit.Y >= mh){
                SideStatus1[side].DeleteUnit(Map, side, unum);
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//݂̃y̒n`^jbg\
__fastcall TForm1::PenStatusPut(void)
{
    if(System.Pen_Type == -1)
        return -1;
    switch(System.DrawMode){
    case MODE_DRAWGROUND:
        PenStatusPut_Ground(System.Pen_Side,System.Pen_Type);
        break;
    case MODE_DRAWUNIT:
        PenStatusPut_Unit(System.Pen_Side,System.Pen_Type);
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//݂̃y̒n`\B
__fastcall TForm1::PenStatusPut_Ground(int side,int type)
{
    MapStatus gnd;
    const MapChip gndInfo = BaseData1->GetMapChipByType(type);
    BaseData1->InitializeMapStatus(&gnd, side, type);
    FieldScreen1->DrawGroundStatusToTCanvas(Image_PenStatus->Canvas,Panel1->Brush->Color,0,0,gnd,&gndInfo);
    return 0;
}
//---------------------------------------------------------------------------
//݂̃ỹjbg\
__fastcall TForm1::PenStatusPut_Unit(int side,int type)
{
    UnitStatus unit;
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(type);

    BaseData1->InitializeUnitStatus(&unit,side,type);
    FieldScreen1->DrawUnitStatusToTCanvas(Image_PenStatus->Canvas,Panel1->Brush->Color,0,0,&unit,&unitInfo,true);
    return 0;
}
//---------------------------------------------------------------------------
//{^̏iCtrlL[̂j
__fastcall TForm1::PenLeftDown(int x,int y)
{
    int zx,zy;

    // `惂[h̎ɃyԍȂ牽ȂB
    if(System.DrawMode == MODE_DRAWGROUND &&
       System.DrawGroundMode <= DGMODE_BOXFILL &&
       System.Pen_Type < 0)
        return -1;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    switch(System.DrawMode){
    case MODE_DRAWGROUND:
        switch(System.DrawGroundMode){
        case DGMODE_PEN:
            MapBackup->Assign(*Map);
            MapChipWrite(zx,zy,System.Pen_Side,System.Pen_Type);
            Enabled_Undo(true);
            break;
        case DGMODE_BOXFILL:
        case DGMODE_BOXSELECT:
            if(!SelectedRect.AreaSelected()){
                // ÏȂ̎BIJnB
                SelectedRect.SelectAreaFirst(zx,zy,zx,zy);
                Container->CopyToBuffer(Map, SelectedRect);
                Container->ShowBufferOnInit(Map, RangeLayer, FieldScreen1);
                DrawAllAndUpdateMapView();
            }
            else{
                if(!System.SelectDecided){
                    // n_͑IĂ邪AI_I̎B
                    SelectedRect.SelectAreaSecond(zx,zy);
                    System.SelectDecided=true;
                    if(System.DrawGroundMode == DGMODE_BOXFILL){
                        // `hԂB
                        MapBackup->Assign(*Map);
                        FieldScreen1->ClearSpriteList();
                        WriteSelectedMapChip(System.Pen_Side,System.Pen_Type);
                        EndBoxSelect();
                        Enabled_Undo(true);
                    }
                    else{
                        // Ï̏I_肵̂ŁAn`obt@ɋLB
                        SelectedRect.Normalize();
                        Container->CopyToBuffer(Map,SelectedRect);
                        Container->ShowBufferOnInit(Map, RangeLayer, FieldScreen1);
                        MI_Copy->Enabled=true;
                    }
                }
                else{
                    if(System.DrawGroundMode == DGMODE_BOXSELECT){
                        if(RangeLayer->GetRangeValue(zx,zy)){
                            System.NowDragging=true;
                            DragRect.SelectAreaFirst(zx,zy,zx,zy);
                        }
                    }
                }
            }
            break;
        }
        break;
    case MODE_DRAWUNIT:
        if(Map->GetMapStatus(zx,zy).Side == -1){
            if(System.Pen_Type != -1){
                UnitWrite(zx,zy,System.Pen_Side,System.Pen_Type);
                Enabled_Undo(false);
            }
        }
        else{
            ShowUnitAttackRange(zx,zy);
        }
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
// CtrlL[Ȃ獶{^̏
__fastcall TForm1::ShowUnitPropertyDialog(int x,int y)
{
    UnitStatus *unit;
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    switch(System.DrawMode){
    case MODE_DRAWUNIT:
        const MapStatus& gnd = Map->GetMapStatus(zx, zy);
        if(gnd.Side != -1){
            unit = &SideStatus1[gnd.Side].Unit[gnd.UnitIndex];
            Form_UnitProperty->Left = Left + 64;
            Form_UnitProperty->Top = Top + 80;
            Form_UnitProperty->Edit_Life->Text = unit->Life;
            Form_UnitProperty->Edit_Fuel->Text = unit->Fuel;
            Form_UnitProperty->Edit_Level->Text = unit->Level;
            Form_UnitProperty->ShowModal();
            if(Form_UnitProperty->ModalResult == mrOk){
                unit->Life = Form_UnitProperty->Edit_Life->Text.ToIntDef(100);
                unit->Fuel = Form_UnitProperty->Edit_Fuel->Text.ToIntDef(0);
                unit->Level = Form_UnitProperty->Edit_Level->Text.ToIntDef(0);
            }
            System.ControlPushed = false;
            ChangeNavigateMessage(0,0);
        }
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
// ShiftL[Ȃ獶{^̏
__fastcall TForm1::SetLoadUnit(int x, int y)
{
    UnitStatus *unit;
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    switch(System.DrawMode){
    case MODE_DRAWUNIT:
        const MapStatus& gnd = Map->GetMapStatus(zx, zy);
        if(gnd.Side != -1){
            unit = &SideStatus1[gnd.Side].Unit[gnd.UnitIndex];
            const UnitChip& unitinfo = BaseData1->GetUnitChipByID(unit->ID);
            if(System.Pen_Type == -1){
                ShowMessage("ڂ郆jbgI΂Ă܂B");
                break;
            }
            if(System.Pen_Side != gnd.Side){
                ShowMessage("ڑƓڂ鑤̃jbg̏wcႢ܂B");
                break;
            }
            if(unit->Load >= unitinfo.Loadable){
                AnsiString str;
                str.sprintf("̃jbg̓ډ\%dłBȏ㓋ڂł܂B", unitinfo.Loadable);
                ShowMessage(str);
                break;
            }
            const UnitChip& unitinfo2 = BaseData1->GetUnitChipByType(System.Pen_Type);
            if(!unitinfo.LoadUnit[System.Pen_Type]){
                AnsiString str;
                str.sprintf("jbgu%svɃjbgu%sv͓ڂł܂B", unitinfo.Name, unitinfo2.Name);
                ShowMessage(str);
                break;
            }
            SideStatus1[System.Pen_Side].AddUnit(BaseData1, -1, 0, System.Pen_Side, System.Pen_Type);
            UnitStatus *newunit = &SideStatus1[System.Pen_Side].Unit[SideStatus1[System.Pen_Side].UnitCount - 1];
            newunit->Serial = 0;
            newunit->Actioned = false;
            BaseData1->InitializeUnitStatus(newunit, System.Pen_Side, System.Pen_Type);
            SideStatus1[System.Pen_Side].LoadUnit(gnd.UnitIndex, SideStatus1[System.Pen_Side].UnitCount - 1);
            DrawMapPartial(zx, zy, zx, zy);
            UpdateMapViewBlock(zx, zy, zx, zy);
        }
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//{^ŃhbȌ
__fastcall TForm1::PenLeftDrag(int x,int y)
{
    int zx,zy,dx,dy;
//    OperateRect WriteRect;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    switch(System.DrawMode){
    case MODE_DRAWGROUND:
        if(System.DrawGroundMode == DGMODE_PEN){
            MapChipWrite(zx,zy,System.Pen_Side,System.Pen_Type);
            break;
        }
        if(System.DrawGroundMode == DGMODE_BOXSELECT){
            if(DragRect.AreaSelected() && System.NowDragging){
                DragRect.SelectAreaSecond(zx,zy);
                DragRect.Difference(&dx,&dy);
                SelectedRect.Move(dx,dy);
                DragRect.Move(dx,dy);
                Container->ShowBuffer(Map, RangeLayer, SelectedRect.Left, SelectedRect.Top, FieldScreen1);
                DrawAllAndUpdateMapView();
            }
            break;
        }
        PenMove(x,y);
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//{^̏
__fastcall TForm1::PenLeftUp(int x,int y)
{
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    switch(System.DrawMode){
    case MODE_DRAWGROUND:
        if(System.NowDragging){
            Container->ShowBuffer(Map, RangeLayer, SelectedRect.Left, SelectedRect.Top, FieldScreen1);
            DrawAllAndUpdateMapView();
            System.NowDragging = false;
        }
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//E{^̏
__fastcall TForm1::PenRightDown(int x,int y)
{
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    switch(System.DrawMode){
    case MODE_DRAWGROUND:
        if(SelectedRect.AreaSelected()){
            if(DragRect.AreaSelected()){
                MapBackup->Assign(*Map);
                FieldScreen1->ClearSpriteList();
                Container->PasteFromBuffer(Map, RangeLayer, SelectedRect.Left, SelectedRect.Top, FieldScreen1, BaseData1);
                System.MapModified=true;
                DragRect.NoSelect();
                EndBoxSelect();
                Enabled_Undo(true);
            }
            else{
                FieldScreen1->ClearSpriteList();
                EndBoxSelect();
            }
        }else{
            const MapStatus& gnd = Map->GetMapStatus(zx, zy);
            System.Pen_Side = gnd.Owner;
            System.Pen_Type = gnd.Type;
            PenStatusPut();
        }
        break;
    case MODE_DRAWUNIT:
        UnitDelete(zx,zy);
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//{^}EXJ[\̏
__fastcall TForm1::PenMove(int x,int y)
{
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    MapChipStatusPut(x,y);
    if(SelectedRect.AreaSelected() && !System.SelectDecided){
        SelectedRect.SelectAreaSecond(zx,zy);
        Container->CopyToBuffer(Map,SelectedRect);
        Container->ShowBufferOnInit(Map, RangeLayer, FieldScreen1);
        DrawAllAndUpdateMapView();
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bv̂P}XύXit[nhpj
__fastcall TForm1::MapChipWrite(int zx,int zy,int owner,int type)
{
    if(type == -1)
        return -1;
    BaseData1->InitializeMapStatus(&Map->GetMapStatus(zx, zy), owner, type);
    DrawMapPartial(zx, zy, zx, zy);
    UpdateMapViewBlock(zx, zy);
    System.MapModified=true;
    return 0;
}
//---------------------------------------------------------------------------
//Iꂽ̈ύX
__fastcall TForm1::WriteSelectedMapChip(int owner,int type)
{
    TRect WriteRect;

    if(type < 0)
        return -1;
    SelectedRect.GetSelectedArea(&WriteRect);
    int mw = Map->GetWidth();
    int mh = Map->GetHeight();
    for(int y=0;y<mh;y++)
        for(int x=0;x<mw;x++)
            if(RangeLayer->GetRangeValue(x,y)){
                BaseData1->InitializeMapStatus(&Map->GetMapStatus(x, y), owner, type);
            }
    System.MapModified=true;
    return 0;
}
//---------------------------------------------------------------------------
//n`ҏWF`̈I
//Erase=trueȂʏ̘g
__fastcall TForm1::EndBoxSelect(void)
{
    if(SelectedRect.AreaSelected()){
        SelectedRect.NoSelect();
        System.SelectDecided = false;
        MI_Copy->Enabled=false;
        DrawAllAndUpdateMapView();
    }
    return 0;
}
//---------------------------------------------------------------------------
//˒͈͕\
__fastcall TForm1::ShowUnitAttackRange(int zx,int zy)
{
    const MapStatus& gnd = Map->GetMapStatus(zx, zy);

    int side = gnd.Side;
    int num  = gnd.UnitIndex;
    UnitStatus *unitp = &SideStatus1[side].Unit[num];
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unitp->Type);
    FieldScreen1->FindAttackRange(RangeLayer, BaseData1, unitp);
    FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stCursor, CURSOR_LOOKUP);
    FieldScreen1->CurrentRangeType = FieldScreen::rtAttackRange;
    int maxr = unitInfo.GetMaxRange();
    DrawMapPartial(zx-maxr, zy-maxr, zx+maxr, zy+maxr);
    UpdateMapViewBlock(zx-maxr, zy-maxr, zx+maxr, zy+maxr);
    System.ShowRange=true;
    ChangeNavigateMessage(0,0);
    return 0;
}
//---------------------------------------------------------------------------
//}bv̂P}XɃjbgu
__fastcall TForm1::UnitWrite(int zx,int zy,int side,int type)
{
    MapStatus& gnd = Map->GetMapStatus(zx, zy);

    if(SideStatus1[side].UnitCount >= UNITMAX){
        char msg[64];
        sprintf(msg,"%dłB",UNITMAX);
        ShowMessage(msg);
        return 0;
    }
    gnd.Side = side;
    gnd.UnitIndex = SideStatus1[side].UnitCount;
    UnitStatus *unitp = &SideStatus1[side].Unit[gnd.UnitIndex];
    SideStatus1[side].AddUnit(BaseData1,zx,zy,side,type);
    unitp->Serial = 0;
    unitp->Actioned = false;
    BaseData1->InitializeUnitStatus(unitp,side,type);
    DrawMapPartial(zx, zy, zx, zy);
    UpdateMapViewBlock(zx, zy, zx, zy);
    System.MapModified=true;
    return 0;
}
//---------------------------------------------------------------------------
//ujbg폜
__fastcall TForm1::UnitDelete(int zx,int zy)
{
    int side,num;
    MapStatus& gnd = Map->GetMapStatus(zx, zy);

    if(gnd.Side==-1)
        return 0;
    side = gnd.Side;
    num = gnd.UnitIndex;
    gnd.Side = -1;
    SideStatus1[side].DeleteUnit(Map, side, num);
    DrawMapPartial(zx, zy, zx, zy);
    UpdateMapViewBlock(zx, zy, zx, zy);
    return 0;
}
//---------------------------------------------------------------------------
//J[\n_̒n`\
__fastcall TForm1::MapChipStatusPut(int x,int y)
{
    char str[10];
    int zx,zy,side,num;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    const MapStatus& gnd = Map->GetMapStatus(zx, zy);
    const MapChip& gndInfo = BaseData1->GetMapChipByType(gnd.Type);
    // MapStatus::LifeMax ĂȂ̂łŏB
    // ]̃}bvGfB^ł͒n`LifelĂȂ̂
    // ̂܂܂ƒn`\p̋ʃ[`ُ퓮삷B
    //BaseData1 gndp->Initialize(gndp->Type);
    FieldScreen1->DrawGroundStatusToTCanvas(Image_GroundStatus->Canvas,Panel1->Brush->Color,0,0,gnd,&gndInfo);

    side = gnd.Side; //jbg\
    num = gnd.UnitIndex;
    if(side==-1){
        FillCanvas(Image_UnitStatus->Canvas, Panel1->Brush->Color);
        FillCanvas(Image_Loading->Canvas, Panel1->Brush->Color);
    }
    else{
        const UnitStatus& unit = SideStatus1[side].Unit[num];
        const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unit.Type);
        FieldScreen1->DrawUnitStatusToTCanvas(Image_UnitStatus->Canvas, Panel1->Brush->Color, 0, 0, &unit, &unitInfo, true);
        FieldScreen1->DrawLoadingStatus(Image_Loading->Canvas, Panel1->Brush->Color, unit, *BaseData1, SideStatus1, side, -1);
    }

    if(zx!=PanelX || zy!=PanelY){
        sprintf(str,"x:%2d",zx);
        StatusBar1->Panels->Items[MAPXPANEL]->Text=str;
        PanelX=zx;
        sprintf(str,"y:%2d",zy);
        StatusBar1->Panels->Items[MAPYPANEL]->Text=str;
        PanelY=zy;
        ChangeNavigateMessage(x,y);
    }
    return 0;
}
//---------------------------------------------------------------------------
//n`ҏW̊Jn
__fastcall TForm1::StartGroundEdit(void)
{
//    TImageList *im_ground = GBWImage1->ImageList_MapN;
    int graph;
    int gcount = BaseData1->GetGroundTypeCount()-1;

    Image_Pen->Picture->Bitmap->Width = (BaseData1->Sides+1)*GRAPHDEGREE_N;
    Image_Pen->Picture->Bitmap->Height = gcount*GRAPHDEGREE_N;
    FillCanvas(Image_Pen->Canvas,ScrollBox_Pen->Color);

    for(int i=0;i<gcount;i++){
        const MapChip& gndInfo = BaseData1->GetMapChipByType(i);
        if(gndInfo.IsBuilding){
            for(int side=0;side<BaseData1->Sides+1;side++){
                graph = BaseData1->GetGroundGraphic(side-1,i);
                FieldScreen1->DrawMapChipToTCanvas(Image_Pen->Canvas, side*GRAPHDEGREE_N, i*GRAPHDEGREE_N, graph, GRAPHDEGREE_N);
            }
        }
        else{
            graph = BaseData1->GetGroundGraphic(0,i);
            FieldScreen1->DrawMapChipToTCanvas(Image_Pen->Canvas, 0, i*GRAPHDEGREE_N, graph, GRAPHDEGREE_N);
        }
    }
    Image_Pen->Refresh();
    PenStatusPut();
    FillCanvas(Image_UnitStatus->Canvas, Panel1->Brush->Color);
    ChangeNavigateMessage(0,0);
    ScrollBox_Pen->Width = Image_Pen->Picture->Bitmap->Width +24;
    OnForm1Resize(NULL);

    return 0;
}
//---------------------------------------------------------------------------
//jbgzůJn
__fastcall TForm1::StartUnitEdit(void)
{
//    TImageList *im_unit = GBWImage1->ImageList_UnitN;
    int graph;
    int ucount = BaseData1->GetUnitTypeCount()-1;

    Image_Pen->Picture->Bitmap->Width = BaseData1->Sides*GRAPHDEGREE_N;
    Image_Pen->Picture->Bitmap->Height = ucount*GRAPHDEGREE_N;
    FillCanvas(Image_Pen->Canvas,ScrollBox_Pen->Color);
    for(int side=0;side<BaseData1->Sides;side++){
        for(int i=0;i<ucount;i++){
            graph = BaseData1->GetUnitGraphic(side,i);
            FieldScreen1->DrawUnitNormalToCanvas(Image_Pen->Canvas, side*GRAPHDEGREE_N, i*GRAPHDEGREE_N, graph, false, false);
        }
    }
    Image_Pen->Refresh();
    PenStatusPut();
    ChangeNavigateMessage(0,0);
    //}bv̍ɃjbgƃbZ[WႤɂȂ肠
    ScrollBox_Pen->Width = Image_Pen->Picture->Bitmap->Width +24;
    OnForm1Resize(NULL);

    return 0;
}
//---------------------------------------------------------------------------
//n`ҏWFy[h̊Jn
__fastcall TForm1::StartPenMode(void)
{
    EndBoxSelect();
    return 0;
}
//---------------------------------------------------------------------------
//n`ҏWF`hԂ[h̊Jn
__fastcall TForm1::StartBoxFillMode(void)
{
    EndBoxSelect();
    return 0;
}
//---------------------------------------------------------------------------
//n`ҏWF`I[h̊Jn
__fastcall TForm1::StartBoxSelectMode(void)
{
    EndBoxSelect();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::MapPropertyDialog(bool newMap)
{
    TForm_MapProperty *Dialogp = new TForm_MapProperty(this);

    Dialogp->Left = Left+32;
    Dialogp->Top = Top+32;
    Dialogp->UnitMax = Situation.UnitMax;
    Dialogp->SetDataPointer(BaseData1,FieldScreen1,Map,KSImageData,&Option,SideStatus1,newMap);

    Dialogp->ShowModal();
    if(Dialogp->ModalResult == mrOk){
        if(newMap){
            Map->Initialize();
        }
        Dialogp->GetControlContent();
        Situation.UnitMax = Dialogp->UnitMax;
//        MapSizeSet();
        CheckOutOfMap();
        // _CAOŃjbgt@CuQƁvŐݒ肵Ăꍇ͓xԂB
        GBW_LoadBaseAll(Map, KSImageData, BaseData1, &Option, false);
        KS_ResizeSideStatusArray(SideStatus1, BaseData1->Sides);
        InitializeMapEdit();
    }
    else{
        if(newMap){
            delete Map;
            Map = NULL;
        }
    }

    delete Dialogp;
    return 0;
}
//---------------------------------------------------------------------------
//irQ[gbZ[W̕\ύXB
//̓J[\̍WBMODE_DRAWUNITȊO͎gĂȂ
__fastcall TForm1::ChangeNavigateMessage(int x,int y)
{
    TStatusPanel *SP=StatusBar1->Panels->Items[NAVIGATEPANEL];
    int zx,zy;

    FieldScreen1->XY_PhyToMap(Map,x,y,&zx,&zy);
    switch(System.DrawMode){
    case MODE_DRAWGROUND:
        SP->Text=NAVIGATEGROUND;
        break;
    case MODE_DRAWUNIT:
        if(System.ShowRange){
            SP->Text=NAVIGATERANGENOW;
            break;
        }
        if(System.ControlPushed){
            SP->Text=NAVIGATEPROPERTY;
            break;
        }
        if(System.ShiftPushed){
            SP->Text=NAVIGATELOAD;
            break;
        }
        if(Map->GetMapStatus(zx, zy).Side!=-1){
            SP->Text=NAVIGATERANGE;
        }else{
            SP->Text=NAVIGATEUNIT;
        }
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//I[v̏
__fastcall TForm1::Enabled_Open(bool Value)
{
    MI_Open->Enabled=Value;
    SpeedButton_Open->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//Z[ȕ
__fastcall TForm1::Enabled_Save(bool Value)
{
    MI_Save->Enabled=Value;
    SpeedButton_Save->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//OtăZ[ȕ
__fastcall TForm1::Enabled_SaveAs(bool Value)
{
    MI_SaveAs->Enabled=Value;
    SpeedButton_SaveAs->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//vpeB̏
__fastcall TForm1::Enabled_Property(bool Value)
{
    MI_Property->Enabled=Value;
    SpeedButton_Property->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//AhD̏
__fastcall TForm1::Enabled_Undo(bool Value)
{
    MI_Undo->Enabled=Value;
    SpeedButton_Undo->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
// ԂҏW\ԂɈڍs邽߂̊֐B
__fastcall TForm1::Enabled_Edit(bool value)
{
    MI_Edit->Enabled = value;
    MI_Tool->Enabled = value;
    MI_Option->Enabled = value;
    SpeedButton_Property->Enabled   = value;
    SpeedButton_DrawGround->Enabled = value;
    SpeedButton_DrawUnit->Enabled   = value;
    SpeedButton_Pen->Enabled        = value;
    SpeedButton_BoxFill->Enabled    = value;
    SpeedButton_BoxSelect->Enabled  = value;
    SpeedButton_GraphNormal->Enabled = value;
    SpeedButton_GraphSmall->Enabled = value;
    return 0;
}
//---------------------------------------------------------------------------
//I
__fastcall OperateRect::NoSelect(void)
{
    Left   = -1;
    Right  = -1;
    return 0;
}
//---------------------------------------------------------------------------
//̈I
__fastcall OperateRect::SelectAreaFirst(int x1,int y1,int x2,int y2)
{
    Left   = x1;
    Top    = y1;
    Right  = x2;
    Bottom = y2;
    return 0;
}
//---------------------------------------------------------------------------
//̈IiQԖڂ̓_̍W߂j
__fastcall OperateRect::SelectAreaSecond(int x2,int y2)
{
    Right  = x2;
    Bottom = y2;
    return 0;
}
//---------------------------------------------------------------------------
//IĂ邩
__fastcall OperateRect::AreaSelected(void) const
{
    return (Left!=-1 && Right!=-1);
}
//---------------------------------------------------------------------------
//Ï̒`Ԃ
__fastcall OperateRect::GetSelectedArea(TRect *r) const
{
    OperateRect or;

    or=*this;
    or.Normalize();
    *r=or;
    return 0;
}
//---------------------------------------------------------------------------
//ォEւ̌`ɒ
__fastcall OperateRect::Normalize(void)
{
    int i;

    if(Left > Right){
        i=Right;
        Right=Left;
        Left=i;
    }
    if(Top > Bottom){
        i=Bottom;
        Bottom = Top;
        Top=i;
    }
    return 0;
}
//---------------------------------------------------------------------------
//̈`ςɂ炷iwNXpj
__fastcall OperateRect::Move(int x,int y)
{
    this->Left   += x;
    this->Top    += y;
    this->Right  += x;
    this->Bottom += y;
    return 0;
}
//---------------------------------------------------------------------------
//Pɕ߂Bil͐Ƃ͌Ȃj
__fastcall OperateRect::Difference(int *x,int *y) const
{
    *x = Right-Left;
    *y = Bottom-Top;
    return 0;
}
//---------------------------------------------------------------------------
//̐Βl
__fastcall OperateRect::Width(void) const
{
    return abs(Right-Left);
}
//---------------------------------------------------------------------------
//c̐Βl
__fastcall OperateRect::Height(void) const
{
    return abs(Bottom-Top);
}
//---------------------------------------------------------------------------
//es{kŏI镶ɂB
//͍̒lĂȂ̂Œ
__fastcall OperateRect::ToString(char *str) const
{
    sprintf(str,"%d,%d,%d,%d\r\n",Left,Top,Right,Bottom);
    return 0;
}
//---------------------------------------------------------------------------
//ToString̋tB
__fastcall OperateRect::FromString(char *str)
{
    if(sscanf(str,"%d,%d,%d,%d\r\n",&Left,&Top,&Right,&Bottom)==4)
        return 0;
    else
        return -1;
}
//---------------------------------------------------------------------------
//TRect^璼ڑ
OperateRect& OperateRect::operator=(TRect r)
{
    this->Left = r.Left;
    this->Top = r.Top;
    this->Right = r.Right;
    this->Bottom = r.Bottom;
    return (*this);
}
//---------------------------------------------------------------------------
//ZBQ̋`̋ʗ̈
OperateRect& OperateRect::operator&(OperateRect r1)
{
    OperateRect r2;

    r2 = *this; //gւ킯ɂ͍sȂ̂ŃRs[
    r1.Normalize();
    r2.Normalize();
    if(r1.Left < r2.Left)
        r1.Left = r2.Left;
    if(r1.Top < r2.Top)
        r1.Top = r2.Top;
    if(r1.Right > r2.Right)
        r1.Right = r2.Right;
    if(r1.Bottom > r2.Bottom)
        r1.Bottom = r2.Bottom;
    return (*this);
}
//---------------------------------------------------------------------------
//Ï̓eRs[
__fastcall MapContainer::CopyToBuffer(MapData *mapData, const OperateRect& selRect)
{
    ContainRect = selRect;
    ContainRect.Normalize();
    int left = min(selRect.Left, selRect.Right);
    int top = min(selRect.Top, selRect.Bottom);
    int w = selRect.Width();
    int h = selRect.Height();
    for(int y=0; y<=h; y++)
        for(int x=0; x<=w;x++){
//            const MapStatus& gnd = mapData->GetMapStatus(selRect.Left+x, selRect.Top+y);
            const MapStatus& gnd = mapData->GetMapStatus(left+x, top+y);
            GetBufferOwner(x, y) = gnd.Owner;
            GetBufferID(x, y) = gnd.ID;       // ꉞhcŋL^B
            GetBufferGraphic(x, y) = gnd.Graphic; // hbO̕\pB
//            ShowMessage(Buffer_Graphic[x][y]);
        }
    return 0;
}
//---------------------------------------------------------------------------
// i[ꂽ̈w肳ꂽWɃRs[B
// `Ȃ悤ɃRs[̓K؂ȍW߂B
// Draw=falseȂŸRangePoint^ɂ̂݁B
// ̏ꍇBaseDatã|C^^Kv͂ȂB
__fastcall MapContainer::PasteFromBuffer(MapData *mapData, TRangeLayer *layer, int ax, int ay,
    bool writeToMap, FieldScreen *Fieldp, const BaseData *baseData)
{
    int x,y,w,h,mx,my,ay2,dx;
    int p,q;

    Fieldp->ClearSpriteList();
    w = ContainRect.Width();
    h = ContainRect.Height();
    layer->InitRange();

    ay2 = ay%2;
    if(ay<0)
        ay2 = -ay2;
    dx = (ContainRect.Top%2 != ay2); //W̋̈v
    for(y=0; y<=h; y++){
        my = ay+y;
        if(my<0 || my>=mapData->GetHeight())
            continue;
        for(x=0; x<=w;x++){
            if(my%2)
                mx = ax+x+dx;
            else
                mx = ax+x;
            if(mx<0 || mx>=mapData->GetWidth())
                continue;
            if(writeToMap){
                MapStatus& gnd = mapData->GetMapStatus(mx, my);
                int type = baseData->GetGroundTypeIndex(GetBufferID(x, y));
                baseData->InitializeMapStatus(&gnd, GetBufferOwner(x,y), type);
            }else{
                Fieldp->AddSpriteZ(mx, my, TSpriteOnMap::stMapChipDark, GetBufferGraphic(x,y));
                layer->GetRangeValue(mx,my) = 1;
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// Ïobt@(ax,ay)ɏށB
__fastcall MapContainer::PasteFromBuffer(MapData *mapData, TRangeLayer *layer, int ax, int ay, FieldScreen *Fieldp, const BaseData *baseData)
{
    return PasteFromBuffer(mapData, layer, ax, ay, true, Fieldp, baseData);
}
//---------------------------------------------------------------------------
// Ï(ax,ay)ɕ\B
__fastcall MapContainer::ShowBuffer(MapData *mapData, TRangeLayer *layer, int ax, int ay, FieldScreen *Fieldp)
{
    return PasteFromBuffer(mapData, layer, ax, ay, false, Fieldp, NULL);
}
//---------------------------------------------------------------------------
// ÏAÏ̍Wɂ̂܂ܕ\B
__fastcall MapContainer::ShowBufferOnInit(MapData *mapData, TRangeLayer *layer, FieldScreen *Fieldp)
{
    return PasteFromBuffer(mapData, layer, ContainRect.Left, ContainRect.Top, false, Fieldp, NULL);
}
//---------------------------------------------------------------------------
//Nbv{[hɃRs[
__fastcall MapContainer::CopyToClipboard(void)
{
    TClipboard *Clip = new TClipboard();
    AnsiString Str;
    char s[64];
    int x,y;

    Str = CLIPBOARDHEAD;
    Str += "\r\n";
    ContainRect.ToString(s);
    Str += s;

    for(y=0;y<=ContainRect.Height();y++)
        for(x=0;x<=ContainRect.Width();x++){
            sprintf(s, "%d\r\n%d\r\n", GetBufferOwner(x,y), GetBufferID(x,y));
            Str += s;
        }

    Clip->SetTextBuf(Str.c_str());

    delete Clip;
    return 0;
}
//---------------------------------------------------------------------------
//Nbv{[hǂݍ
__fastcall MapContainer::PasteFromClipboard(void)
{
    TClipboard *Clip = new TClipboard();
    AnsiString Str;
    char s[50];
    int x,y,i;

    Str = Clip->AsText;
    i = Str.Pos("\n")-2;
    if(i == (sizeof CLIPBOARDHEAD)-1){
        strncpy(s,Str.c_str(),i);
        s[i]='\0';
        if(strcmp(s,CLIPBOARDHEAD))
            return -1;
    }
    else
        return -1;
    Str.Delete(1,Str.Pos("\n"));
    if(ContainRect.FromString(Str.c_str())==-1)
        ShowMessage("Nbv{[h̓ǂݍ݃G[");
    Str.Delete(1,Str.Pos("\n"));
    for(y=0;y<=ContainRect.Height();y++)
        for(x=0;x<=ContainRect.Width();x++){
            sscanf(Str.c_str(), "%d", &GetBufferOwner(x,y));
            Str.Delete(1,Str.Pos("\n"));
            sscanf(Str.c_str(), "%d", &GetBufferID(x,y));
            Str.Delete(1,Str.Pos("\n"));
        }
    delete Clip;
    return 0;
}
//---------------------------------------------------------------------------

