//---------------------------------------------------------------------------
#ifndef gbwedit1H
#define gbwedit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <stdlib.h>
#include "cgauges.h"
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include "gbwfield.h"
#include "ksunitprp.h"
#include <ComCtrls.hpp>

#define CLIPBOARDHEAD "KS-Map ClipBoard Format"
#define MAPXPANEL 0
#define MAPYPANEL 1
#define NAVIGATEPANEL 2
//#define RIGHTSPACE 400

#define MODE_DRAWGROUND 0
#define MODE_DRAWUNIT   1
#define DGMODE_PEN       0
#define DGMODE_BOXFILL   1
#define DGMODE_BOXSELECT 2

#define NAVIGATEGROUND "n`ҏWF}bv̒n`߂܂B"
#define NAVIGATEUNIT "jbgzuF}bvɃjbgzu܂B"
#define NAVIGATERANGE "jbgNbNƎ˒͈͂\܂B"
#define NAVIGATERANGENOW "˒͈͕\"
#define NAVIGATEPROPERTY "CtrlȂ烆jbgNbNƃvpeBJ܂B"
#define NAVIGATELOAD "ShiftȂ烆jbgNbNƓڃjbg܂B"

#define GRAPHFILE "gwgrp.bmp"
#define GRAPHFILE16 "gwgrp16.bmp"
#define NEWFILENAME "newfile.map"
#define UNITFILE "gbwunit.dat"

//---------------------------------------------------------------------------
class TSystemStatus
{
private:
public:
    bool LeftButton;
    bool RightButton;
    bool MapModified;
    bool ShowRange;
//    bool ShowVisible;
    bool SelectDecided;
    bool NowDragging;
    bool LButtonDownedOnViewport;
    bool ControlPushed;
    bool ShiftPushed;
    char EditFile[256];
    int DrawMode;       // n`ҏWjbgzu
    int DrawGroundMode; // n`ҏW̕`惂[h
    int Pen_Side;       // n`:Lwc  jbg:wc
    int Pen_Type;       // n`/jbg̓CfbNXBI-1
    TSystemStatus(void){
        LeftButton=RightButton=false;
        MapModified=false;
        ShowRange=false;
        SelectDecided=false;
        NowDragging=false;
        ControlPushed=false;
        ShiftPushed=false;
        strcpy(EditFile,NEWFILENAME);
        DrawMode = MODE_DRAWGROUND;
        DrawGroundMode = DGMODE_PEN;
        Pen_Side=0;
        Pen_Type=-1;
    }
};
//---------------------------------------------------------------------------
class OperateRect : public TRect
{
private:
public:
    OperateRect(void){
        NoSelect();
    }
    OperateRect(TRect r){
        *this = r;
    }
    __fastcall NoSelect(void);
    __fastcall SelectAreaFirst(int,int,int,int);
    __fastcall SelectAreaSecond(int,int);
    __fastcall AreaSelected(void) const;
    __fastcall GetSelectedArea(TRect *) const;
    __fastcall Normalize(void);
    __fastcall Move(int,int);
    __fastcall Difference(int *,int *) const;
    __fastcall Width(void) const;
    __fastcall Height(void) const;
    __fastcall ToString(char *) const;
    __fastcall FromString(char *);
    operator TRect(void){
         return Rect(Left,Top,Right,Bottom);
    }
    OperateRect& operator=(TRect);
    OperateRect& operator&(OperateRect);
    OperateRect& operator&=(OperateRect r){
         return (*this & r);
    }
};
//---------------------------------------------------------------------------
//}bvf[^̈ꕔi[B
class MapContainer
{
private:
    TValueLayer<int> Buffer_Owner;
    TValueLayer<int> Buffer_ID;
    TValueLayer<int> Buffer_Graphic;
public:
    OperateRect ContainRect; //Rs[̋`̈
    MapContainer(int w, int h) : Buffer_Owner(w,h), Buffer_ID(w,h), Buffer_Graphic(w,h) {
        ContainRect.NoSelect();
    }
    __fastcall CopyToBuffer(MapData *, const OperateRect&);
private:
    __fastcall PasteFromBuffer(MapData *, TRangeLayer *, int, int, bool, FieldScreen *, const BaseData *);
public:
    __fastcall PasteFromBuffer(MapData *, TRangeLayer *, int, int, FieldScreen *, const BaseData *);
    __fastcall ShowBuffer(MapData *, TRangeLayer *, int, int, FieldScreen *);
    __fastcall ShowBufferOnInit(MapData *, TRangeLayer *layer, FieldScreen *);
    __fastcall CopyToClipboard(void);
    __fastcall PasteFromClipboard(void);
    int& __fastcall GetBufferOwner(int w, int h){ return Buffer_Owner.GetValue(w, h); };
    __fastcall GetBufferOwner(int w, int h) const { return Buffer_Owner.GetValue(w, h); };
    int& __fastcall GetBufferID(int w, int h){ return Buffer_ID.GetValue(w, h); };
    __fastcall GetBufferID(int w, int h) const { return Buffer_ID.GetValue(w, h); };
    int& __fastcall GetBufferGraphic(int w, int h){ return Buffer_Graphic.GetValue(w, h); };
    __fastcall GetBufferGraphic(int w, int h) const { return Buffer_Graphic.GetValue(w, h); };
};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lgvoid __fastcall FormCreate(TObject *Sender);
    TMainMenu *MainMenu1;
    TMenuItem *MI_File;
    TMenuItem *MI_Exit;
    TMenuItem *MI_N_File_HistoryTop;
    TMenuItem *MI_SaveAs;
    TMenuItem *MI_Save;
    TMenuItem *MI_Open;
    TPanel *Panel1;
    TMenuItem *MI_Edit;
    TMenuItem *MI_Undo;
    TMenuItem *MI_Property;
    TOpenDialog *OpenDialog1;
    TSaveDialog *SaveDialog1;
    TMenuItem *MI_Help;
    TMenuItem *MI_Version;
    TPanel *Panel2;
    TSpeedButton *SpeedButton_Open;
    TSpeedButton *SpeedButton_Save;
    TSpeedButton *SpeedButton_SaveAs;
    TSpeedButton *SpeedButton_Property;
    TSpeedButton *SpeedButton_Undo;
    TPanel *Panel3;
    TSpeedButton *SpeedButton_GraphNormal;
    TSpeedButton *SpeedButton_GraphSmall;
    TMenuItem *MI_Option;
    TMenuItem *MI_GraphSmall;
    TMenuItem *MI_GraphNormal;
    TMenuItem *N2;
    TPanel *Panel4;
    TSpeedButton *SpeedButton_DrawGround;
    TSpeedButton *SpeedButton_DrawUnit;
    TStatusBar *StatusBar1;
    TMenuItem *MI_Tool;
    TMenuItem *MI_DrawGround;
    TMenuItem *MI_Edit_BoxSelect;
    TMenuItem *MI_Edit_BoxFill;
    TMenuItem *MI_Edit_Pen;
    TMenuItem *MI_DrawUnit;
    TMenuItem *MI_Copy;
    TMenuItem *MI_Paste;
    TPanel *Panel5;
    TSpeedButton *SpeedButton_Pen;
    TSpeedButton *SpeedButton_BoxFill;
    TSpeedButton *SpeedButton_BoxSelect;
    TImage *Image_UnitStatus;
    TImage *Image_GroundStatus;
    TImage *Image_PenStatus;
    TMenuItem *MI_New;
    TScrollBox *ScrollBox_Pen;
    TImage *Image_Pen;
    TMenuItem *MI_N_File_HistoryBottom;
    TImage *Image_Map;
    TTimer *Timer_InputRepeat;
    TImage *Image_Viewport;
    TImage *Image_Loading;
    void __fastcall OnForm1Paint(TObject *Sender);

    void __fastcall OnForm1Resize(TObject *Sender);

    void __fastcall OnForm1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall OnImage_MapMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall MI_OpenClick(TObject *Sender);
    void __fastcall MI_SaveClick(TObject *Sender);
    void __fastcall MI_SaveAsClick(TObject *Sender);
    void __fastcall OnImage_MapMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall OnImage_MapMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall MI_UndoClick(TObject *Sender);
    void __fastcall MI_PropertyClick(TObject *Sender);
    void __fastcall MI_ExitClick(TObject *Sender);
    void __fastcall OnForm1Close(TObject *Sender, TCloseAction &Action);
    void __fastcall MI_VersionClick(TObject *Sender);
    void __fastcall GraphNormalClick(TObject *Sender);
    void __fastcall GraphSmallClick(TObject *Sender);
    void __fastcall MenuGraphNormalClick(TObject *Sender);
    void __fastcall MenuGraphSmallClick(TObject *Sender);
    void __fastcall DrawGroundClick(TObject *Sender);
    void __fastcall MI_DrawUnitClick(TObject *Sender);

    void __fastcall MI_Edit_PenClick(TObject *Sender);
    void __fastcall MI_Edit_BoxFillClick(TObject *Sender);
    void __fastcall MI_Edit_BoxSelectClick(TObject *Sender);
    void __fastcall MI_CopyClick(TObject *Sender);
    void __fastcall MI_PasteClick(TObject *Sender);
    void __fastcall OnForm1Show(TObject *Sender);
    
    void __fastcall MI_NewClick(TObject *Sender);
    void __fastcall Image_PenMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Image_PenMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall MenuItem_HistoryClick(TObject *Sender);
        void __fastcall OnForm1MouseWheel(TObject *Sender,
          TShiftState Shift, int WheelDelta, TPoint &MousePos,
          bool &Handled);
    void __fastcall OnForm1CanResize(TObject *Sender, int &NewWidth,
          int &NewHeight, bool &Resize);
    void __fastcall OnForm1ConstrainedResize(TObject *Sender,
          int &MinWidth, int &MinHeight, int &MaxWidth, int &MaxHeight);
    void __fastcall Timer_InputRepeatTimer(TObject *Sender);
    void __fastcall Image_ViewportMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall Image_ViewportMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
    void __fastcall Image_ViewportMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall OnForm1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
private:	// [U[錾
    MapData *Map,*MapBackup;
    FieldScreen *FieldScreen1;
    TKSImageData *KSImageData;
    BaseData *BaseData1;
    TSideStatusArray SideStatus1;
    TSystemStatus System;
    TKSOption Option;
    GameSituation Situation;
    TRangeLayer *RangeLayer;
    OperateRect SelectedRect;
    OperateRect DragRect;
    MapContainer *Container;
    TForm_UnitProperty *Form_UnitProperty;
    bool SelectedRectDrawFlag;
    bool NowRunning;
    int PanelX,PanelY;
    __fastcall FileHistory_Add(const char *);
    __fastcall FileHistory_Update(void);
    __fastcall DrawAllAndUpdateMapView(void);
    __fastcall DrawAll(void);
    __fastcall DrawMapPartial(int zx1, int zy1, int zx2, int zy2);
    __fastcall ScreenPut(void);
    __fastcall UpdateMapViewAll(void);
    __fastcall UpdateMapView(int,int,int,int);
    __fastcall UpdateMapView(const TRect&);
    __fastcall UpdateMapViewBlock(int,int);
    __fastcall UpdateMapViewBlock(int zx1, int zy1, int zx2, int zy2);
    __fastcall SaveMap(const char *);
    __fastcall LoadMap(const char *);
    __fastcall SaveNameDialog(void);
    __fastcall ModifiedSaveDialog(void);
    __fastcall MapModifiedCheck(void);
    __fastcall InitializeMapEdit(void);
    __fastcall MapSizeSet(void);
    __fastcall SetViewportLeftTop(int x, int y);
    __fastcall SlideViewport(int x, int y);
    __fastcall CheckOutOfMap(void);
    __fastcall PenStatusPut(void);
    __fastcall PenStatusPut_Ground(int,int);
    __fastcall PenStatusPut_Unit(int,int);
    __fastcall PenLeftDown(int,int);
    __fastcall ShowUnitPropertyDialog(int x,int y);
    __fastcall SetLoadUnit(int x, int y);
    __fastcall PenLeftDrag(int,int);
    __fastcall PenLeftUp(int,int);
    __fastcall PenRightDown(int,int);
    __fastcall PenMove(int,int);
    __fastcall MapChipWrite(int,int,int,int);
    __fastcall WriteSelectedMapChip(int,int);
    __fastcall EndBoxSelect(void);
    __fastcall CopySelectedMapChip(bool);
    __fastcall ShowUnitAttackRange(int zx,int zy);
    __fastcall UnitWrite(int,int,int,int);
    __fastcall UnitDelete(int,int);
    __fastcall MapChipStatusPut(int,int);
    __fastcall StartGroundEdit(void);
    __fastcall StartUnitEdit(void);
    __fastcall StartPenMode(void);
    __fastcall StartBoxFillMode(void);
    __fastcall StartBoxSelectMode(void);
    __fastcall MapPropertyDialog(bool newMap);
    __fastcall ChangeNavigateMessage(int,int);
    __fastcall Enabled_Open(bool);
    __fastcall Enabled_Save(bool);
    __fastcall Enabled_SaveAs(bool);
    __fastcall Enabled_Property(bool);
    __fastcall Enabled_Undo(bool);
    __fastcall Enabled_Edit(bool);
public:		// [U[錾
    __fastcall TForm1(TComponent* Owner);
    __fastcall ~TForm1(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
