//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#pragma hdrstop

#include "gbwfield.h"
#include "ksfunc.h"
#include "kslua.h"
#include "ksdrawhdc.h"
#define IMGCTL_RUNTIME
#include "../common/imgctl/imgctl.h"
//---------------------------------------------------------------------------
//}bṽXe[^X
__fastcall MapData::Initialize(void)
{
    Name[0]='\0';
    UnitDataFile[0]='\0';
    ScriptFile[0] = '\0';
    BGImageFile[0] = '\0';
    BGImageOnGame = false;
    ZOCMode = Tekisaku = IgnoreLife = LevelUpEnabled = false;
    Protected = false;
    InitData();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall MapData::InitData(void)
{
    int mw = GetWidth();
    int mh = GetHeight();
//    Data.Init();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            MapStatus& gnd = GetMapStatus(x, y);
            gnd.Owner=-2;
            gnd.Side=-1;
            gnd.ID = -1;
            gnd.Type = -1;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// TCYB̃f[^ێăRs[B
void __fastcall MapData::Resize(int w, int h){
    int oldw = GetWidth();
    int oldh = GetHeight();
    TValueLayer<MapStatus> *backup = new TValueLayer<MapStatus>(Data);
    Data.Resize(w, h);
    InitData();
    for(int y=0;y<oldh;y++){
        for(int x=0;x<oldw;x++){
            Data.GetValue(x, y) = backup->GetValue(x, y);
        }
    }
    delete backup;
    Visible.Resize(w, h);
    Shade.Resize(w, h);
}
//---------------------------------------------------------------------------
//E̒lvalueŏB
//eLTN[hmFɒVisibleꍇ̂ŁA
//eLTN[hŖƂ͗ȊO̒lŖ߂ĂƁB
__fastcall MapData::InitVisible(int value)
{
    int i,*p = &Visible.GetValue(), sz = GetWidth()*GetHeight();

    for(i=0;i<sz;i++)
        *p++ = value;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall MapData::UpdateShade(void)
{
    //e
    //memset(&GetShade(0, 0), 0, Width*Height*sizeof(int));
    int mw = GetWidth();
    int mh = GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            GetShade(x,y) = !GetVisible(x,y);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bv̒n`TB߂l͂1,0.
__fastcall MapData::HasMapChip(int owner, int id) const
{
    int mw = GetWidth();
    int mh = GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            const MapStatus& gnd = GetMapStatus(x, y);
            if(gnd.Owner==owner && gnd.ID==id){
                return 1;
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bv̒n`TĈʒuplistɊi[B߂l͊i[B
__fastcall MapData::SearchChipByID(int owner, int id, POINT *plist, int len) const
{
    int count=0;

    int mw = GetWidth();
    int mh = GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            const MapStatus& gnd = GetMapStatus(x, y);
            if(gnd.Owner==owner && gnd.ID==id){
                if(count >= len){
                    return count;
                }
                POINT *p = plist+count;
                p->x = x;
                p->y = y;
                count++;
            }
        }
    }
    return count;
}
//---------------------------------------------------------------------------
// }bvɊ܂܂en`̑߂BtypeMax̓Xg̒B
// CfbNXtypeMaxȏ̒n`͖B
__fastcall MapData::CountGround(int count[],int typeMax) const
{
    memset(count,0,sizeof(int)*typeMax);
    int mw = GetWidth();
    int mh = GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            const MapStatus& gnd = GetMapStatus(x, y);
            if(gnd.Type < typeMax){
                count[gnd.Type]++;
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uɃQ[Z[up݂̏sB
__fastcall MapData::WriteText(TDataTable *table) const
{
    char ctg[50];
    int x,y;

    table->Put(KEY_MAPWIDTH, GetWidth());
    table->Put(KEY_MAPHEIGHT, GetHeight());
    table->Put(KEY_MAPNAME, Name.c_str());
    table->Put(KEY_UNITFILE, UnitDataFile);
    table->Put(KEY_SCRIPTFILE, ScriptFile);
    table->Put(KEY_BGIMAGEFILE, BGImageFile);
    table->Put(KEY_BGIMAGEONGAME, BGImageOnGame);
    table->Put(KEY_ZOCMODE, ZOCMode);
    table->Put(KEY_SAKUTEKI, Tekisaku);
    table->Put(KEY_IGNORELIFE, IgnoreLife);
    table->Put(KEY_LEVELUPENABLED, LevelUpEnabled);
    table->Put(KEY_PROTECTED, Protected);

    int mw = GetWidth();
    int mh = GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            const MapStatus& gnd = GetMapStatus(x, y);
            sprintf(ctg,"%s %d,%d",CTG_MAPSTATUS,x,y);
            table->SetCategory(ctg);
            table->Put(KEY_MS_ID, gnd.ID);
            // {݂ɂĂ͏LwcƑϋvxB
            if(gnd.Owner >= -1){
                table->Put(KEY_MS_OWNER, gnd.Owner);
                table->Put(KEY_MS_LIFE, gnd.Life);
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uQ[Z[up̓ǂݍ݂sB
__fastcall MapData::ReadText(TDataTable *table)
{
    char ctg[50], buf[257];

    Initialize();
    table->Get(KEY_MAPNAME, buf);
    Name = buf;
    table->Get(KEY_UNITFILE, UnitDataFile);
    table->Get(KEY_SCRIPTFILE, ScriptFile);
    table->Get(KEY_BGIMAGEFILE, BGImageFile);
    table->Get(KEY_BGIMAGEONGAME, &BGImageOnGame);
    table->Get(KEY_ZOCMODE, &ZOCMode);
    table->Get(KEY_SAKUTEKI, &Tekisaku);
    table->Get(KEY_IGNORELIFE, &IgnoreLife);
    table->Get(KEY_LEVELUPENABLED, &LevelUpEnabled);
    table->Get(KEY_PROTECTED, &Protected);

    int mw = GetWidth();
    int mh = GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            MapStatus& gnd = GetMapStatus(x, y);
            sprintf(ctg,"%s %d,%d",CTG_MAPSTATUS,x,y);
            table->GetCategory(ctg);
            table->Get(KEY_MS_ID, &gnd.ID);
            // Lwc̋LqΒʏn`B
            int owner;
            if(table->Get(KEY_MS_OWNER, &owner) != -1){
                gnd.Owner = owner;
                table->Get(KEY_MS_LIFE, &gnd.Life);
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbg{f[^̃ftHgl߂
__fastcall UnitChip::SetDefault(void)
{
    ANFType=Army;
    MoveMax=2;
    Value=0x7fffffff;
    for(int i=0;i<GUN_MAX;i++){
        MinRange[i]=2;
        MaxRange[i]=2;
        Radius[i]=1;
        GunMax[i]=0;
        GunValue[i]=1;
        GunName[i][0]='\0';
    }
    Loadable=0;
    FuelMax=1;
    FuelValue=2;
    FuelConsume=0;
/*    for(i=0;i<GROUNDMAX;i++){
        MoveLost[i]=1;
        GroundFlag[i]=GROUND_CAN_ALL;
    }
    memset(Attack,0,sizeof Attack);*/
    LevelUpAttackFunc = "";
    LevelUpDamageFunc = "";
    strcpy(Name,"o^");
    Occupy=0;
    OnlyTekisaku=false;
    SuperMissile=false;
    GraphicX.assign(GraphicX.size(), 0);
    GraphicY.assign(GraphicY.size(), 0);
//    memset(GraphicX, 0, sizeof GraphicX);
//    memset(GraphicY, 0, sizeof GraphicY);
//    memset(SupplyFlag_Neighbor,0,sizeof SupplyFlag_Neighbor);
//    memset(SupplyFlag_Loading,0,sizeof SupplyFlag_Loading);
//    memset(LoadUnit,0,sizeof LoadUnit);
    return 0;
}
//---------------------------------------------------------------------------
// ϒz̒ݒ肷B
__fastcall UnitChip::SetArraySize(int sideCount, int unitTypeCount, int groundTypeCount)
{
    for(int gun=0;gun<GUN_MAX;gun++){
        Attack[gun].resize(unitTypeCount);
    }
    LoadUnit.resize(unitTypeCount);
    LoadUnit.assign(0, unitTypeCount);
    SupplyFlag_Neighbor.resize(unitTypeCount);
    SupplyFlag_Neighbor.assign(unitTypeCount, 0);
    SupplyFlag_Loading.resize(unitTypeCount);
    SupplyFlag_Loading.assign(unitTypeCount, 0);
    MoveLost.resize(groundTypeCount);
    MoveLost.assign(groundTypeCount, 0);
    GroundFlag.resize(groundTypeCount);
    GroundFlag.assign(groundTypeCount, 0);
    GraphicX.resize(sideCount);
    GraphicX.assign(sideCount, 0);
    GraphicY.resize(sideCount);
    GraphicY.assign(sideCount, 0);
    Available.resize(sideCount);
    Available.assign(sideCount, 0);
    return 0;
}
//---------------------------------------------------------------------------
//KwNXUΊĂ邩B
__fastcall UnitChip::HasMegaHex(void) const
{
    if(SuperMissile)
        return 1;
    for(int i=0;i<GUN_MAX;i++)
        if(Radius[i] > 1)
            return 1;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall UnitChip::GetMaxRange(void) const
{
    if(SuperMissile){
        return Radius[0];
    }
    int range = 0;
    for(int i=0; i<GUN_MAX; ++i){
        if(GunMax[i]){
            if(MaxRange[i] > range){
                range = MaxRange[i];
            }
        }
    }
    return range;
}
//---------------------------------------------------------------------------
__fastcall BaseData::~BaseData(void){
    if(LuaState_LevelUp != NULL){
        KSLua_FreeLua(LuaState_LevelUp);
        LuaState_LevelUp = NULL;
    }
}
//---------------------------------------------------------------------------
// [hȂꍇ̃ftHgl߂B
// ܂ł̂ŁAǍŏɈx͌ĂяoKvB
__fastcall BaseData::SetDefault(void)
{
    //for(int i=0;i<UNITTYPEMAX;i++)
    //    UnitInfo[i].SetDefault();
    //strcpy(BitmapFile,FILE_DEFAULTBMP);
    //strcpy(SideName[0],UNION1NAME);
    //strcpy(SideName[1],UNION2NAME);
    //UnitTypeCount=0;
    //GroundTypeCount=0;
    Sides=0;
//    SideName[0] = UNION1NAME;
//    SideName[1] = UNION2NAME;
    DefinedGunMax = 2;  // ߋ̍őΊ퐔B
    strcpy(LevelUpScriptFile, FILE_DEFAULTLVUP);
    return 0;
}
//---------------------------------------------------------------------------
//jbgY\ǂ̔ijbgf[^j
__fastcall BaseData::CanCreateUnit(int side,int gndnum,int type,bool sakuteki) const
{
//    if(type >= UnitTypeCount)
//        return 0;
    const UnitChip *unitInfop = &UnitInfo[type];
    if(!sakuteki && unitInfop->OnlyTekisaku)
        return 0;
    if(!(unitInfop->GroundFlag[gndnum] & GROUND_CREATE))
        return 0;
    if(!unitInfop->Available[side])
        return 0;
    return 1;
}
//---------------------------------------------------------------------------
//̒n`ŐY\ȃjbg邩
__fastcall BaseData::CreatableExists(int side,int groundType,bool sakuteki)
{
    //jbgЂƂłY\Ȃ߂l͐^ƂȂ
    int tcount = UnitInfo.size();
    for(int i=0;i<tcount-1;i++)
        if(CanCreateUnit(side,groundType,i,sakuteki))
            return 1;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall BaseData::SetLuaStateLevelUp(lua_State *ls)
{
    if(LuaState_LevelUp != NULL){
        KSLua_FreeLua(LuaState_LevelUp);
    }
    LuaState_LevelUp = ls;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall BaseData::LoadFromCSV(const char *file)
{
    TCSVTable *table = new TCSVTable();
    int row,endrow,id;

    if(table->LoadFromFile(file) == -1)
        return -1;
    SetDefault();

    row = table->GetRowByName("摜t@C");
    if(row != -1){
        table->GetCellByXY(1,row,BitmapFile,sizeof BitmapFile);
    }
    // wc
    Sides = 0;
    row = table->GetRowByName("wc");
    if(row != -1){
        int col=1;
        for(;;){
            char name[256];
            if(table->GetCellByXY(col, row, name, sizeof name) == -1)
                break;
            if(name[0] == '\0')
                break;
            SideName.push_back(name);
            col++;
            Sides++;
        }
    }
//    if(Sides < 2)
//        Sides = 2;

    row = table->GetRowByName("jbg摜ʒu");
    if(row != -1){
        table->GetCellByXY(1,row,&UnitGraphicX);
        table->GetCellByXY(2,row,&UnitGraphicY);
    }

    row = table->GetRowByName("n`摜ʒu");
    if(row != -1){
        table->GetCellByXY(1,row,&GroundGraphicX);
        table->GetCellByXY(2,row,&GroundGraphicY);
    }

    row = table->GetRowByName("xAbvXNvg");
    if(row != -1){
        table->GetCellByXY(1, row, LevelUpScriptFile, sizeof LevelUpScriptFile);
    }

    // n`ƃjbǵA炩ߑSĂ̂hcǂݍ񂾌A
    // hc̏ɔzɓǂݍށB
    int gndKeyRow,unitKeyRow;
    vector<int> gndRows, unitRows;
    UnitID.clear();
    row = table->GetRowByName("jbg");
    if(row != -1){
        unitKeyRow = row;
        // jbg񂪏Ăsǂ܂łׂB
        endrow = CSV_GetEndOfNumberRow(table,row+1);
        // 炩ߑSĂ̂hcǂݍށB
        for(int i=row+1; i<=endrow; i++){
            table->GetCellByXY(0,i,&id);
            UnitID.push_back(id);
            unitRows.push_back(i);
        }
        // z̍ŌɃ_~[̃jbgB
        UnitID.push_back(0x7fffffff);
        UnitInfo.resize(UnitID.size());
        UnitChip *unitInfop = &UnitInfo[UnitID.size()-1];
        unitInfop->SetDefault();
        strcpy(unitInfop->Name, "`ID");
        // 񕪒T̂߃\[gB
        stable_sort(UnitID.begin(), UnitID.end());
    }

    GroundID.clear();
    row = table->GetRowByName("n`");
    if(row != -1){
        gndKeyRow = row;
        // n`񂪏Ăsǂ܂łׂB
        endrow = CSV_GetEndOfNumberRow(table,row+1);
        // 炩ߑSĂ̂hcǂݍށB
        for(int i=row+1; i<=endrow; i++){
            table->GetCellByXY(0,i,&id);
            GroundID.push_back(id);
            gndRows.push_back(i);
        }
        // z̍ŌɃ_~[̒n`B
        GroundID.push_back(0x7fffffff);
        GroundInfo.resize(GroundID.size());
        MapChip& gndInfo = GroundInfo[GroundID.size()-1];
        gndInfo.SetDefault();
        strcpy(gndInfo.Name, "`ID");
        // 񕪒T̂߃\[gB
        stable_sort(GroundID.begin(), GroundID.end());
    }

    // z񒷐ݒB
    for(vector<UnitChip>::iterator itr=UnitInfo.begin(); itr!=UnitInfo.end(); itr++){
        itr->SetArraySize(Sides, GetUnitTypeCount(), GetGroundTypeCount());
    }
    for(vector<MapChip>::iterator itr=GroundInfo.begin(); itr!=GroundInfo.end(); itr++){
        itr->GraphicX.resize(Sides+1);
        itr->GraphicY.resize(Sides+1);
    }

    // jbg̍sǂݍށB
    for(vector<int>::const_iterator itr=unitRows.begin(); itr<unitRows.end(); itr++){
        CSV_GetUnit(table, *itr, unitKeyRow);
    }

    // n`̍sǂݍށB
    for(vector<int>::const_iterator itr=gndRows.begin(); itr<gndRows.end(); itr++){
        CSV_GetGround(table, *itr, gndKeyRow);
    }
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
// jbgBSidesɐlĂKvB
__fastcall BaseData::CSV_GetUnit(TCSVTable *table,const int row,const int keyrow)
{
    const int cellsize=1024;
    char cell[cellsize];
    UnitChip *unitInfop;
    int i,id,num,col;

    if(table->GetCellByXY(0,row,&id) == -1)
        return -1;
    num = GetUnitTypeIndex(id);
    unitInfop = &UnitInfo[num];

    unitInfop->ID = id;
    unitInfop->SetDefault();
    table->GetCellByKeyRow(keyrow,"",row, unitInfop->Name, sizeof unitInfop->Name);

    col = table->GetCellColumnByName(keyrow,"");
    if(table->GetCellByXY(col,row,cell,cellsize) != -1){
        if(!strcmp(cell,"C")){
            unitInfop->ANFType = UnitChip::Navy;
        }else if(!strcmp(cell,"q")){
            unitInfop->ANFType = UnitChip::Force;
        }else{
            unitInfop->ANFType = UnitChip::Army;
        }
    }

    table->GetCellByKeyRow(keyrow,"i",  row, &unitInfop->Value);
    table->GetCellByKeyRow(keyrow,"ړ",row, &unitInfop->MoveMax);
    table->GetCellByKeyRow(keyrow,"E",  row, &unitInfop->Visibility);
    table->GetCellByKeyRow(keyrow,"R",  row, &unitInfop->FuelMax);
    table->GetCellByKeyRow(keyrow,"Ri",row, &unitInfop->FuelValue);
    table->GetCellByKeyRow(keyrow,"R",row, &unitInfop->FuelConsume);
    table->GetCellByKeyRow(keyrow,"ډ\",row, &unitInfop->Loadable);
    table->GetCellByKeyRow(keyrow,"̔\",row, &unitInfop->Occupy);
    // 񕜔\͂̋LqꍇA񕜔\͂͐̔\͂ƓlB
    if(table->GetCellByKeyRow(keyrow,"񕜔\",row, &unitInfop->Repair) == -1){
        unitInfop->Repair = unitInfop->Occupy;
    }

    table->GetCellByKeyRow(keyrow, "őLV", row, &unitInfop->LevelMax);
    if(table->GetCellByKeyRow(keyrow, "ULV␳", row, cell, cellsize) != -1){
        unitInfop->LevelUpAttackFunc = cell;
    }
    if(table->GetCellByKeyRow(keyrow, "hLV␳", row, cell, cellsize) != -1){
        unitInfop->LevelUpDamageFunc = cell;
    }

    col = table->GetCellColumnByName(keyrow,"Gp");
    unitInfop->OnlyTekisaku = CSV_GetBool(table,col,row);

    col = table->GetCellColumnByName(keyrow,"");
    unitInfop->SuperMissile = CSV_GetBool(table,col,row);

    if(table->GetCellByKeyRow(keyrow, "", row, cell, cellsize) != -1){
        unitInfop->GuidanceString = cell;
    }

    col = table->GetCellColumnByName(keyrow,"ډ\");
    if(col != -1){
        int num;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,&id) == -1)
                break;
            num = GetUnitTypeIndex(id);
            if(CSV_GetBool(table,col,row)){
                unitInfop->LoadUnit[num] = true;
            }
        }
    }

    // ⋋֌WBאڂƓڂő̓B
    col = table->GetCellColumnByName(keyrow,"אڕ⋋");
    if(col != -1){
        int num;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,&id) == -1)
                break;
            num = GetUnitTypeIndex(id);
            if(table->GetCellByXY(col,row,cell,cellsize) == -1)
                continue;
            unitInfop->SupplyFlag_Neighbor[num] = CSV_StringToSupplyFlag(cell);
        }
    }
    col = table->GetCellColumnByName(keyrow,"ڕ⋋");
    if(col != -1){
        int num;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,&id) == -1)
                break;
            num = GetUnitTypeIndex(id);
            if(table->GetCellByXY(col,row,cell,cellsize) == -1)
                continue;
            unitInfop->SupplyFlag_Loading[num] = CSV_StringToSupplyFlag(cell);
        }
    }
    // ȏA⋋֌W

    // Ί
    memset(unitInfop->GunMax, 0, sizeof unitInfop->GunMax);
    for(int gun=0;gun<GUN_MAX;gun++){
        CSV_GetGun(table,unitInfop,gun,row,keyrow);
        // DefinedGunMax̌ɉΊ킪ݒ肳ĂDefinedGunMax𑝂₷B
        for(int gm=DefinedGunMax; gm < GUN_MAX; ++gm){
            if(unitInfop->GunMax[gm]){
                DefinedGunMax = gm + 1;
            }
        }
    }

    // ړ
    col = table->GetCellColumnByName(keyrow,"ړ");
    if(col != -1){
        int gndnum;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
                break;
            if(sscanf(cell,"%d",&id) != 1)
                break;
            gndnum = GetGroundTypeIndex(id);
            if(gndnum == GetGroundTypeCount()-1)
                continue;
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d", &unitInfop->MoveLost[gndnum]);
        }
    }

    // n`̉\ȓ
    unitInfop->GroundFlag.assign(unitInfop->GroundFlag.size(), 0);
    col = table->GetCellColumnByName(keyrow,"\");
    if(col != -1){
        int gndnum;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
                break;
            if(sscanf(cell,"%d",&id) != 1)
                break;
            gndnum = GetGroundTypeIndex(id);
            table->GetCellByXY(col,row,cell,cellsize);
            unitInfop->GroundFlag[gndnum] = CSV_StringToGroundFlag(cell);
        }
    }

    // {݂Ƃ̊֌W
    col = table->GetCellColumnByName(keyrow,"{");
    if(col != -1){
        int gndnum;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
                break;
            if(sscanf(cell,"%d",&id) != 1)
                break;
            gndnum = GetGroundTypeIndex(id);
            table->GetCellByXY(col,row,cell,cellsize);
            if(strstr(cell,"") != NULL)
                unitInfop->GroundFlag[gndnum] |= GROUND_CREATE;
            if(strstr(cell,"") != NULL)
                unitInfop->GroundFlag[gndnum] |= GROUND_SUPPLY;
        }
    }

    // rbg}bṽOtBbNWǂݍށB
    char key[32];
    for(i=0;i<Sides;i++){
        sprintf(key,"%dwc",i);
        CSV_GetGraphicXY(table,keyrow,row,
                         &unitInfop->GraphicX[i], &unitInfop->GraphicY[i],key);

        col = table->GetCellColumnByName(keyrow,key);
        unitInfop->Available[i] = CSV_GetBool(table,col,row);
    }
    return 0;
}
//---------------------------------------------------------------------------
// 񂩂⋋tOǂݍŕԂB
__fastcall BaseData::CSV_StringToSupplyFlag(const char *str) const
{
    int flag=0;
    if(strstr(str,"R") != NULL)
        flag |= SUPPLY_FUEL;
    if(strstr(str,"e") != NULL)
        flag |= SUPPLY_GUN;
    if(strstr(str,"") != NULL)
        flag |= SUPPLY_LIFE;
    return flag;
}
//---------------------------------------------------------------------------
// 񂩂n`tOǂݍŕԂB
__fastcall BaseData::CSV_StringToGroundFlag(const char *str) const
{
    int flag=0;
    if(strstr(str,"") != NULL)
        flag |= GROUND_CAN_LOAD;
    if(strstr(str,"g") != NULL)
        flag |= GROUND_CAN_UNLOAD;
    if(strstr(str,"") != NULL)
        flag |= GROUND_CAN_RIDE;
    if(strstr(str,"~") != NULL)
        flag |= GROUND_CAN_ALIGHT;
    return flag;
}
//---------------------------------------------------------------------------
// ΊǂݍށBindex ͉ΊԍB
__fastcall BaseData::CSV_GetGun(TCSVTable *table,UnitChip *unitInfop,
    int index,int row,int keyrow)
{
    const int cellsize=256;
    char cell[cellsize];
    char key[16];
    int col,i,id;

    sprintf(key,"Ί%d",index+1);
    col = table->GetCellColumnByName(keyrow,key);
    if(col == -1){
        return -1;
    }
    table->GetCellByXY(col,row, unitInfop->GunName[index], sizeof unitInfop->GunName[index]);
    col++;
    for(;;col++){
        if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
            break;
        // U͂̋Lqn܂ĂΏIB
        if(sscanf(cell,"%d",&i) == 1)
            break;
        if(!strcmp(cell,"e")){
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d", &unitInfop->GunMax[index]);
        }else if(!strcmp(cell,"ei")){
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d", &unitInfop->GunValue[index]);
        }else if(!strcmp(cell,"˒")){
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d-%d", &unitInfop->MinRange[index], &unitInfop->MaxRange[index]);
        }else if(!strcmp(cell,"a")){
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d-%d", &i, &unitInfop->Radius[index]);
        }
    }
    // U͂̋LqǂݍށB
    int num;
    for(;;col++){
        if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
            break;
        if(sscanf(cell,"%d",&id) != 1)
            break;
        num = GetUnitTypeIndex(id);
        table->GetCellByXY(col,row,cell,cellsize);
        sscanf(cell,"%d", &unitInfop->Attack[index][num]);
    }
    return 0;
}
//---------------------------------------------------------------------------
// n`BSidesɐlĂKvB
__fastcall BaseData::CSV_GetGround(TCSVTable *table,const int row,const int keyrow)
{
    MapChip *gndInfop;
    int i,id,num,income,col;

    if(table->GetCellByXY(0,row,&id) == -1)
        return -1;
    num = GetGroundTypeIndex(id);
    if(static_cast<unsigned>(num) == GroundInfo.size()-1)
        return -1;

    gndInfop = &GroundInfo[num];
    gndInfop->ID = id;
    table->GetCellByKeyRow(keyrow,"",row, gndInfop->Name, sizeof gndInfop->Name);
    table->GetCellByKeyRow(keyrow,"n`",row, &gndInfop->Shield);
    // ̗ɐl̋LqΎ{݁AȂΒʏn`B
    if(table->GetCellByKeyRow(keyrow,"",row, &income) != -1){
        gndInfop->IsBuilding = true;
        gndInfop->Income = income;
        table->GetCellByKeyRow(keyrow,"ϋvx",row, &gndInfop->LifeMax);
        gndInfop->Visibility = 0;
        table->GetCellByKeyRow(keyrow,"E",row, &gndInfop->Visibility);
        //AnsiString str;
        //str.cat_sprintf("%s %d", gndInfop->Name, gndInfop->Visibility);ShowMessage(str);
        col = table->GetCellColumnByName(keyrow,"s@\");
        gndInfop->IsCapital = CSV_GetBool(table,col,row);
        col = table->GetCellColumnByName(keyrow,"ƗY");
        gndInfop->SelfCreatable = CSV_GetBool(table,col,row);
    }
    else{
        gndInfop->IsBuilding = false;
        gndInfop->IsCapital = false;
        gndInfop->SelfCreatable = false;
    }

    // rbg}bṽOtBbNWǂݍށB
    // CSV_GetUnit()ɎĂ邪ʏn`ƒ{݂̕KvB
    if(!gndInfop->IsBuilding){
        CSV_GetGraphicXY(table,keyrow,row,
                         &gndInfop->GraphicX[0], &gndInfop->GraphicY[0],"n`");
    }
    else{
        CSV_GetGraphicXY(table,keyrow,row,
                         &gndInfop->GraphicX[0], &gndInfop->GraphicY[0],"");
        // ewc̎{݁B
        char key[32];
        for(i=0;i<Sides;i++){
            sprintf(key,"%dwc",i);
            CSV_GetGraphicXY(table,keyrow,row,
                             &gndInfop->GraphicX[i+1], &gndInfop->GraphicY[i+1],key);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// n`/jbg̃OtBbNW`ǂݍށB
// keynameɂ͗Ⴆ"nwc"""B
__fastcall BaseData::CSV_GetGraphicXY(TCSVTable *table,int keyrow,int row,
    int *x,int *y,char *keyname)
{
    char key[32];
    int col;
    // X,YɂĂقƂǓB
    sprintf(key,"%sX",keyname);
    col = table->GetCellColumnByName(keyrow,key);
    if(col != -1){
        table->GetCellByXY(col,row,x);
    }

    sprintf(key,"%sY",keyname);
    col = table->GetCellColumnByName(keyrow,key);
    if(col != -1){
        table->GetCellByXY(col,row,y);
    }
    return 0;
}
//---------------------------------------------------------------------------
// ŏ̃ZɐĂsǂ܂őĂ邩ׁA
// Ō̍s̃CfbNXԂB
// X numbers ɂ̓ZɓĂ鐮̃Xgi[B
// X Xg̃TCYȂΎsƂĖ߂l -1
__fastcall BaseData::CSV_GetEndOfNumberRow(TCSVTable *table,int row)
{
    const int cellsize=64;
    char cell[cellsize];
    int endrow,i;

    for(endrow=row;;endrow++){
        if(table->GetCellByXY(0,endrow,cell,cellsize) == -1)
            break;
        if(sscanf(cell,"%d",&i) != 1)
            break;
    }
    return endrow-1;
}
//---------------------------------------------------------------------------
// ZɉĂ 1, Ȃ 0.
__fastcall BaseData::CSV_GetBool(TCSVTable *table,int col,int row)
{
    const int cellsize=64;
    char cell[cellsize];
    if(table->GetCellByXY(col,row,cell,cellsize) == -1)
        return 0;
    return (cell[0] != '\0');
}
//---------------------------------------------------------------------------
// ID烆jbg/n`̏zCfbNX𓾂B
// sꍇ̓_~[̃CX^X̃CfbNXԂB
__fastcall BaseData::GetUnitTypeIndex(int id) const
{
//    const int *itr = lower_bound(UnitID.begin(), UnitID.end(), id);
    vector<int>::const_iterator itr = lower_bound(UnitID.begin(), UnitID.end(), id);
    if(itr != UnitID.end() && *itr == id){
        return distance(UnitID.begin(), itr);
    }else{
        return UnitID.size() - 1;
    }
}
//---------------------------------------------------------------------------
const UnitChip& __fastcall BaseData::GetUnitChipByID(int id) const
{
    return UnitInfo[GetUnitTypeIndex(id)];
}
//---------------------------------------------------------------------------
__fastcall BaseData::GetGroundTypeIndex(int id) const
{
//    const int *itr = lower_bound(GroundID.begin(), GroundID.end(), id);
    vector<int>::const_iterator itr = lower_bound(GroundID.begin(), GroundID.end(), id);
    if(itr != GroundID.end() && *itr == id){
        return distance(GroundID.begin(), itr);
    }
    else{
        return GroundID.size() - 1;
    }
}
//---------------------------------------------------------------------------
const MapChip& __fastcall BaseData::GetMapChipByID(int id) const
{
    return GroundInfo[GetGroundTypeIndex(id)];
}
//---------------------------------------------------------------------------
// n`ƃjbg̃CX^XŜɂhc̔ԍ蓖ĂKpB
// ꂼɂ͊ɂhcĂ̂ƂB
__fastcall BaseData::ApplyIDToAll(MapData *mapData,TSideStatusArray& sideStatus) const
{
    int mw = mapData->GetWidth();
    int mh = mapData->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            MapStatus& gnd = mapData->GetMapStatus(x, y);
            gnd.Type = GetGroundTypeIndex(gnd.ID);
            gnd.Graphic = GetGroundGraphic(gnd.Owner, gnd.Type);
        }
    }

    for(int side=0;side<Sides;side++){
        for(int num=0;num<sideStatus[side].UnitCount;num++){
            UnitStatus *unitp = &sideStatus[side].Unit[num];
            unitp->Type = GetUnitTypeIndex(unitp->ID);
            unitp->Graphic = GetUnitGraphic(side, unitp->Type);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// OtBbNԍԂB
__fastcall BaseData::GetGroundGraphic(int side,int type) const
{
    const MapChip& gndInfo = GroundInfo[type];
    if(gndInfo.IsBuilding)
        side += 1;
    else
        side = 0;
    return gndInfo.GraphicY[side]*10 + gndInfo.GraphicX[side];
}
//---------------------------------------------------------------------------
__fastcall BaseData::GetUnitGraphic(int side,int type) const
{
    const UnitChip *unitInfop = &UnitInfo[type];
    return unitInfop->GraphicY[side]*10 + unitInfop->GraphicX[side];
}
//---------------------------------------------------------------------------
// jbg̑SẲΊ̎˒܂ލŒEő˒ԂB˒\pB
__fastcall BaseData::GetUnitGunRange(int type,int *minr,int *maxr)
{
    UnitChip *unitInfop = &UnitInfo[type];
    *minr = min(unitInfop->MinRange[0], unitInfop->MinRange[1]);
    *maxr = max(unitInfop->MaxRange[0], unitInfop->MaxRange[1]);
    return 0;
}
//---------------------------------------------------------------------------
// n`̏Ԃw肳ꂽn`ނŏB
__fastcall BaseData::InitializeMapStatus(MapStatus *gnd,int side,int type) const
{
    const MapChip& gndInfo = GroundInfo[type];

    gnd->Graphic = GetGroundGraphic(side, type);
    if(gndInfo.IsBuilding){
        gnd->Owner = side;
    }else{
        gnd->Owner = -2;
    }
    gnd->ID = gndInfo.ID;
    gnd->Type = type;
    gnd->Life = gndInfo.LifeMax;
    return 0;
}
//---------------------------------------------------------------------------
// jbg̏Ԃw肳ꂽނŏB
__fastcall BaseData::InitializeUnitStatus(UnitStatus *unit,int side,int type) const
{
    const UnitChip *unitInfop = &UnitInfo[type];

    unit->ID = unitInfop->ID;
    unit->Type = type;
    unit->Life = 100;
    unit->Load = 0;
    unit->Fuel = unitInfop->FuelMax;
    unit->Level = 0;
    unit->Experience = 0;
    for(int i=0;i<GUN_MAX;i++)
        unit->GunRest[i] = unitInfop->GunMax[i];
    unit->Graphic = GetUnitGraphic(side,type);
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uɃjbg̏ށB
//JeSw͌ĂяoōsB
__fastcall UnitStatus::WriteText(TDataTable *table) const
{
    table->PutTwoValues(KEY_US_XY, X,Y);
    table->Put(KEY_US_ID, ID);
    table->Put(KEY_US_SERIAL, Serial);
    table->Put(KEY_US_LIFE, Life);
    table->Put(KEY_US_FUEL, Fuel);
    table->Put(KEY_US_LEVEL, Level);
    table->Put(KEY_US_EXP, Experience);
    table->PutValues(KEY_US_LOAD, LoadingUnit, Load);
    table->PutValues(KEY_US_GUNREST, GunRest, GUN_MAX);
    table->Put(KEY_US_ACTIONED, (int)Actioned);
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[u烆jbg̏ǂݍށB
//JeSw͌ĂяoōsB
__fastcall UnitStatus::ReadText(TDataTable *table)
{
    table->GetTwoValues(KEY_US_XY, &X,&Y);
    table->Get(KEY_US_ID, &ID);
    table->Get(KEY_US_SERIAL, &Serial);
    table->Get(KEY_US_LIFE, &Life);
    table->Get(KEY_US_FUEL, &Fuel);
    table->Get(KEY_US_LEVEL, &Level);
    table->Get(KEY_US_EXP, &Experience);
    Load = table->GetValues(KEY_US_LOAD, LoadingUnit, LOAD_MAX);
    table->GetValues(KEY_US_GUNREST, GunRest, GUN_MAX);
    table->Get(KEY_US_ACTIONED, &Actioned);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall SideStatus::Initialize(void)
{
    UnitCount=0;
    Money=0;
    PhaseStartX=PhaseStartY=0;
    Friendly.assign(Friendly.size(), 0);
    UnitSerialMax = UNITSERIAL_GETA;
    ComScriptFile[0] = '\0';
    MailAddress[0] = '\0';
    Valid = false;
    Lost = false;
    LimitView = false;
    IsComputer = false;
    LuaState_Com = NULL;
    return 0;
}
//---------------------------------------------------------------------------
//tFCYIp
__fastcall SideStatus::EndClear(void)
{
    for(int i=0;i<UnitCount;i++)
        Unit[i].Actioned=false;
    return 0;
}
//---------------------------------------------------------------------------
//̌vZ
__fastcall SideStatus::CalcIncome(const MapData *mapData, const BaseData *baseData, int side)
{
    Income=0;
    int mw = mapData->GetWidth();
    int mh = mapData->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            const MapStatus& gnd = mapData->GetMapStatus(x,y);
            if(gnd.Owner == side){
                const MapChip& gndInfo = baseData->GetMapChipByType(gnd.Type);
                Income += gndInfo.Income;
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbg̒ǉ
__fastcall SideStatus::AddUnit(BaseData *BaseDatap,int zx,int zy,int side,int type)
{
    if(UnitCount>=UNITMAX)
        return -1;
    UnitStatus *unitp = &Unit[UnitCount];

    BaseDatap->InitializeUnitStatus(unitp,side,type);
    unitp->X = zx;
    unitp->Y = zy;
    unitp->Serial = ++UnitSerialMax;
    unitp->Actioned=true;
    UnitCount++;
    return 0;
}
//---------------------------------------------------------------------------
// VAɂ郆jbg̍폜
__fastcall SideStatus::DeleteUnitBySerial(MapData *mapData, int side, int serial)
{
    int num=-1;

    for(int i=0;i<UnitCount;i++){
        if(Unit[i].Serial == serial){
            num = i;
            break;
        }
    }
    if(num == -1)
        return -1;
    return DeleteUnit(mapData, side, num);
}
//---------------------------------------------------------------------------
//jbg̍폜
__fastcall SideStatus::DeleteUnit(MapData *Mapp,int side,int UnitNum)
{
    int DeleteList[UNITMAX],temp[UNITMAX],count;

    count=MakeDeleteList(UnitNum,DeleteList,0);
    stable_sort(DeleteList, DeleteList+count);
    memcpy(temp,DeleteList,sizeof(int)*count);
    for(int i=0;i<count;i++){
        DeleteList[i] = temp[count-1-i];
    }
    PressUnit(Mapp,DeleteList,count,side);
    return 0;
}
//---------------------------------------------------------------------------
//w肵jbgɓڂĂ郆jbgSăXgɏo
//߂l̓Xg̗vf
__fastcall SideStatus::MakeDeleteList(int UnitNum,int DeleteList[],int Count)
{
    int i;

    DeleteList[Count]=UnitNum; //w肳ꂽjbggXgɒǉ
    Count++;
    for(i=0;i<Unit[UnitNum].Load;i++) //ڂĂ΂ɂĂׂ
        Count=MakeDeleteList(Unit[UnitNum].LoadingUnit[i],DeleteList,Count);
    return Count;
}
//---------------------------------------------------------------------------
//폜ꂽjbg̐Ղl߂
__fastcall SideStatus::PressUnit(MapData *Mapp,int UnitNums[],int Units,int side)
{
    int i,j,k,x,y;

    for(i=0;i<Units;i++){
        for(j=UnitNums[i];j<UnitCount-1;j++) //l߂
            Unit[j]=Unit[j+1];
        for(y=0;y<Mapp->GetHeight();y++)    //}bṽjbgԍC
            for(x=0;x<Mapp->GetWidth();x++){
                MapStatus& gnd = Mapp->GetMapStatus(x,y);
                if(gnd.Side==side && gnd.UnitIndex>UnitNums[i])
                    gnd.UnitIndex--;
            }
        for(j=0;j<UnitCount;j++)
            for(k=0;k<Unit[j].Load;k++)
                if(Unit[j].LoadingUnit[k]>UnitNums[i])
                    Unit[j].LoadingUnit[k]--; //ڒ̃jbg̔ԍC
        UnitCount--;
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbgɃjbg𓋍
__fastcall SideStatus::LoadUnit(int Loader,int Loaded)
{
    if(Unit[Loader].Load+1 > LOAD_MAX)
        return -1;
    Unit[Loader].LoadingUnit[Unit[Loader].Load]=Loaded;
    Unit[Loader].Load++;
    return 0;
}
//---------------------------------------------------------------------------
//jbg̃Ct
__fastcall SideStatus::DisLife(int unitNum,int decrease)
{
    UnitStatus *unitp = &Unit[unitNum];
    int i,d;

    unitp->Life -= decrease;
    for(i=0;i<unitp->Load;i++)
        if(Unit[unitp->LoadingUnit[i]].Life > unitp->Life){
            d = Unit[unitp->LoadingUnit[i]].Life - unitp->Life;
            DisLife(unitp->LoadingUnit[i],d);
            //ڃjbg̓ڃjbg_[W󂯂
        }
    return 0;
}
//---------------------------------------------------------------------------
//s̃jbgTB͌Jn郆jbgԍB
//߂l͍ŏɌsjbg̔ԍBȂ-1
__fastcall SideStatus::SearchNoActioned(int UnitNum) const
{
    int i,j=-1;

    for(i=UnitNum;i<UnitCount;i++)
        if(!Unit[i].Actioned && Unit[i].X!=-1){
            j=i;
            break;
        }
    if(j==-1) //Ō܂ŒTČȂΐ擪ɖ߂ĒT
        for(i=0;i<UnitNum;i++)
            if(!Unit[i].Actioned && Unit[i].X!=-1){
                j=i;
                break;
            }

    return j;
}
//---------------------------------------------------------------------------
//VAtĂȂzujbgɃVAtB
__fastcall SideStatus::GenerateUnitSerial(void)
{
    for(int i=0;i<UnitCount;i++){
        UnitStatus *unitp = &Unit[i];
        if(unitp->Serial < UNITSERIAL_GETA){
            unitp->Serial = ++UnitSerialMax;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//VAw肵ăjbgԍ𓾂B
__fastcall SideStatus::GetUnitBySerial(int serial) const
{
    for(int i=0;i<UnitCount;i++){
        const UnitStatus *unitp = &Unit[i];
        if(unitp->Serial == serial){
            return i;
        }
    }
    return -1;
}
//---------------------------------------------------------------------------
//^ꂽe[uɐwcށBJeS͌ĂяoŎwB
__fastcall SideStatus::WriteText(TDataTable *table, int side)
{
    table->Put(KEY_SS_MONEY, Money);
    table->Put(KEY_SS_INCOME, Income);
    table->PutTwoValues(KEY_SS_ORIGINXY, PhaseStartX,PhaseStartY);
    table->Put(KEY_SS_VALID,     Valid);
    table->Put(KEY_SS_LOST,      Lost);
    table->PutValues(KEY_SS_FRIENDLY, Friendly);
    table->Put(KEY_SS_SERIALMAX, UnitSerialMax);
    table->Put(KEY_SS_LIMITVIEW, LimitView);
    table->Put(KEY_SS_ISCOMPUTER, IsComputer);
    table->Put(KEY_SS_COMSCRIPTFILE, ComScriptFile);
    table->Put(KEY_SS_MAIL, MailAddress);
    table->Put(KEY_SS_PLAYER, PlayerName);

    char ctg[50];
    for(int i=0;i<UnitCount;i++){
        sprintf(ctg,"%s%d-%d",CTG_UNITSTATUS,side,i);
        table->SetCategory(ctg);
        Unit[i].WriteText(table);
    }

    sprintf(ctg,"%s%d",CTG_CPUSCRIPTVAR,side);
    table->SetCategory(ctg);
	//hash_map<string,string>::iterator itr;
	for(TStringVariableMap::iterator itr=CPUScriptVariable_String.begin(); itr!=CPUScriptVariable_String.end(); itr++){
        string key = itr->first;
        string value = itr->second;
        table->Put(key.c_str(), value.c_str());
//        ShowMessage(key.c_str());
    }
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uwcǂݍށBJeS͌ĂяoŎwB
__fastcall SideStatus::ReadText(TDataTable *table, int side)
{
    char ctg[50];
    int i;

    Initialize();
    table->Get(KEY_SS_MONEY, &Money);
    table->Get(KEY_SS_INCOME, &Income);
    table->GetTwoValues(KEY_SS_ORIGINXY, &PhaseStartX,&PhaseStartY);
    table->Get(KEY_SS_VALID,     &Valid);
    table->Get(KEY_SS_LOST,      &Lost);
    table->GetValues(KEY_SS_FRIENDLY, Friendly);
    table->Get(KEY_SS_SERIALMAX, &UnitSerialMax);
    table->Get(KEY_SS_LIMITVIEW, &LimitView);
    table->Get(KEY_SS_ISCOMPUTER, &IsComputer);
    table->Get(KEY_SS_COMSCRIPTFILE, ComScriptFile);
    table->Get(KEY_SS_MAIL, MailAddress);
    table->Get(KEY_SS_PLAYER, PlayerName);

    UnitCount = 0;
    for(i=0;i<UNITMAX;i++){
        sprintf(ctg,"%s%d-%d",CTG_UNITSTATUS,side,i);
        if(table->GetCategory(ctg) == -1)
            break;
        Unit[i].ReadText(table);
        UnitCount++;
    }

    CPUScriptVariable_String.clear();
    // ̃JeS}bvǂ񂾎̂߂Ƀ`FbNB
    if(table->GetCategory(CTG_CPUSCRIPTVAR) == -1)
        return 0;
    char keystr[256],valstr[256];
    while(table->GetNext(keystr,valstr) != -1){
        string key=keystr;
        string val=valstr;
        CPUScriptVariable_String[key] = val;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall GameSituation::Initialize(void)
{
    Turn=0;
    Phase=0;
    UnitMax=UNITMAX;
    return 0;
}
//---------------------------------------------------------------------------
//Q[̏󋵂^ꂽe[uɏ
__fastcall GameSituation::WriteText(TDataTable *table)
{
    table->Put(KEY_PHASE, Phase);
    table->Put(KEY_TURN, Turn);
    table->Put(KEY_UNITMAX, UnitMax);

    table->SetCategory(CTG_EVENTSCRIPTVAR);
    //hash_map<string,string>::const_iterator i;
	for(TStringVariableMap::const_iterator i=EventScriptVariable.begin(); i!=EventScriptVariable.end(); i++){
        const string& key = i->first;
        const string& value = i->second;
        table->Put(key.c_str(), value.c_str());
    }
/*
    table->SetCategory(CTG_SCRIPTVARINT);
    map<string,int>::iterator i1;
    for(i1=ScriptVariable_Integer.begin(); i1!=ScriptVariable_Integer.end(); i1++){
        string key = i1->first;
        int value = i1->second;
        table->Put(key.c_str(), value);
//        ShowMessage(key.c_str());
    }
    table->SetCategory(CTG_SCRIPTVARSTR);
    map<string,string>::iterator i2;
    for(i2=ScriptVariable_String.begin(); i2!=ScriptVariable_String.end(); i2++){
        string key = i2->first;
        string value = i2->second;
        table->Put(key.c_str(), value.c_str());
//        ShowMessage(key.c_str());
    }*/
    return 0;
}
//---------------------------------------------------------------------------
//Q[̏󋵂^ꂽe[uǂݍ
__fastcall GameSituation::ReadText(TDataTable *table)
{
    char keystr[256],valstr[256];
    int value;

    table->Get(KEY_PHASE, &Phase);
    table->Get(KEY_TURN, &Turn);
    table->Get(KEY_UNITMAX, &UnitMax);

    EventScriptVariable.clear();
    // ̃JeS}bvǂ񂾎̂߂Ƀ`FbNB
    if(table->GetCategory(CTG_EVENTSCRIPTVAR) == -1)
        return 0;
    while(table->GetNext(keystr,valstr) != -1){
        string key(keystr);
        string val(valstr);
        EventScriptVariable[key] = val;
    }
/*
    ScriptVariable_Integer.clear();
    ScriptVariable_String.clear();
    // ̃JeS}bvǂ񂾎̂߂Ƀ`FbNB
    if(table->GetCategory(CTG_SCRIPTVARINT) == -1)
        return 0;
    while(table->GetNext(keystr,&value) != -1){
        string key=keystr;
        ScriptVariable_Integer[key] = value;
    }
    table->GetCategory(CTG_SCRIPTVARSTR);
    while(table->GetNext(keystr,valstr) != -1){
        string key=keystr;
        string val=valstr;
        ScriptVariable_String[key] = val;
    }
*/
    return 0;
}
//---------------------------------------------------------------------------
// Q̃TCYׂOtBbNidefault.bmpQƁjATABitmap ɏcycount荞ށB
__fastcall TABitmapChipSet::CopyGraphicSet(Graphics::TBitmap *srcbitmap, int srcx, int srcy, int ycount)
{
    // ʏ摜͂̂܂܃Rs[B
    TCanvas *canvas = srcbitmap->Canvas;
    int w_n = 10 * GRAPHDEGREE_N;
    int h_n = ycount * GRAPHDEGREE_N;
    ABitmapN->Width = w_n;
    ABitmapN->Height = h_n;
    ABitmapN->Canvas->CopyRect(TRect(0, 0, w_n, h_n), canvas, TRect(srcx, srcy, srcx+w_n, srcy+h_n));
    // k摜5`bvRs[B
    int w_s = 10 * GRAPHDEGREE_S;
    int h_s = ycount * GRAPHDEGREE_S;
    ABitmapS->Width = w_s;
    ABitmapS->Height = h_s;
    int dy=0,sy=0;
    for(int y=0;y<ycount;y++){
        ABitmapS->Canvas->CopyRect(TRect(0, dy, w_s/2, dy+GRAPHDEGREE_S), canvas, TRect(srcx+w_n, srcy+sy, srcx+w_n+w_s/2, srcy+sy+GRAPHDEGREE_S));
        sy += GRAPHDEGREE_S;
        ABitmapS->Canvas->CopyRect(TRect(w_s/2, dy, w_s, dy+GRAPHDEGREE_S), canvas, TRect(srcx+w_n, srcy+sy, srcx+w_n+w_s/2, srcy+sy+GRAPHDEGREE_S));
        sy += GRAPHDEGREE_S;
        dy += GRAPHDEGREE_S;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TABitmapChipSet::DrawChipToTBitmap(Graphics::TBitmap *bitmap, int x, int y, int index, int size, TColor maskColor)
{
    int gx = (index%10)*size;
    int gy = (index/10)*size;
    TABitmap *srcBitmap;
    if(size == GRAPHDEGREE_N){
        srcBitmap = ABitmapN;
    }else{
        srcBitmap = ABitmapS;
    }
    // NbsOBColorKey()̓NbsOsȂ߁B
    int x1=x, y1=y, x2=x+size, y2=y+size;
    if(x1 < ClipRect.Left){
        x1 = ClipRect.Left;
    }
    if(x2 > ClipRect.Right){
        x2 = ClipRect.Right;
    }
    if(y1 < ClipRect.Top){
        y1 = ClipRect.Top;
    }
    if(y2 > ClipRect.Bottom){
        y2 = ClipRect.Bottom;
    }
    if(x1 >= x2 || y1 >= y2)
        return 0;
    if(maskColor & 0xff000000){
        bitmap->Canvas->CopyRect(TRect(x1, y1, x2, y2), srcBitmap->Canvas,
                TRect(gx, gy, gx+size, gy+size));
    }
    else{
        srcBitmap->ColorKey(x1, y1, x2-x1, y2-y1, gx, gy, bitmap, maskColor);
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TABitmapChipSet::DrawChipToTCanvas(TCanvas *canvas,int x,int y,int index,int size)
{
    int gx = (index%10)*size;
    int gy = (index/10)*size;
    TABitmap *srcBitmap;
    if(size == GRAPHDEGREE_N){
        srcBitmap = ABitmapN;
    }else{
        srcBitmap = ABitmapS;
    }
    canvas->CopyRect(TRect(x, y, x+size, y+size), srcBitmap->Canvas,
            TRect(gx, gy, gx+size, gy+size));
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TKSImageData::InitInstance(void)
{
    ImageList_FigureN=new TImageList(NULL);
    ImageList_FigureN->AllocBy=FIGURECOUNT*FIGURECOLORMAX;
    ImageList_FigureN->Width=GRAPHDEGREE_N/2;
    ImageList_FigureN->Height=GRAPHDEGREE_N;
    ImageList_FigureN->Masked=true;
    ImageList_FigureS=new TImageList(NULL);
    ImageList_FigureS->AllocBy=FIGURECOUNT*FIGURECOLORMAX;
    ImageList_FigureS->Width=GRAPHDEGREE_S/2;
    ImageList_FigureS->Height=GRAPHDEGREE_S;
    ImageList_FigureS->Masked=true;

    Bitmap_MapD = new TABitmap();
    Bitmap_BGImageN = new TABitmap();
    Bitmap_BGImageS = new TABitmap();
    ChipSetMap = new TABitmapChipSet();
    ChipSetUnit = new TABitmapChipSet();
    ChipSetCursor = new TABitmapChipSet();
    ChipSetCrash = new TABitmapChipSet();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TKSImageData::DeleteInstance(void)
{
    delete ImageList_FigureN;
    delete ImageList_FigureS;
    delete Bitmap_MapD;
    delete Bitmap_BGImageN;
    delete Bitmap_BGImageS;
    delete ChipSetMap;
    delete ChipSetUnit;
    delete ChipSetCursor;
    delete ChipSetCrash;
    return 0;
}
//---------------------------------------------------------------------------
// VXeŗL̃OtBbNǂݍށB
// ʏAvONɈ񂾂s΂悢B
__fastcall TKSImageData::LoadSystemGraphic(const char *file)
{
    Graphics::TBitmap *srcbmp = new Graphics::TBitmap();
    Graphics::TBitmap *bitmapN = new Graphics::TBitmap(),
                      *bitmapS = new Graphics::TBitmap();
    const TColor MaskColor=(TColor)0x00808000;
    int nw,nh,sw,sh,nx,sx,ny,sy;

    bitmapN->Palette = srcbmp->Palette;
    bitmapN->Width  = nw = GRAPHDEGREE_N/2;
    bitmapN->Height = nh = GRAPHDEGREE_N;
    bitmapS->Palette = srcbmp->Palette;
    bitmapS->Width  = sw = GRAPHDEGREE_S/2;
    bitmapS->Height = sh = GRAPHDEGREE_S;

    srcbmp->LoadFromFile(file);
    // J[\摜̓ǂݍ݁B
    ChipSetCursor->CopyGraphicSet(srcbmp, 0, 0, 2);

    // ŁEvEė摜̓ǂݍ݁B
    ChipSetCrash->CopyGraphicSet(srcbmp, 0, 160, 3);

    // 摜̓ǂݍ݁B
    ny = sy = nh*2;
    for(int i=0;i<FIGURECOLORMAX;i++){
        nx = 0;
        sx = nw*20;
        for(int j=0;j<FIGURECOUNT;j++){
            bitmapN->Canvas->CopyRect(Rect(0,0,nw,nh),srcbmp->Canvas,Rect(nx,ny,nx+nw,ny+nh));
            ImageList_FigureN->AddMasked(bitmapN,MaskColor);
            bitmapS->Canvas->CopyRect(Rect(0,0,sw,sh),srcbmp->Canvas,Rect(sx,sy,sx+sw,sy+sh));
            ImageList_FigureS->AddMasked(bitmapS,MaskColor);
            nx += nw;
            if(j!=9){
                sx += sw;
            }else{
                sx = nw*20;
                sy += sh;
            }
        }
        ny += nh;
        sy += sh;
    }
    delete srcbmp;
    delete bitmapN;
    delete bitmapS;
    return 0;
}
//---------------------------------------------------------------------------
// rbg}bvt@Cn`EjbgOtBbN荞ށB
__fastcall TKSImageData::LoadFromFile(const char *file, int ground_srcx, int ground_srcy, int ground_ycount,
    int unit_srcx,int unit_srcy,int unit_ycount)
{
    Graphics::TBitmap *baseBitmap = new Graphics::TBitmap();

    if(access(file,0) == -1)
        return -1;
    KS_LoadFromImgctl(baseBitmap,file);

    ChipSetMap->CopyGraphicSet(baseBitmap, ground_srcx, ground_srcy, ground_ycount);
    ChipSetUnit->CopyGraphicSet(baseBitmap, unit_srcx, unit_srcy, unit_ycount);
    // Ƃ肠B
    Bitmap_MapD->Width = 10;
    Bitmap_MapD->Height = ground_ycount;
    for(int gnum=0;gnum<ground_ycount*10;gnum++){
        // ȕɏkăhbgɂB
        int srcx = ground_srcx + GRAPHDEGREE_N*10 + GRAPHDEGREE_S * (gnum%5);
        int srcy = ground_srcy + GRAPHDEGREE_S * (gnum/5);
        TRect srcr(srcx, srcy, srcx+GRAPHDEGREE_S, srcy+GRAPHDEGREE_S);
        TRect dstr(gnum%10, gnum/10, gnum%10 + 1, gnum/10 + 1);
        Bitmap_MapD->Canvas->CopyRect(dstr, baseBitmap->Canvas, srcr);
    }
    delete baseBitmap;
    return 0;
}
//---------------------------------------------------------------------------
// XN[o[̈ʒuƃTCYݒ肷B
__fastcall TSimpleScrollBar::SetSize(int left, int top, int fulllen, int vplen, int outlen, int outw, int minuslen, int pluslen)
{
    Left = left;
    Top = top;
    ScrollTargetLength = fulllen;
    ViewportLength = vplen;
    OuterLength = outlen;
    OuterWidth = outw;
    MinusButtonLength = minuslen;
    PlusButtonLength = pluslen;
    InnerLength = OuterLength - MinusButtonLength - PlusButtonLength;
    SliderLength = GetSliderLength(ScrollTargetLength, ViewportLength);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TSimpleScrollBar::InitStatus(void)
{
    SliderMouseDownedPosition = -1;
    LargeChangeMouseDownedPosition = -1;
    MinusButtonDowned = false;
    PlusButtonDowned = false;
    return 0;
}
//---------------------------------------------------------------------------
// XC_̒߂B
__fastcall TSimpleScrollBar::GetSliderLength(int fulllen, int vplen) const
{
    int sliderlen = InnerLength * vplen / fulllen;
    if(sliderlen < 16){
        sliderlen = 16;
    }
    // FieldScreen::DrawScrollBar()ƓB
    // XC_ZāiPhbgHj[/[ɓ͂ȂꍇAmɓ͂悤ɒB
    int sliderpos = InnerLength * (fulllen - vplen) / fulllen;
    if(InnerLength > sliderpos + sliderlen){
        sliderlen = InnerLength - sliderpos;
    }
    return sliderlen;
}
//---------------------------------------------------------------------------
// XC_̈ʒuB
__fastcall TSimpleScrollBar::GetSliderPosition(int targetPosition) const
{
    return InnerLength * targetPosition / ScrollTargetLength;
}
//---------------------------------------------------------------------------
// S̈̑傫ƁA\̈̑傫ݒ肷B
__fastcall TViewport::SetSize(int fullw, int fullh, int vpw, int vph)
{
    int vw = vpw, vh = vph;
    const int scrollBarWidth = 16;

    int RightScrollBarX = -1;
    int BottomScrollBarY = -1;
    RightScrollBar.Visible = false;
    BottomScrollBar.Visible = false;
    if(vw > scrollBarWidth && vh > scrollBarWidth){
        if(fullh > vh){
            RightScrollBarX = vw = min(fullw, vw - scrollBarWidth);
            RightScrollBar.Visible = true;
        }
        if(fullw > vw){
            BottomScrollBarY = vh = min(fullh, vh - scrollBarWidth);
            BottomScrollBar.Visible = true;
            if(RightScrollBarX == -1 && fullh > vh){
                RightScrollBarX = min(fullw, vw - scrollBarWidth);
                RightScrollBar.Visible = true;
            }
        }
    }

    InnerSize.cx = min(fullw, vw);
    InnerSize.cy = min(fullh, vh);
    OuterSize.cx = InnerSize.cx + (RightScrollBarX != -1)*scrollBarWidth;
    OuterSize.cy = InnerSize.cy + (BottomScrollBarY != -1)*scrollBarWidth;
    FullSize.cx = fullw;
    FullSize.cy = fullh;
    RightScrollBar.InitStatus();
    BottomScrollBar.InitStatus();
    if(RightScrollBar.Visible){
        RightScrollBar.SetSize(RightScrollBarX, 0, FullSize.cy, InnerSize.cy, InnerSize.cy, scrollBarWidth, 16, 16);
//        RightScrollBar.SliderMouseDownedPosition = -1;
//        RightScrollBar.LargeChangeMouseDownedPosition = -1;
//        RightScrollBar.MinusButtonDowned = false;
//        RightScrollBar.PlusButtonDowned = false;
    }
    if(BottomScrollBar.Visible){
        BottomScrollBar.SetSize(0, BottomScrollBarY, FullSize.cx, InnerSize.cx, InnerSize.cx, scrollBarWidth, 16, 16);
//        BottomScrollBar.SliderMouseDownedPosition = -1;
//        BottomScrollBar.LargeChangeMouseDownedPosition = -1;
//        BottomScrollBar.MinusButtonDowned = false;
//        BottomScrollBar.PlusButtonDowned = false;
    }
    Valid = true;
//    char str[256];
//    sprintf(str, "%d,%d %d,%d %d,%d %d,%d", w,h,vw,vh, Viewport.InnerSize.cx, Viewport.InnerSize.cy, Viewport.OuterSize.cx, Viewport.OuterSize.cy);
//    ShowMessage(str);
    return 0;
}
//---------------------------------------------------------------------------
// r[|[g̍WݒB
__fastcall TViewport::SetLeftTop(int x, int y)
{
    // ㉺EB
    if(InnerSize.cx < FullSize.cx){
        if(x < 0){
            x = 0;
        }else if(x + InnerSize.cx > FullSize.cx){
            x = FullSize.cx - InnerSize.cx;
        }
    }else{
        x = 0;
    }
    if(InnerSize.cy < FullSize.cy){
        if(y < 0){
            y = 0;
        }else if(y + InnerSize.cy > FullSize.cy){
            y = FullSize.cy - InnerSize.cy;
        }
    }else{
        y = 0;
    }

    LeftTop.x = x;
    LeftTop.y = y;
    return 0;
}
//---------------------------------------------------------------------------
// }EX_ECxgʒm֐B
__fastcall TViewport::NoticeMouseDown(int x, int y)
{
    if(RightScrollBar.Visible){
        RightScrollBar.SliderMouseDownedPosition = -1;
        RightScrollBar.LargeChangeMouseDownedPosition = -1;
        if(RightScrollBar.Left <= x && x < RightScrollBar.Left + RightScrollBar.OuterWidth){
            // EXN[o[B
            if(RightScrollBar.Top <= y && y < RightScrollBar.Top + RightScrollBar.MinusButtonLength){
                // {^B
                SetLeftTop(LeftTop.x, LeftTop.y - ButtonScrollUnit);
                RightScrollBar.MinusButtonDowned = true;
                TimerCount = 0;
                return 1;
            }
            if(RightScrollBar.Top + RightScrollBar.MinusButtonLength + RightScrollBar.InnerLength <= y &&
               y < RightScrollBar.Top + RightScrollBar.MinusButtonLength + RightScrollBar.InnerLength + RightScrollBar.PlusButtonLength){
                // {^B
                SetLeftTop(LeftTop.x, LeftTop.y + ButtonScrollUnit);
                RightScrollBar.PlusButtonDowned = true;
                TimerCount = 0;
                return 1;
            }
            int slidery = RightScrollBar.GetSliderPosition(LeftTop.y);
            if(RightScrollBar.Top + RightScrollBar.MinusButtonLength <= y &&
               y < RightScrollBar.Top + RightScrollBar.MinusButtonLength + slidery){
                // {^ƃXC_̊ԁB
                SetLeftTop(LeftTop.x, LeftTop.y - InnerSize.cy / 2);
                RightScrollBar.LargeChangeMouseDownedPosition = y - RightScrollBar.MinusButtonLength;
                TimerCount = 0;
                return 1;
            }
            if(RightScrollBar.Top + RightScrollBar.MinusButtonLength + slidery + RightScrollBar.SliderLength <= y &&
               y < RightScrollBar.Top + RightScrollBar.MinusButtonLength + RightScrollBar.InnerLength){
                // {^ƃXC_̊ԁB
                SetLeftTop(LeftTop.x, LeftTop.y + InnerSize.cy / 2);
                RightScrollBar.LargeChangeMouseDownedPosition = y - RightScrollBar.MinusButtonLength;
                TimerCount = 0;
                return 1;
            }
            if(RightScrollBar.Top + RightScrollBar.MinusButtonLength + slidery <= y &&
               y < RightScrollBar.Top + RightScrollBar.MinusButtonLength + slidery + RightScrollBar.SliderLength){
                // XC_͂񂾁B
                RightScrollBar.SliderMouseDownedPosition = y - slidery;
                return 1;
            }
        }
    }

    if(BottomScrollBar.Visible){
        BottomScrollBar.SliderMouseDownedPosition = -1;
        BottomScrollBar.LargeChangeMouseDownedPosition = -1;
        if(BottomScrollBar.Top <= y && y < BottomScrollBar.Top + BottomScrollBar.OuterWidth){
            // XN[o[B
            if(BottomScrollBar.Left <= x && x < BottomScrollBar.Left + BottomScrollBar.MinusButtonLength){
                // {^B
                SetLeftTop(LeftTop.x - ButtonScrollUnit, LeftTop.y);
                BottomScrollBar.MinusButtonDowned = true;
                TimerCount = 0;
                return 1;
            }
            if(BottomScrollBar.Left + BottomScrollBar.MinusButtonLength + BottomScrollBar.InnerLength <= x &&
               x < BottomScrollBar.Left + BottomScrollBar.MinusButtonLength + BottomScrollBar.InnerLength + BottomScrollBar.PlusButtonLength){
                // E{^B
                SetLeftTop(LeftTop.x + ButtonScrollUnit, LeftTop.y);
                BottomScrollBar.PlusButtonDowned = true;
                TimerCount = 0;
                return 1;
            }
            int sliderx = BottomScrollBar.GetSliderPosition(LeftTop.x);
            if(BottomScrollBar.Left + BottomScrollBar.MinusButtonLength <= x &&
               x < BottomScrollBar.Left + BottomScrollBar.MinusButtonLength + sliderx){
                // {^ƃXC_̊ԁB
                SetLeftTop(LeftTop.x - InnerSize.cx / 2, LeftTop.y);
                BottomScrollBar.LargeChangeMouseDownedPosition = x - BottomScrollBar.MinusButtonLength;
                TimerCount = 0;
                return 1;
            }
            if(BottomScrollBar.Left + BottomScrollBar.MinusButtonLength + sliderx + BottomScrollBar.SliderLength <= x &&
               x < BottomScrollBar.Left + BottomScrollBar.MinusButtonLength + BottomScrollBar.InnerLength){
                // E{^ƃXC_̊ԁB
                SetLeftTop(LeftTop.x + InnerSize.cx / 2, LeftTop.y);
                BottomScrollBar.LargeChangeMouseDownedPosition = x - BottomScrollBar.MinusButtonLength;
                TimerCount = 0;
                return 1;
            }
            if(BottomScrollBar.Left + BottomScrollBar.MinusButtonLength + sliderx <= x &&
               x < BottomScrollBar.Left + BottomScrollBar.MinusButtonLength + sliderx + BottomScrollBar.SliderLength){
                // XC_͂񂾁B
                BottomScrollBar.SliderMouseDownedPosition = x - sliderx;
                return 1;
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// }EXAbvCxgʒm֐B
__fastcall TViewport::NoticeMouseUp(void)
{
    // EXN[o[
    if(RightScrollBar.SliderMouseDownedPosition != -1){
        RightScrollBar.SliderMouseDownedPosition = -1;
        return 1;
    }
    if(RightScrollBar.LargeChangeMouseDownedPosition != -1){
        RightScrollBar.LargeChangeMouseDownedPosition = -1;
        return 1;
    }
    if(RightScrollBar.MinusButtonDowned){
        RightScrollBar.MinusButtonDowned = false;
        return 1;
    }
    if(RightScrollBar.PlusButtonDowned){
        RightScrollBar.PlusButtonDowned = false;
        return 1;
    }
    // XN[o[
    if(BottomScrollBar.SliderMouseDownedPosition != -1){
        BottomScrollBar.SliderMouseDownedPosition = -1;
        return 1;
    }
    if(BottomScrollBar.LargeChangeMouseDownedPosition != -1){
        BottomScrollBar.LargeChangeMouseDownedPosition = -1;
        return 1;
    }
    if(BottomScrollBar.MinusButtonDowned){
        BottomScrollBar.MinusButtonDowned = false;
        return 1;
    }
    if(BottomScrollBar.PlusButtonDowned){
        BottomScrollBar.PlusButtonDowned = false;
        return 1;
    }
    return 0;
}
//---------------------------------------------------------------------------
// }EXړCxgʒm֐B
__fastcall TViewport::NoticeMouseMove(int x, int y)
{
    if(RightScrollBar.Visible){
        if(RightScrollBar.SliderMouseDownedPosition != -1){
            int slidery = y - RightScrollBar.SliderMouseDownedPosition;
            int lty = FullSize.cy * slidery / RightScrollBar.InnerLength;
            SetLeftTop(LeftTop.x, lty);
            return 1;
        }
    }
    if(BottomScrollBar.Visible){
        if(BottomScrollBar.SliderMouseDownedPosition != -1){
            int sliderx = x - BottomScrollBar.SliderMouseDownedPosition;
            int ltx = FullSize.cx * sliderx / BottomScrollBar.InnerLength;
            SetLeftTop(ltx, LeftTop.y);
            return 1;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// {^̃s[ǵB
__fastcall TViewport::NoticeTimer(void)
{
    if(!Valid)
        return 0;
    TimerCount++;
    if(TimerCount > 4){
        // EXN[o[
        if(RightScrollBar.Visible){
            if(RightScrollBar.MinusButtonDowned){
                SetLeftTop(LeftTop.x, LeftTop.y - ButtonScrollUnit);
                return 1;
            }
            if(RightScrollBar.PlusButtonDowned){
                SetLeftTop(LeftTop.x, LeftTop.y + ButtonScrollUnit);
                return 1;
            }
            int slidery = RightScrollBar.GetSliderPosition(LeftTop.y);
            if(RightScrollBar.LargeChangeMouseDownedPosition != -1){
                if(RightScrollBar.LargeChangeMouseDownedPosition < slidery){
                    SetLeftTop(LeftTop.x, LeftTop.y - InnerSize.cy / 2);
                    return 1;
                }
                if(RightScrollBar.LargeChangeMouseDownedPosition > slidery + RightScrollBar.SliderLength){
                    SetLeftTop(LeftTop.x, LeftTop.y + InnerSize.cy / 2);
                    return 1;
                }
            }
        }
        // XN[o[
        if(BottomScrollBar.Visible){
            if(BottomScrollBar.MinusButtonDowned){
                SetLeftTop(LeftTop.x - ButtonScrollUnit, LeftTop.y);
                return 1;
            }
            if(BottomScrollBar.PlusButtonDowned){
                SetLeftTop(LeftTop.x + ButtonScrollUnit, LeftTop.y);
                return 1;
            }
            int sliderx = BottomScrollBar.GetSliderPosition(LeftTop.x);
            if(BottomScrollBar.LargeChangeMouseDownedPosition != -1){
                if(BottomScrollBar.LargeChangeMouseDownedPosition < sliderx){
                    SetLeftTop(LeftTop.x - InnerSize.cx / 2, LeftTop.y);
                    return 1;
                }
                if(BottomScrollBar.LargeChangeMouseDownedPosition > sliderx + BottomScrollBar.SliderLength){
                    SetLeftTop(LeftTop.x + InnerSize.cx / 2, LeftTop.y);
                    return 1;
                }
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//wNXg[Xp萔Bオn_Ŏv
const int FieldScreen::NextDX[2][6]={{0,1,1,1,0,-1},{-1,0,1,0,-1,-1}},
          FieldScreen::NextDY[6]={-1,-1,0,1,1,0};
//---------------------------------------------------------------------------
FieldScreen::FieldScreen(void){
//    Bitmap = new Graphics::TBitmap();
    Bitmap = new TABitmap();
    Bitmap_TempChip = new TABitmap();
    Bitmap_TempChip->Width = GRAPHDEGREE_N;
    Bitmap_TempChip->Height = GRAPHDEGREE_N;
    Bitmap_Viewport = new Graphics::TBitmap();
    MakeNeighborList();
    GetNeighborRect();
}
//---------------------------------------------------------------------------
FieldScreen::~FieldScreen(void){
    if(Bitmap != NULL)
        delete Bitmap;
    delete Bitmap_Viewport;
}
//---------------------------------------------------------------------------
//ߖT̓_̑΍WXgB
__fastcall FieldScreen::MakeNeighborList(void)
{
    int index_from,index_current;

    for(int mode=0;mode<2;mode++){
        NeighborX[mode][0] = 0;
        NeighborY[mode][0] = mode;
        NeighborIndex[0] = 0;
        NeighborIndex[1] = 1;
        index_from = 0;
        index_current = 1;
        for(int radius=1;radius<=NEIGHBOR_MAX;radius++){
            for(int i=NeighborIndex[radius-1];i<NeighborIndex[radius];i++){
                int new_index = GenerateNeighborList(mode,index_from,index_current,NeighborX[mode][i],NeighborY[mode][i]);
                if(new_index == -1)
                    break;
                index_current = new_index;
            }
            NeighborIndex[radius+1] = index_current;
            index_from = NeighborIndex[radius-1];
        }
    }
    //SW͕̎֋X(0,1)̋ߖT̍W߁A
    //yW1ďCB
    for(int i=0;i<index_current;i++){
        NeighborY[1][i]--;
    }
    /*
    for(i=0;i<index_current;i++){
        char str[32];
        sprintf(str,"%d,%d",NeighborX[0][i],NeighborY[0][i]);
        ShowMessage(str);

    } */
    /*
    //dWĂȂׂB
    int index;
    mode = 0;
    for(i=0;i<index_current;i++){
        //܂ڂ̍WTB
        index = GetNeighborIndex(mode,NeighborX[mode][i],NeighborY[mode][i],
                                 0,index_current);
        //͌͂B
        if(index == -1){
            ShowMessage("foolish!");
            break;
        }
        //ڂTČꍇAdW݂B
        index = GetNeighborIndex(mode,NeighborX[mode][i],NeighborY[mode][i],
                                 index+1,index_current);
        if(index != -1){
            char str[32];
            sprintf(str,"ERROR:multiple location(%d,%d)%d",NeighborX[mode][i],NeighborY[mode][i],index);
            ShowMessage(str);
        }
    }
    */
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::GenerateNeighborList(int mode,int index_from,int index_current,int center_x,int center_y)
{
    int i,x,y,odd;

    odd = (center_y >= 0 ? center_y : -center_y)%2;
    for(i=0;i<6;i++){
        //w肳ꂽW̎͂̍WɂāA
        x = center_x + NextDX[odd][i];
        y = center_y + NextDY[i];
        //܂XgɓĂȂWȂ烊XgɉB
        if(GetNeighborIndex(mode,x,y,index_from,index_current) == -1){
            if(index_current >= NEIGHBOR_LIST_MAX){
                ShowMessage("ߖTWZoŃI[o[t[N܂B");
                return -1;
            }
            NeighborX[mode][index_current] = x;
            NeighborY[mode][index_current] = y;
            index_current++;
        }
    }
    return index_current;
}
//---------------------------------------------------------------------------
//index_from index_to-1 ͈̔͂Ŏw肳ꂽWXgTB
//߂l͌΂̃CfbNXAȂ-1
//mode ͍ŏ̒ŜxW̎1,̎0
__fastcall FieldScreen::GetNeighborIndex(int mode,int x,int y,int index_from,int index_to)
{
    for(int i=index_from;i<index_to;i++){
        if(x==NeighborX[mode][i] && y==NeighborY[mode][i])
            return i;
    }
    return -1;
}
//---------------------------------------------------------------------------
//ߖTWɑ΂ĕ`sA̕`̈܂ދ`̃XgB
__fastcall FieldScreen::GetNeighborRect(void)
{
    int radius,x1,y1,x2,y2;

    for(radius=0;radius<NEIGHBOR_MAX;radius++){
        x1 = y1 = -radius*GRAPHDEGREE_S;
        x2 = y2 = (radius+1)*GRAPHDEGREE_S;
        NeighborRect[radius] = Rect(x1,y1,x2,y2);
    }
    return 0;
}
//---------------------------------------------------------------------------
// (x,y)𒆐SƂ锼ar1`r2͈̔͂̋ߖTW̃Xg𓾂B
// length ̓Xg̍ő咷A߂l̓Xg̒B
// r2傫ꍇ͍ő͈͂̋ߖTԂB
__fastcall FieldScreen::GetNeighborList(int cx,int cy,int r1,int r2,int w,int h,POINT *list,int length) const
{
    int i,x,y,count=0,mode=cy%2;
    const int *dX = NeighborX[mode];
    const int *dY = NeighborY[mode];

    if(r1 < 0){
        AnsiString str;
        str.cat_sprintf("GetNeighborList error r1=%d", r1);
        ShowMessage(str);
        r1 = 0;
    }
    if(r2 > NEIGHBOR_MAX){
        r2 = NEIGHBOR_MAX;
    }
    for(i=NeighborIndex[r1]; i<NeighborIndex[r2]; i++){
        x = cx + dX[i];
        y = cy + dY[i];
        if(x<0 || x>=w || y<0 || y>=h)
            continue;
        list[count].x = x;
        list[count].y = y;
        count++;
        if(count >= length)
            break;
    }
    return count;
}
//---------------------------------------------------------------------------
// vector<POINT>ŁB
__fastcall FieldScreen::GetNeighborList(int cx, int cy, int r1, int r2, int w, int h, vector<POINT>& list) const
{
    int i,x,y,count=0,mode=cy%2;
    const int *dX = NeighborX[mode];
    const int *dY = NeighborY[mode];

    if(r1 < 0){
        r1 = 0;
    }
    if(r2 > NEIGHBOR_MAX){
        r2 = NEIGHBOR_MAX;
    }
    list.resize(NEIGHBOR_NEED_SIZE(r2));
    for(i=NeighborIndex[r1]; i<NeighborIndex[r2]; i++){
        x = cx + dX[i];
        y = cy + dY[i];
        if(x<0 || x>=w || y<0 || y>=h)
            continue;
        list[count].x = x;
        list[count].y = y;
        count++;
    }
    return count;
}
//---------------------------------------------------------------------------
// (x,y)𒆐SƂ锼ar1`r2͈̔͂̋ߖTWɂāATRangeLayer̒l1ɂB
// r2傫ꍇ͍ő͈͂̋ߖTԂB
__fastcall FieldScreen::GetNeighborRange(int cx,int cy,int r1,int r2,TRangeLayer *layer) const
{
    int i,x,y,mode=cy%2;
    int w = layer->GetWidth();
    int h = layer->GetHeight();
    const int *dX = NeighborX[mode];
    const int *dY = NeighborY[mode];

    if(r2 > NEIGHBOR_MAX)
        r2 = NEIGHBOR_MAX;
    for(i=NeighborIndex[r1]; i<NeighborIndex[r2]; i++){
        x = cx + dX[i];
        y = cy + dY[i];
        if(x<0 || x>=w || y<0 || y>=h)
            continue;
        layer->GetRangeValue(x,y) = 1;
    }
    return 0;
}
//---------------------------------------------------------------------------
//(x,y)(cx,cy)甼aradiusȓɂ邩BႦradius=1ȂׁB
__fastcall FieldScreen::IsNeighbor(int x,int y,int cx,int cy,int radius) const
{
    int mode=cy%2;
    const int *listX = NeighborX[mode];
    const int *listY = NeighborY[mode];

    if(radius > NEIGHBOR_MAX){
        radius = NEIGHBOR_MAX;
    }
    for(int i=NeighborIndex[0]; i<NeighborIndex[radius+1]; i++){
        if(cx+listX[i]==x && cy+listY[i]==y)
            return 1;
    }
    return 0;
}
//---------------------------------------------------------------------------
//gpImageList߂B
__fastcall FieldScreen::DefineImageList(TKSImageData *GBWImagep,int mode)
{
    int sprite_zoom;    // XvCgWCWB

    KSImageData = GBWImagep;
    switch(mode){
    case 0:   //WTCY
        ImageList_Figure=GBWImagep->ImageList_FigureN;
        GraphDegree=GRAPHDEGREE_N;
        sprite_zoom = 256 * GRAPHDEGREE_N / GRAPHDEGREE_S;
        break;
    case 1:   //kTCY
        ImageList_Figure=GBWImagep->ImageList_FigureS;
        GraphDegree=GRAPHDEGREE_S;
        sprite_zoom = 256 * GRAPHDEGREE_S / GRAPHDEGREE_N;
        break;
    }
    // \̃XvCg͍W̑sB
    for(list<TSpriteOnMap>::iterator sprite=SpriteList.begin(); sprite!=SpriteList.end(); sprite++){
        sprite->X = (sprite->X * sprite_zoom)>>8;
        sprite->Y = (sprite->Y * sprite_zoom)>>8;
    }
    return 0;
}
//---------------------------------------------------------------------------
// XN[o[܂߂r[|[gŜ̉摜̑傫ݒ肷B
__fastcall FieldScreen::SetViewportSize(const MapData *mapData, int w, int h)
{
    int mapw = mapData->GetWidth()*GraphDegree + GraphDegree/2;
    int maph = mapData->GetHeight()*GraphDegree;

    Viewport.SetSize(mapw, maph, w, h);
    Viewport.ButtonScrollUnit = GraphDegree;

#if 0
    BITMAPINFO biBMP;
    ZeroMemory(&biBMP, sizeof(biBMP));
    biBMP.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    biBMP.bmiHeader.biBitCount = 32;
    biBMP.bmiHeader.biPlanes = 1;
    biBMP.bmiHeader.biWidth = Viewport.OuterSize.cx;
    biBMP.bmiHeader.biHeight = Viewport.OuterSize.cy;
    HBITMAP hbmpBuffer = CreateDIBSection(NULL, &biBMP, DIB_RGB_COLORS, reinterpret_cast<void **>(&lpdwPixel), NULL, 0);
    Bitmap->ReleaseHandle();
    Bitmap->Handle = hbmpBuffer;
#else
    Bitmap->Width = Viewport.OuterSize.cx;
    Bitmap->Height = Viewport.OuterSize.cy;
#endif
    RangeLimit = false;

    // k}bv摜쐬B
    int mw = mapData->GetWidth();
    int mh = mapData->GetHeight();
    Bitmap_Viewport->Width = mw;
    Bitmap_Viewport->Height = mh;
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            int g = mapData->GetMapStatus(x, y).Graphic;
            Bitmap_Viewport->Canvas->Pixels[x][y] = KSImageData->Bitmap_MapD->Canvas->Pixels[g%10][g/10];
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
const TSize& __fastcall FieldScreen::GetViewportInnerSize(void) const
{
    return Viewport.InnerSize;
}
//---------------------------------------------------------------------------
const TSize& __fastcall FieldScreen::GetViewportOuterSize(void) const
{
    return Viewport.OuterSize;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::SetViewportLeftTop(int x, int y)
{
    Viewport.SetLeftTop(x, y);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::GetViewportLeftTop(int *x, int *y) const
{
    *x = Viewport.LeftTop.x;
    *y = Viewport.LeftTop.y;
    return 0;
}
//---------------------------------------------------------------------------
// r[|[g炷B
__fastcall FieldScreen::SlideViewport(int x, int y)
{
    SetViewportLeftTop(Viewport.LeftTop.x + x, Viewport.LeftTop.y + y);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::NoticeMouseDownToViewport(int x, int y)
{
    // NoticeMouseMoveToViewport()̃Rsyƕς́B蔲B
    if(PopupMenu.Visible){
        int px = x + Viewport.LeftTop.x;
        int py = y + Viewport.LeftTop.y;
        int menuh = PopupMenu.MenuHeight * PopupMenu.MenuItems.size();
        if(PopupMenu.X <= px && px < PopupMenu.X + PopupMenu.MenuWidth && 
           PopupMenu.Y <= py && py < PopupMenu.Y + menuh){
            PopupMenu.SelectedIndex = (py - PopupMenu.Y) / PopupMenu.MenuHeight;
            return 1;
        }
    }
    return Viewport.NoticeMouseDown(x, y);
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::NoticeMouseUpToViewport(void)
{
    return Viewport.NoticeMouseUp();
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::NoticeMouseMoveToViewport(int x, int y)
{
    if(PopupMenu.Visible){
        int px = x + Viewport.LeftTop.x;
        int py = y + Viewport.LeftTop.y;
        int menuh = PopupMenu.MenuHeight * PopupMenu.MenuItems.size();
        if(PopupMenu.X <= px && px < PopupMenu.X + PopupMenu.MenuWidth && 
           PopupMenu.Y <= py && py < PopupMenu.Y + menuh){
            PopupMenu.MouseMovedIndex = (py - PopupMenu.Y) / PopupMenu.MenuHeight;
            return 1;
        }
    }
    TPoint oldp = Viewport.LeftTop;
    if(Viewport.NoticeMouseMove(x, y)){
        return Viewport.LeftTop.x != oldp.x || Viewport.LeftTop.y != oldp.y;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::NoticeTimerToViewport(void)
{
    return Viewport.NoticeTimer();
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawScrollBars(void)
{
    if(Viewport.RightScrollBar.Visible){
        DrawScrollBar(Viewport.RightScrollBar, Viewport.LeftTop.y, true);
    }

    if(Viewport.BottomScrollBar.Visible){
        DrawScrollBar(Viewport.BottomScrollBar, Viewport.LeftTop.x, false);
    }
    // ꍇ͉E̎lphԂB
    if(Viewport.RightScrollBar.Visible && Viewport.BottomScrollBar.Visible){
        Bitmap->Canvas->Brush->Color = clBlack;
        Bitmap->Canvas->FillRect(TRect(Viewport.RightScrollBar.Left, Viewport.BottomScrollBar.Top, Viewport.OuterSize.cx, Viewport.OuterSize.cy));
    }
    return 0;
}
//---------------------------------------------------------------------------
// c܂͉̃XN[o[P{`B
__fastcall FieldScreen::DrawScrollBar(const TSimpleScrollBar& bar, int vppos, bool isVertical)
{
    const TColor bgcolor = 0x00fff0e8,
                 slidercolor = 0x00f8d8c0, slidercolor2 = 0x00f0c0a0,
                 buttoncolor = 0x00f0c0a0,
                 linecolor = clBlack;
    TRect barRect, mbRect, pbRect, sliderRect, lcRect(-1,0,0,0);

    // XC_ʒu
    int sliderpos = bar.MinusButtonLength + bar.GetSliderPosition(vppos);
    if(isVertical){
        barRect = TRect(bar.Left, bar.Top, bar.Left + bar.OuterWidth, bar.Top + bar.OuterLength);
        mbRect = TRect(bar.Left, bar.Top, bar.Left + bar.MinusButtonLength, bar.Top + bar.OuterWidth);
        pbRect = TRect(bar.Left, bar.Top + bar.MinusButtonLength + bar.InnerLength, bar.Left + bar.OuterWidth, bar.Top + bar.MinusButtonLength + bar.InnerLength + bar.PlusButtonLength);
        sliderRect = TRect(bar.Left + 1, bar.Top + sliderpos, bar.Left + bar.OuterWidth - 1, bar.Top + sliderpos + bar.SliderLength);
        if(bar.LargeChangeMouseDownedPosition != -1){
            if(bar.LargeChangeMouseDownedPosition < sliderpos){
                lcRect = TRect(bar.Left + 1, bar.Top + bar.MinusButtonLength, bar.Left + bar.OuterWidth - 1, bar.Top + bar.MinusButtonLength + sliderpos);
            }
            else if(bar.LargeChangeMouseDownedPosition > sliderpos + bar.SliderLength){
                lcRect = TRect(bar.Left + 1, bar.Top + sliderpos + bar.SliderLength, bar.Left + bar.OuterWidth - 1, bar.Top + bar.MinusButtonLength + bar.InnerLength);
            }
        }
    }
    else{
        barRect = TRect(bar.Left, bar.Top, bar.Left + bar.OuterLength, bar.Top + bar.OuterWidth);
        mbRect = TRect(bar.Left, bar.Top, bar.Left + bar.OuterWidth, bar.Top + bar.MinusButtonLength);
        pbRect = TRect(bar.Left + bar.MinusButtonLength + bar.InnerLength, bar.Top, bar.Left + bar.MinusButtonLength + bar.InnerLength + bar.PlusButtonLength, bar.Top + bar.OuterWidth);
        sliderRect = TRect(bar.Left + sliderpos, bar.Top + 1, bar.Left + sliderpos + bar.SliderLength, bar.Top + bar.OuterWidth - 1);
        if(bar.LargeChangeMouseDownedPosition != -1){
            if(bar.LargeChangeMouseDownedPosition < sliderpos){
                lcRect = TRect(bar.Left + bar.MinusButtonLength, bar.Top + 1, bar.Left + bar.MinusButtonLength + sliderpos, bar.Top + bar.OuterWidth - 1);
            }
            else if(bar.LargeChangeMouseDownedPosition > sliderpos + bar.SliderLength){
                lcRect = TRect(bar.Left + sliderpos + bar.SliderLength, bar.Top + 1, bar.Left + bar.MinusButtonLength + bar.InnerLength, bar.Top + bar.OuterWidth - 1);
            }
        }
    }

    TCanvas *canvas = Bitmap->Canvas;
    canvas->Pen->Color = linecolor;
    canvas->Brush->Color = bgcolor;
    canvas->Rectangle(barRect);
    // Ŝ̘gB
    // /̎lpB
    if(bar.MinusButtonDowned){
        canvas->Brush->Color = buttoncolor;
    }else{
        canvas->Brush->Color = bgcolor;
    }
    canvas->Rectangle(mbRect);
    // /E̎lpB
    if(bar.PlusButtonDowned){
        canvas->Brush->Color = buttoncolor;
    }else{
        canvas->Brush->Color = bgcolor;
    }
    canvas->Rectangle(pbRect);
    if(lcRect.Left != -1){
        canvas->Brush->Color = buttoncolor;
        canvas->FillRect(lcRect);
    }
    // XC_B
    if(bar.SliderMouseDownedPosition == -1){
        canvas->Brush->Color = slidercolor;
    }else{
        canvas->Brush->Color = slidercolor2;
    }
    canvas->Rectangle(sliderRect);
    return 0;
}
//---------------------------------------------------------------------------
// C[CfbNXw肳Ăꍇ́ÃC[CfbNX̗vf폜B
// w肳ĂȂꍇ͑S폜B
__fastcall FieldScreen::ClearSpriteList(int layer)
{
    if(layer == -1){
        SpriteList.clear();
    }
    else{
        // LayerIndex == layer ̃XvCgSč폜B
        TSpriteOnMap sprite;
        sprite.LayerIndex = layer;
        SpriteList.erase(lower_bound(SpriteList.begin(), SpriteList.end(), sprite),
                         upper_bound(SpriteList.begin(), SpriteList.end(), sprite));
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::AddSprite(int x, int y, TSpriteOnMap::TSpriteType stype, int index, int value, int layer)
{
    TSpriteOnMap sprite;

    sprite.X = x;
    sprite.Y = y;
    sprite.SpriteType = stype;
    sprite.Value = value;
    sprite.Index = index;
    sprite.LayerIndex = layer;
    // C[CfbNXvf̌ɓB
    SpriteList.insert(upper_bound(SpriteList.begin(), SpriteList.end(), sprite), sprite);
//    SpriteList.push_back(sprite);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::AddSpriteZ(int zx, int zy, TSpriteOnMap::TSpriteType stype, int index, int value, int layer)
{
    int x,y;

    XY_MapToPhy(zx, zy, &x, &y);
    AddSprite(x, y, stype, index, value, layer);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::ClearMessageRectList(void)
{
    MessageRectList.clear();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::AddMessageRect(const TMessageRectOnMap& msgr)
{
    MessageRectList.push_back(msgr);
    return 0;
}
//---------------------------------------------------------------------------
// ݂̃bZ[W`\SXV邽߂ɕKvȍXV̈_WœB
// r͌ĂяoŏBr̒lɘ_aB
__fastcall FieldScreen::GetMessageRectNeedUpdateRect(TRect *r) const
{
    for(vector<TMessageRectOnMap>::const_iterator msgr=MessageRectList.begin(); msgr!=MessageRectList.end(); msgr++){
        // Ȃ傴ρB
        int zx1 = msgr->ZX - msgr->Width/GraphDegree - 2;
        int zy1 = msgr->ZY - msgr->Height/GraphDegree - 1;
        int zx2 = msgr->ZX + msgr->Width/GraphDegree + 2;
        int zy2 = msgr->ZY + msgr->Height/GraphDegree + 1;
        r->left = min(r->left, zx1);
        r->top = min(r->top, zy1);
        r->right = max(r->right, zx2);
        r->bottom = max(r->bottom, zy2);
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::ClearPopupMenu(void)
{
    PopupMenu.MenuItems.clear();
    PopupMenu.MenuID.clear();
    PopupMenu.MenuEnabled.clear();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::AddPopupMenu(const string& title, int menuID, bool enabled)
{
    PopupMenu.MenuItems.push_back(title);
    PopupMenu.MenuID.push_back(menuID);
    PopupMenu.MenuEnabled.push_back(enabled);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::ShowPopupMenu(int zx, int zy, TRect *updateRect)
{
    int x, y, zx1, zy1, zx2, zy2;

    PopupMenu.MenuWidth = 128;
    PopupMenu.MenuHeight = 16;
    XY_MapToPhy(zx, zy, &x, &y);
    if(x + GraphDegree - Viewport.LeftTop.x + PopupMenu.MenuWidth <= Viewport.InnerSize.cx){
        // EɃXy[XȂ΁AEB
        PopupMenu.X = x + GraphDegree;
        zx1 = zx + 1;
        zx2 = zx + 1 + (PopupMenu.MenuWidth+GraphDegree-1)/GraphDegree;
    }else{
        // B
        PopupMenu.X = x - PopupMenu.MenuWidth;
        zx1 = zx - (PopupMenu.MenuWidth+GraphDegree-1)/GraphDegree;
        zx2 = zx - 1;
    }
    int menuh = PopupMenu.MenuHeight*PopupMenu.MenuItems.size();
    if(y - Viewport.LeftTop.y + menuh <= Viewport.InnerSize.cy){
        // ɃXy[XȂ΁AB
        PopupMenu.Y = y;
        zy1 = zy;
        zy2 = zy + (menuh+GraphDegree-1)/GraphDegree;
    }else{
        // B
        PopupMenu.Y = y + GraphDegree - menuh;
        zy1 = zy - (menuh+GraphDegree-1)/GraphDegree;
        zy2 = zy;
    }
    *updateRect = TRect(zx1, zy1, zx2, zy2);
    PopupMenu.MouseMovedIndex = -1;
    PopupMenu.SelectedIndex = -1;
    PopupMenu.Visible = true;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::HidePopupMenu(TRect *updateRect)
{
    if(!PopupMenu.Visible)
        return 0;
    if(updateRect != NULL){
        int zx, zy;
        zx = PopupMenu.X/GraphDegree - 1;
        zy = PopupMenu.Y/GraphDegree;
        int menuh = PopupMenu.MenuHeight*PopupMenu.MenuItems.size();
        *updateRect = TRect(zx, zy, zx + (PopupMenu.MenuWidth+GraphDegree-1)/GraphDegree + 1, zy + (menuh+GraphDegree-1)/GraphDegree);
    }
    PopupMenu.Visible = false;
    return 1;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::GetPopupMenuSelectedID(void) const
{
    if(PopupMenu.SelectedIndex != -1)
        return PopupMenu.MenuID[PopupMenu.SelectedIndex];
    return -1;
}
//---------------------------------------------------------------------------
// }bvŜ`B
__fastcall FieldScreen::DrawMap(MapData *mapData, const TRangeLayer *layer, const UnitStatus *holdUnit, const TSideStatusArray& sideStatus)
{
    return DrawMap(mapData, layer, holdUnit, sideStatus, 0, 0, mapData->GetWidth(), mapData->GetHeight());
}
//---------------------------------------------------------------------------
// }bv̎w蕔`B
// ړ͈͂`悷鎞́AholdUnitsideStatusQƂB
__fastcall FieldScreen::DrawMap(MapData *mapData, const TRangeLayer *layer, const UnitStatus *holdUnit, const TSideStatusArray& sideStatus, int x1, int y1, int x2, int y2)
{
    int minx1 = max(0, (Viewport.LeftTop.x - GraphDegree)/GraphDegree);
    int miny1 = max(0, (Viewport.LeftTop.y - GraphDegree)/GraphDegree);
    int maxx2 = min(mapData->GetWidth()-1,  (Viewport.LeftTop.x + Viewport.InnerSize.cx + GraphDegree)/GraphDegree);
    int maxy2 = min(mapData->GetHeight()-1, (Viewport.LeftTop.y + Viewport.InnerSize.cy + GraphDegree)/GraphDegree);

    if(x1 < minx1){
        x1 = minx1;
    }
    if(x2 > maxx2){
        x2 = maxx2;
    }
    if(y1 < miny1){
        y1 = miny1;
    }
    if(y2 > maxy2){
        y2 = maxy2;
    }

    // TCanvas ɑ΂NbsOwB
    TCanvas *canvas = Bitmap->Canvas;
    HRGN myRgn = ::CreateRectRgn(0, 0, Viewport.InnerSize.cx, Viewport.InnerSize.cy);
    ::SelectClipRgn(canvas->Handle, myRgn);
    // TABitmapChipSet ɓNbsOwsB
    TRect r(0, 0, Viewport.InnerSize.cx, Viewport.InnerSize.cy);
    KSImageData->ChipSetMap->SetClipRect(r);
    KSImageData->ChipSetUnit->SetClipRect(r);
    KSImageData->ChipSetCursor->SetClipRect(r);
    KSImageData->ChipSetCrash->SetClipRect(r);

    canvas->Brush->Color = clBlack;
    TABitmap *bgbmp;
    if(GraphDegree == GRAPHDEGREE_N){
        bgbmp = KSImageData->Bitmap_BGImageN;
    }else{
        bgbmp = KSImageData->Bitmap_BGImageS;
    }
    if(!bgbmp->Empty){
        int bmpsrcx = Viewport.LeftTop.x;
        int bmpsrcy = Viewport.LeftTop.y;
        int bmpsrcw = Viewport.InnerSize.cx;
        int bmpsrch = Viewport.InnerSize.cy;
        int bmpdstw = Viewport.InnerSize.cx;
        int bmpdsth = Viewport.InnerSize.cy;
        TRect srcr(bmpsrcx, bmpsrcy, bmpsrcx + bmpsrcw, bmpsrcy + bmpsrch);
        TRect dstr(0, 0, bmpdstw, bmpdsth);
        canvas->CopyRect(dstr, bgbmp->Canvas, srcr);
        // EȂꍇB
        if(bgbmp->Width - bmpsrcx < Viewport.InnerSize.cx){
            int left = max(0, bgbmp->Width - bmpsrcx);
            canvas->FillRect(TRect(left, 0, dstr.Right, dstr.Bottom));
        }
        // ȂꍇB
        if(bgbmp->Height - bmpsrcy < Viewport.InnerSize.cy){
            int top = max(0, bgbmp->Height - bmpsrcy);
            canvas->FillRect(TRect(0, top, dstr.Right, dstr.Bottom));
        }
    }
    else{
        // E̔wNXhԂB
        if(x1 == 0){
            canvas->FillRect(TRect(0, 0, GraphDegree/2, Viewport.OuterSize.cy));
        }
        if(x2 == mapData->GetWidth() - 1){
            canvas->FillRect(TRect(Viewport.InnerSize.cx - GraphDegree/2, 0, Viewport.InnerSize.cx, Viewport.InnerSize.cy));
        }
    }

    for(int y=y1;y<=y2;y++){
        for(int x=x1;x<=x2;x++){
            const MapStatus& gnd = mapData->GetMapStatus(x, y);
            int px, py;
            XY_MapToPhy(x, y, &px, &py);
            if(mapData->GetShade(x,y)){
                DrawMapChipShade(px, py, gnd.Graphic);
            }
            else{
                DrawMapChip(px, py, gnd.Graphic);
            }
            if(gnd.Side != -1 && !mapData->GetShade(x,y)){
                DrawUnitChipAuto(mapData, sideStatus, x, y, true);
            }
            if(CurrentRangeType != rtNone && layer->GetRangeValue(x, y)){
                // CPU쎞p̃IvVBȂ͕̑`悵Ȃ
                if(RangeLimit && mapData->GetShade(x,y))
                    continue;
                if(CurrentRangeType == rtMoveRange){
                    if(gnd.Side==-1 || mapData->GetShade(x,y)){
                        // jbgs݁A͌ȂꍇʏJ[\B
                        DrawCursor(px, py, CURSOR_MOVE);
                    }
                    else{
                        // jbgꍇAKvɉč܂
                        // ڃJ[\`B
                        // AVisible=false͎̎͂Rjbgł
                        // 肦Ȃ̂ŁAʏJ[\`B
                        if((x!=holdUnit->X || y!=holdUnit->Y) && mapData->GetVisible(x,y)){
                            int type2 = sideStatus[gnd.Side].Unit[gnd.UnitIndex].Type;
                            if(holdUnit->Type==type2){
                                DrawCursor(px, py, CURSOR_PLUS);
                            }else{
                                DrawCursor(px, py, CURSOR_UP);
                            }
                        }
                        else{
                            DrawCursor(px,py,CURSOR_MOVE);
                        }
                    }
                }
                else if(CurrentRangeType == rtAttackOrLoadRange){
                    if(gnd.Side == -1 || mapData->GetShade(x,y)){
                        // jbgs݁A͌Ȃꍇ
                        DrawCursor(px, py, CURSOR_DOWN);
                    }
                    else{
                        DrawCursor(px, py, CURSOR_RANGE);
                    }
                }
                else if(CurrentRangeType == rtAttackRange){
                    // ɍUJ[\B
                    DrawCursor(px, py, CURSOR_RANGE);
                }
            }
        }
    }
    for(list<TSpriteOnMap>::const_iterator sprite=SpriteList.begin(); sprite!=SpriteList.end(); sprite++){
        switch(sprite->SpriteType){
        case TSpriteOnMap::stMapChip:
            DrawMapChip(sprite->X, sprite->Y, sprite->Index);
            break;
        case TSpriteOnMap::stMapChipDark:
            DrawMapChipDark(sprite->X, sprite->Y, sprite->Index);
            break;
        case TSpriteOnMap::stUnitChip:
            DrawUnitChip(sprite->X, sprite->Y, sprite->Index);
            break;
        case TSpriteOnMap::stCursor:
            DrawCursor(sprite->X, sprite->Y, sprite->Index);
            break;
        case TSpriteOnMap::stCrash:
            DrawCrash(sprite->X, sprite->Y, sprite->Index);
            break;
        case TSpriteOnMap::stDarkRect:
            DrawDarkRect(sprite->X, sprite->Y, sprite->X+GraphDegree, sprite->Y+GraphDegree);
            break;
        case TSpriteOnMap::stValue:
            DrawValue(sprite->X, sprite->Y, sprite->Value, sprite->Index);
            break;
        }
    }
    for(vector<TMessageRectOnMap>::const_iterator msgr=MessageRectList.begin(); msgr!=MessageRectList.end(); msgr++){
        int px, py;
        XY_MapToPhy(msgr->ZX, msgr->ZY, &px, &py);
        px -= Viewport.LeftTop.x;
        py -= Viewport.LeftTop.y;
        if(px + GraphDegree + msgr->Width <= Viewport.InnerSize.cx){
            // E
            px = px + GraphDegree;
        }
        else{
            // 
            px = px - msgr->Width;
        }
        if(py + GraphDegree + msgr->Height <= Viewport.InnerSize.cy){
            // 
            py = py + GraphDegree;
        }
        else{
            // 㑤
            py = py - msgr->Height;
        }
        const TColor bgcolor = 0x00fff0e8;
        canvas->Brush->Color = bgcolor;
        canvas->Pen->Color = clBlack;
        canvas->Rectangle(TRect(px, py, px+msgr->Width, py+msgr->Height));
        canvas->Font->Color = clBlack;
        int stry = 0;
        for(vector<string>::const_iterator str=msgr->MessageString.begin(); str!=msgr->MessageString.end(); str++){
            canvas->TextOut(px+2, py+2+stry, str->c_str());
            stry += msgr->StringHeight;
        }
    }
    if(PopupMenu.Visible){
        int px = PopupMenu.X - Viewport.LeftTop.x;
        int py = PopupMenu.Y - Viewport.LeftTop.y;
        const TColor bgcolor = 0x00fff0e8, selectedcolor = 0x00f8d8c0, disabledcolor = 0x00808080;
        // Og̕`B
        canvas->Brush->Color = bgcolor;
        canvas->Pen->Color = clBlack;
        canvas->Rectangle(TRect(px, py, px+PopupMenu.MenuWidth, py+PopupMenu.MenuHeight*PopupMenu.MenuItems.size()));
        for(int i=0; i<static_cast<int>(PopupMenu.MenuItems.size()); i++){
            const string& str = PopupMenu.MenuItems[i];
            canvas->Brush->Color = bgcolor;
            if(i == PopupMenu.MouseMovedIndex){
                // Ij[̕`B
                canvas->Brush->Color = selectedcolor;
                canvas->FillRect(TRect(px+1, py+(i==0), px+PopupMenu.MenuWidth-1, py+PopupMenu.MenuHeight-1));
            }
            // ̕`B
            if(PopupMenu.MenuEnabled[i]){
                canvas->Font->Color = clBlack;
            }else{
                canvas->Font->Color = disabledcolor;
            }
            canvas->TextOut(px+2, py+2, str.c_str());
            // d؂̕`B
            canvas->Brush->Color = clBlack;
            canvas->FillRect(TRect(px+1, py+PopupMenu.MenuHeight-1, px+PopupMenu.MenuWidth-1, py+PopupMenu.MenuHeight));
            py += PopupMenu.MenuHeight;
        }
    }
    ::SelectClipRgn(canvas->Handle, NULL);
    ::DeleteObject(myRgn);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawMapChipToTBitmap(Graphics::TBitmap *bitmap,int x,int y,int index,int size)
{
    if(!KSImageData->Bitmap_BGImageN->Empty){
        KSImageData->ChipSetMap->DrawChipToTBitmap(bitmap, x, y, index, size, TColor(MASKCOLOR));
    }else{
        KSImageData->ChipSetMap->DrawChipToTBitmap(bitmap, x, y, index, size, TColor(0xffffffff));
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawMapChipToTCanvas(TCanvas *canvas,int x,int y,int index,int size)
{
    KSImageData->ChipSetMap->DrawChipToTCanvas(canvas, x, y, index, size);
    return 0;
}
//---------------------------------------------------------------------------
//n`PP`iW̎wj
__fastcall FieldScreen::DrawMapChip(int x, int y, int index)
{
    int dx = x - Viewport.LeftTop.x;
    int dy = y - Viewport.LeftTop.y;
    DrawMapChipToTBitmap(Bitmap, dx, dy, index, GraphDegree);
    return 0;
}
//---------------------------------------------------------------------------
//n`PP`i_W̎wj
__fastcall FieldScreen::DrawMapChipZ(MapData *mapData,int zx,int zy)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    DrawMapChip(x, y, mapData->GetMapStatus(zx,zy).Graphic);
    return 0;
}
//---------------------------------------------------------------------------
//etĒn`PP`iW̎wj
__fastcall FieldScreen::DrawMapChipShade(int x,int y,int Index)
{
    DrawMapChip(x, y, Index);
    DrawCursor(x, y, CURSOR_DARK);
    return 0;
}
//---------------------------------------------------------------------------
//n`PP`i_W̎wj
//Shade=trueȂetB
__fastcall FieldScreen::DrawMapChipShadeZ(MapData *Mapp,int zx,int zy)
{
    int x,y,Index;

    Index = Mapp->GetMapStatus(zx,zy).Graphic;
    XY_MapToPhy(zx,zy,&x,&y);
    if(Mapp->GetShade(zx,zy))
        DrawMapChipShade(x,y,Index);
    else
        DrawMapChip(x,y,Index);
    return 0;
}
//---------------------------------------------------------------------------
//ÂF̒n`PP`iW̎wj
__fastcall FieldScreen::DrawMapChipDark(int x, int y, int index)
{
    if(index < 0)
        return -1;
    DrawMapChip(x, y, index);
    DrawDarkRect(x, y, x+GraphDegree, y+GraphDegree);
    return 0;
}
//---------------------------------------------------------------------------
//ÂF̒n`PP`i_W̎wj
__fastcall FieldScreen::DrawMapChipDarkZ(int zx, int zy, int index)
{
    if(index < 0)
        return -1;
    int x, y;
    XY_MapToPhy(zx, zy, &x, &y);
    DrawMapChipDark(x, y, index);
    return 0;
}
//---------------------------------------------------------------------------
// ÐF`P`iW̎wj
__fastcall FieldScreen::DrawDarkRect(int px1, int py1, int px2, int py2)
{
    int x1 = px1 - Viewport.LeftTop.x;
    int y1 = py1 - Viewport.LeftTop.y;
    int x2 = px2 - Viewport.LeftTop.x;
    int y2 = py2 - Viewport.LeftTop.y;
    const TSize& sz = Viewport.InnerSize;
    x1 = max(0, x1);
    y1 = max(0, y1);
    x2 = min(sz.cx, x2);
    y2 = min(sz.cy, y2);
    if(x1 < x2 && y1 < y2){
        Bitmap->RectAngleAlphaMMX(x1, y1, x2-x1, y2-y1, clBlack, 128);
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawUnitChipToTBitmap(Graphics::TBitmap *bitmap,int x,int y,int index,int size)
{
    return KSImageData->ChipSetUnit->DrawChipToTBitmap(bitmap, x, y, index, size, TColor(MASKCOLOR));
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawUnitChipToTCanvas(TCanvas *canvas,int x,int y,int index,int size)
{
    TRect r(0, 0, size, size);
    TCanvas *tempCanvas = Bitmap_TempChip->Canvas;
    tempCanvas->Brush->Color = clDkGray;
    tempCanvas->FillRect(r);
    KSImageData->ChipSetUnit->DrawChipToTBitmap(Bitmap_TempChip, 0, 0, index, size, TColor(MASKCOLOR));
    canvas->CopyRect(TRect(x, y, x+size, y+size), tempCanvas, r);
    return 0;
}
//---------------------------------------------------------------------------
//jbgP`iW̎wj
__fastcall FieldScreen::DrawUnitChip(int x, int y, int index)
{
//    ImageList_Unit->Draw(Bitmap->Canvas, x - Viewport.LeftTop.x, y - Viewport.LeftTop.y, Index);
    return DrawUnitChipToTBitmap(Bitmap, x - Viewport.LeftTop.x, y - Viewport.LeftTop.y, index, GraphDegree);
}
//---------------------------------------------------------------------------
//jbgP`i_W̎wj
__fastcall FieldScreen::DrawUnitChipZ(int zx,int zy,int Index)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    DrawUnitChip(x,y,Index);
    return 0;
}
//---------------------------------------------------------------------------
//jbg`iʂɕ`Bڃ}[Ntj
__fastcall FieldScreen::DrawUnitChipAuto(const MapData *mapp,const TSideStatusArray& sideStatus,int zx,int zy,bool ActionPut)
{
    int x,y,side,num;

    const MapStatus& gnd = mapp->GetMapStatus(zx, zy);
    side = gnd.Side;
    num = gnd.UnitIndex;
    XY_MapToPhy(zx,zy,&x,&y);
    DrawMapChipDark(x, y, gnd.Graphic);
    const UnitStatus *unitp = &sideStatus[side].Unit[num];
    DrawUnitChip(x,y,unitp->Graphic);
    if(unitp->Load)
        DrawCursor(x,y,CURSOR_LOAD);
    if(ActionPut && unitp->Actioned)
        DrawCursor(x,y,CURSOR_END);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawUnitNormalToCanvas(TCanvas *canvas,int x,int y,int index,bool load,bool actioned)
{
    TRect r(0, 0, GRAPHDEGREE_N, GRAPHDEGREE_N);
    TCanvas *tempCanvas = Bitmap_TempChip->Canvas;
    tempCanvas->Brush->Color = clDkGray;
    tempCanvas->FillRect(r);
    KSImageData->ChipSetUnit->DrawChipToTBitmap(Bitmap_TempChip, 0, 0, index, GRAPHDEGREE_N, TColor(MASKCOLOR));
    if(load){
        KSImageData->ChipSetCursor->DrawChipToTBitmap(Bitmap_TempChip, x, y, CURSOR_LOAD, GRAPHDEGREE_N, TColor(MASKCOLOR));
    }
    if(actioned){
        KSImageData->ChipSetCursor->DrawChipToTBitmap(Bitmap_TempChip, x, y, CURSOR_END, GRAPHDEGREE_N, TColor(MASKCOLOR));
    }
    canvas->CopyRect(TRect(x, y, x+GRAPHDEGREE_N, y+GRAPHDEGREE_N), tempCanvas, r);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawUnitWithStatus(int zx,int zy,int graph,bool load,bool actioned)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    DrawUnitChip(x,y,graph);
    if(load)
        DrawCursor(x,y,CURSOR_LOAD);
    if(actioned)
        DrawCursor(x,y,CURSOR_END);
    return 0;
}
//---------------------------------------------------------------------------
//J[\P`iW̎wj
__fastcall FieldScreen::DrawCursor(int x, int y, int index)
{
    return KSImageData->ChipSetCursor->DrawChipToTBitmap(Bitmap, x - Viewport.LeftTop.x, y - Viewport.LeftTop.y, index, GraphDegree, TColor(MASKCOLOR));
}
//---------------------------------------------------------------------------
//J[\P`i_W̎wj
__fastcall FieldScreen::DrawCursorZ(int zx,int zy,int index)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    DrawCursor(x,y,index);
    return 0;
}
//---------------------------------------------------------------------------
//ŁEvEė摜P`iW̎wj
__fastcall FieldScreen::DrawCrash(int x, int y, int index)
{
    return KSImageData->ChipSetCrash->DrawChipToTBitmap(Bitmap, x - Viewport.LeftTop.x, y - Viewport.LeftTop.y, index, GraphDegree, TColor(MASKCOLOR));
}
//---------------------------------------------------------------------------
//P`iW̎wj
__fastcall FieldScreen::DrawFigure(int x,int y,int index,int color)
{
    ImageList_Figure->Draw(Bitmap->Canvas, x - Viewport.LeftTop.x, y  - Viewport.LeftTop.y, index+color*FIGURECOUNT);
    return 0;
}
//---------------------------------------------------------------------------
//l`iW̎wj100ȏ͑S100\
__fastcall FieldScreen::DrawValue(int x,int y,int value,int color)
{
    int index[2]={10,11};

    if(value<100){
        index[0]=(value%100)/10;
        index[1]=value%10;
    }
    if(index[0])
        DrawFigure(x,y,index[0],color);
    DrawFigure(x+GraphDegree/2,y,index[1],color);
    return 0;
}
//---------------------------------------------------------------------------
//l`i_W̎wj
__fastcall FieldScreen::DrawValueZ(int zx,int zy,int value,int color)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    DrawValue(x,y,value,color);
    return 0;
}
//---------------------------------------------------------------------------
// T[tFCXRs[BXN[o[ƑSB
__fastcall FieldScreen::CopyToTCanvas(TCanvas *canvas)
{
    TRect r;

    r.Left = 0;
    r.Top = 0;
    r.Right = Viewport.OuterSize.cx;
    r.Bottom = Viewport.OuterSize.cy;
    canvas->CopyRect(r, Bitmap->Canvas, r);
    return 0;
}
//---------------------------------------------------------------------------
// ێT[tFCẌꕔ]B
// r ͓]̈B}bvP̋摜Ƃ݂Ȃ̍Ww肷B
// ̑ł̓XN[o[̗̈̓Rs[ȂB
__fastcall FieldScreen::CopyToTCanvas(TCanvas *canvas, const TRect& r)
{
    TRect r2;

    r2.Left = max(0, r.Left - Viewport.LeftTop.x);
    r2.Top  = max(0, r.Top - Viewport.LeftTop.y);
    r2.Right  = min(Viewport.InnerSize.cx, r.Right - Viewport.LeftTop.x);
    r2.Bottom = min(Viewport.InnerSize.cy, r.Bottom - Viewport.LeftTop.y);
    canvas->CopyRect(r2, Bitmap->Canvas, r2);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawViewportToTCanvas(TCanvas *canvas, int canvasw, int canvash)
{
    int w = Bitmap_Viewport->Width;
    int h = Bitmap_Viewport->Height;
    TRect r(0, 0, w, h);
    canvas->CopyRect(r, Bitmap_Viewport->Canvas, r);
    // ]hԂB
    canvas->Brush->Color = clBlack;
    if(w < canvasw){
        canvas->FillRect(TRect(w, 0, canvasw, canvash));
    }
    if(h < canvash){
        canvas->FillRect(TRect(0, h, canvash, canvash));
    }

    // ݂̃r[|[gʒu`悷B
    canvas->Pen->Mode = pmNot;
    const TPoint& lt = Viewport.LeftTop;
    const TSize& sz = Viewport.InnerSize;
    // ォEɍWwB
    TPoint plist[5];
    plist[0] = TPoint(lt.x/GraphDegree, lt.y/GraphDegree);
    plist[1] = TPoint((lt.x+sz.cx)/GraphDegree, lt.y/GraphDegree);
    plist[2] = TPoint((lt.x+sz.cx)/GraphDegree, (lt.y+sz.cy)/GraphDegree);
    plist[3] = TPoint(lt.x/GraphDegree, (lt.y+sz.cy)/GraphDegree);
    plist[4] = plist[0];
    canvas->Polyline(plist, 4); // ԈႢł͂ȂIQԖڂ͍̈Ō̓YB
    return 0;
}
//---------------------------------------------------------------------------
// w肵 TCanvas ɒn`Xe[^X`悷B
__fastcall FieldScreen::DrawGroundStatusToTCanvas(TCanvas *canvas,
    TColor backcolor,int x,int y,const MapStatus& gnd, const MapChip *gndInfop)
{
    char str[64];
    TColor front,back;

    canvas->Font->Name = "lr SVbN";
    canvas->Font->Pitch = fpFixed;
    canvas->Font->Size = FONT_SIZE;
    canvas->Brush->Color = backcolor;
    canvas->FillRect(canvas->ClipRect);

    DrawMapChipToTCanvas(canvas, x, y, gnd.Graphic, GRAPHDEGREE_N);
#if 1
    canvas->TextOut(x+40,y+4, gndInfop->Name); // 
#else
    char debug[32];
    sprintf(debug,"ID=%d,Type=%d", gndp->ID,gndp->Type);
    canvas->TextOut(x+40,y+4, debug); // ԍ
#endif
    sprintf(str,"n` %2d%%",gndInfop->Shield);
    canvas->TextOut(x+40,y+20,str);

    if(gndInfop->IsBuilding){
        if(gnd.Life < gndInfop->LifeMax/3){
            canvas->Font->Color = clRed;
            back = clPurple;
            front = clRed;
        }else{
            canvas->Font->Color = clWindowText;
            back = clOlive;
            front = clBlue;
        }
        sprintf(str, "Life %3d/%3d", gnd.Life, gndInfop->LifeMax);
        canvas->TextOut(x+4,y+36,str);
        DrawGage(canvas,x+80,y+36,40,12,
                 gnd.Life, gndInfop->LifeMax, front,back);
    }
    return 0;
}
//---------------------------------------------------------------------------
// w肵 TCanvas ɃjbgXe[^X`悷B
__fastcall FieldScreen::DrawUnitStatusToTCanvas(TCanvas *canvas,
    TColor backcolor,int x,int y,const UnitStatus *unitp,const UnitChip *unitInfop, bool drawLevel)
{
    char str[64];
    TColor front,back;

    canvas->Font->Name = "lr SVbN";
    canvas->Font->Pitch = fpFixed;
    canvas->Font->Size = FONT_SIZE;
    canvas->Brush->Color = backcolor;
    canvas->FillRect(canvas->ClipRect);

    DrawUnitChipToTCanvas(canvas, x, y, unitp->Graphic, GRAPHDEGREE_N);

    canvas->TextOut(x+40,y+4, unitInfop->Name); // 

    sprintf(str,"ړ %1d",unitInfop->MoveMax);
    canvas->TextOut(x+40,y+20,str);      // ړ

    // Ct
    // `F߂镔璷B
    // ɃQ[W悤Ȃ狤ʉlB
    const int lifemax = 100;
    if(unitp->Life < lifemax/3){
        canvas->Font->Color = clRed;
        back = clPurple;
        front = clRed;
    }else{
        canvas->Font->Color = clWindowText;
        back = clOlive;
        front = clBlue;
    }
    sprintf(str,"Life %3d/%3d",unitp->Life,lifemax);
    canvas->TextOut(x+4,y+40,str);
    DrawGage(canvas,x+80,y+40,40,12,unitp->Life,lifemax,front,back);

    // R
    if(unitp->Fuel < unitInfop->FuelMax/3){
        canvas->Font->Color = clRed;
        back = clPurple;
        front = clRed;
    }else{
        canvas->Font->Color = clWindowText;
        back = clGreen;
        front = clBlue;
    }
    sprintf(str,"R %3d/%3d",unitp->Fuel,unitInfop->FuelMax);
    canvas->TextOut(x+4,y+56,str);
    canvas->Font->Color = clWindowText;
    DrawGage(canvas,x+80,y+56,40,12,unitp->Fuel,unitInfop->FuelMax,front,back);

    y += 72;
    if(drawLevel){
        sprintf(str, "Lv.%2d", unitp->Level);
        canvas->TextOut(x+4, y, str);
        DrawGage(canvas,x+36, y, 27, 12, unitp->Experience, 100, clBlue, clNavy);
        sprintf(str, "%2d", unitp->Experience);
        canvas->TextOut(x+64, y, str);
        y += 16;
    }

    // ΊEe
    // \ȃXy[XΏȗB
    // ܂ȗȂcB
    if(canvas->ClipRect.Bottom < y+64)
        return 0;

    canvas->Font->Color = clWindowText;
    char s[32];
    for(int i=0;i<GUN_MAX;i++){
        if(!unitInfop->GunMax[i])
            break;
        canvas->TextOut(x+4,y,unitInfop->GunName[i]);
        sprintf(str,"%d/%d", unitp->GunRest[i], unitInfop->GunMax[i]);
        canvas->TextOut(x+4+88,y,str);

        RangeToText(s,unitInfop->MinRange[i],unitInfop->MaxRange[i],
                    unitInfop->Radius[i]);
        sprintf(str,"˒ %s", s);
        canvas->TextOut(x+4,y+15,str);
        y += 32;
    }

    return 0;
}
//---------------------------------------------------------------------------
// ڏ󋵕\B
__fastcall FieldScreen::DrawLoadingStatus(TCanvas *canvas, TColor backcolor,
    const UnitStatus& unit, const BaseData& base,
    const TSideStatusArray& sideStatus, int side, int selected)
{
    const UnitChip& unitInfo = base.GetUnitChipByType(unit.Type);

    FillCanvas(canvas, backcolor);
    if(!unitInfo.Loadable)
        return 0;
    canvas->Font->Color = clWindowText;
    canvas->TextOut(0, 0, "ڃjbg");
    int y = 16;
    for(int i=0; i<unitInfo.Loadable; i++){
        if(i<unit.Load){
            if(selected == i){
                canvas->Brush->Color = clHighlight;
                canvas->FillRect(Rect(0, y, canvas->ClipRect.Right, y+36));
                canvas->Font->Color = clHighlightText;
            }else{
                canvas->Brush->Color = backcolor;
                canvas->Font->Color = clWindowText;
            }
            const UnitStatus& loaded = sideStatus[side].Unit[unit.LoadingUnit[i]];
            DrawUnitChipToTCanvas(canvas, 2, y+2, loaded.Graphic, GRAPHDEGREE_N);
            // jbg
            canvas->TextOut(36, y+4, base.GetUnitChipByType(loaded.Type).Name);
            // Life
            AnsiString str;
            str.cat_sprintf("Life %2d", loaded.Life);
            canvas->TextOut(36, y+20, str);
        }
        canvas->Brush->Color = clBlack;
        canvas->FrameRect(TRect(0, y, canvas->ClipRect.Right, y+36));
        y += 36;
    }
    return 0;
}
//---------------------------------------------------------------------------
// ЂƂ̐wcɂāAe{ݐ`悷Bside=-1Ȃ璆{݁B
__fastcall FieldScreen::DrawBuildingCount(TCanvas *canvas,int side,
    const BaseData *baseData,const MapData *mapData)
{
    char str[16];
    vector<int> bcount;
    int tcount = baseData->GetGroundTypeCount()-1;

    bcount.resize(tcount);
    bcount.assign(bcount.size(), 0);
    int mw = mapData->GetWidth();
    int mh = mapData->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            const MapStatus& gnd = mapData->GetMapStatus(x, y);
            if(gnd.Owner==side)
                bcount[gnd.Type]++;
        }
    }

    int n=0;
    for(int i=0;i<tcount;i++){
        const MapChip& gndInfo = baseData->GetMapChipByType(i);
        if(!gndInfo.IsBuilding)
            continue;
        int x = (n%7)*52;
        int y = (n/7)*20;
        int graph = baseData->GetGroundGraphic(side,i);
//        KSImageData->ImageList_MapS->Draw(canvas,x,y,graph);
        DrawMapChipToTCanvas(canvas, x, y, graph, GRAPHDEGREE_S);
        sprintf(str,"%3d",bcount[n]);
        canvas->TextOut(x+18,y+2,str);
        n++;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::RangeToText(char *str,int minr,int maxr,int radius)
{
    char s[16];

    if(minr != maxr){
        sprintf(str,"%d-%d ",minr,maxr);
    }else{
        sprintf(str,"%d    ",minr);
    }

    if(radius > 1){
        sprintf(s,"[%d]",radius);
        strcat(str,s);
    }
    return 0;
}
//---------------------------------------------------------------------------
// Q[WBLife̎o\ɗpB
// TCanvas::Brush̒l͕ێB
__fastcall FieldScreen::DrawGage(TCanvas *canvas,int x,int y,int w,int h,
    int level,int maxlevel,TColor frontcolor,TColor backcolor)
{
    if(!maxlevel)
        return -1;
    TColor color = canvas->Brush->Color;
    // w
    canvas->Brush->Color = backcolor;
    canvas->FillRect(Rect(x,y,x+w,y+h));
    // o[
    int gw = level*(w-2)/maxlevel;
    if(gw > 1){
        canvas->Brush->Color = frontcolor;
        canvas->FillRect(Rect(x+1,y+1,x+1+gw,y+h-1));
    }
    canvas->Brush->Color = color;
    return 0;
}
//---------------------------------------------------------------------------
// _W->W
__fastcall FieldScreen::XY_MapToPhy(int MapX,int MapY,int *PhyX,int *PhyY) const
{
    *PhyX=MapX*GraphDegree;
    if(!(MapY%2))
        *PhyX+=GraphDegree/2;
    *PhyY=MapY*GraphDegree;
    return 0;
}
//---------------------------------------------------------------------------
//i}EXJ[\́jW->_W
__fastcall FieldScreen::XY_PhyToMap(const MapData *mapp,int PhyX,int PhyY,int *MapX,int *MapY) const
{
    PhyX += Viewport.LeftTop.x;
    PhyY += Viewport.LeftTop.y;

    *MapY=PhyY/GraphDegree;
    if(!(*MapY%2))
        PhyX-=GraphDegree/2;
    *MapX = PhyX/GraphDegree;
    if(*MapX < 0)
        *MapX=0;
    if(mapp->GetWidth() <= *MapX)
        *MapX = mapp->GetWidth()-1;
    if(*MapY<0)
        *MapY=0;
    if(mapp->GetHeight() <= *MapY)
        *MapY = mapp->GetHeight()-1;
    return 0;
}
//---------------------------------------------------------------------------
// ړ͈͂̒iʏj
__fastcall FieldScreen::GetMoveRange(TRangeLayer *layer, const MapData *mapp,
    const BaseData *baseDatap, const TSideStatusArray& sideStatus, const UnitStatus *unitp, int side, int zx, int zy) const
{
    layer->InitRange();
    RangeSearch(layer,mapp,baseDatap,sideStatus,unitp,side,zx,zy,false);
    return 0;
}
//---------------------------------------------------------------------------
// ړ͈͂̒i~ԁjRangePoint̏͂Ȃ
// ͓ڂẴjbg
__fastcall FieldScreen::GetLoadRange(TRangeLayer *layer, const MapData *mapp,
    const BaseData *baseDatap, const TSideStatusArray& sideStatus, const UnitStatus *unitp, int side, int zx, int zy) const
{
    for(int i=0;i<unitp->Load;i++)
        RangeSearch(layer,mapp,baseDatap,sideStatus,&sideStatus[side].Unit[unitp->LoadingUnit[i]],side,zx,zy,true);
    layer->GetRangeValue(zx,zy) = 0; //gɓځEU͂łȂ̂
    return 0;
}
//---------------------------------------------------------------------------
// ړ͈͂̒iڂ͌ĂяoȂj
// isUnload=false:ʏ true:~Ԏiړ͂Pj
__fastcall FieldScreen::RangeSearch(TRangeLayer *layer,const MapData *mapp,const BaseData *baseDatap,
                                    const TSideStatusArray& sideStatus, const UnitStatus *unitp,
                                    int side, int zx, int zy, bool isUnload) const
{
    const UnitChip& unitInfo = baseDatap->GetUnitChipByType(unitp->Type);
    int p;

    if(zx<0){
        if(isUnload)
            ShowMessage("Error:Wrong Range(move)");
        else{
            ShowMessage("Error:Wrong Range(load)");
            ShowMessage(unitInfo.ANFType);
        }
        return -1;
    }
    if(!isUnload)
        p=min(unitp->Fuel+1, unitInfo.MoveMax+1);
    else
        p=2;
    layer->GetRangeValue(zx,zy) = p;
    RangeTrace(layer, mapp, baseDatap, sideStatus, side, zx, zy, unitp->Type, isUnload);
    // ړɑ̃jbgꍇ̎𒲂ׂB
    // AE̊OȂ疳B
    int mw = mapp->GetWidth();
    int mh = mapp->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0; x<mw; x++){
            int& range = layer->GetRangeValue(x, y);
            if(!range || !mapp->GetVisible(x,y))
                continue;
            const MapStatus& ground = mapp->GetMapStatus(x, y);
            if(ground.Side == -1)
                continue;
            if(ground.Side == side){
                // ~Ԃ鎞͍ڂłȂB
                if(isUnload){
                    range = 0;
                    continue;
                }
                const UnitStatus *unit_t = &sideStatus[side].Unit[ground.UnitIndex];
                const UnitChip& unitInfoT = baseDatap->GetUnitChipByType(unit_t->Type);
                // ނ̃jbg͓ڂłȂB
                if(unitp->Type != unit_t->Type){
                    // ڏ̔B
                    if(!(unitInfoT.GroundFlag[ground.Type] & GROUND_CAN_LOAD) ||
                       !(unitInfo.GroundFlag[ground.Type] & GROUND_CAN_RIDE) ||
                       !unitInfoT.LoadUnit[unitp->Type] ||
                       unit_t->Load >= unitInfoT.Loadable){
                        range = 0;
                    }
                }
                else{
                    // ̏F~Ԃł͂ȂBǂƂڂĂȂB
                    // Ct̍vPOOȉB
                    if(unitp->Load || unit_t->Load || unitp->Life+unit_t->Life>100)
                        range = 0;
                }
            }
            else{
                //Gjbg鏊ɂ͈ړłȂB
                //A~Ԏ͍Uׂ͈͂׃NAȂB
                if(!isUnload)
                    range = 0;
            }
        }
    }
    layer->GetRangeValue(zx,zy) = p;
    return 0;
}
//---------------------------------------------------------------------------
// side=-1ȊOł͈ړ͈͂̒s
// stepRangePoinťWBbot[`pp~H
// sideStatue ZOC̎ɎgpB
__fastcall FieldScreen::RangeTrace(TRangeLayer *layer, const MapData *mapp, const BaseData *baseDatap,
    const TSideStatusArray& sideStatus,int side,int zx,int zy,int unitType,bool isUnload) const
{
    int x,y,i,power,consume;
    int groundType;
    bool currentCE=false;
    const UnitChip& unitInfo = baseDatap->GetUnitChipByType(unitType);

    power = layer->GetRangeValue(zx,zy);

    // ZOC[h̎́Aݒn_œGאڂĂ邩ׂB
    if(mapp->ZOCMode && !isUnload)
        currentCE = CirculationEnemy(mapp,baseDatap,sideStatus,zx,zy,side,unitType,false);
    for(i=0;i<6;i++){
        x = zx + NextDX[zy%2][i];
        y = zy + NextDY[i];
        if(x<0 || y<0 || x>=mapp->GetWidth() || y>=mapp->GetHeight())
            continue;
        //-1łȂSidew莞AGjbg͒ʂȂ
        //AE̊OɂȂ疳
        const MapStatus& gnd = mapp->GetMapStatus(x, y);
        if(side!=-1 && mapp->GetVisible(x,y)){
            if(gnd.Side!=-1 && side!=gnd.Side && sideStatus[gnd.Side].Friendly[side]<=0){
                continue;
            }
        }
        groundType = gnd.Type;
        if(!unitInfo.MoveLost[groundType])
            continue; //lOȂg[XȂ

        consume = unitInfo.MoveLost[groundType];
        //ZOCLȂړlςB
        if(mapp->ZOCMode && !isUnload)
            if(currentCE && (CirculationEnemy(mapp,baseDatap,sideStatus,x,y,side,unitType,false) || power<unitInfo.MoveMax+1))
                consume = max(consume,unitInfo.MoveMax);

        int& rp = layer->GetRangeValue(x,y);
        if(power-consume > rp){
            rp = power-consume;
            TPoint& p = layer->GetBack(x,y);
            p.x = zx;
            p.y = zy;
            RangeTrace(layer,mapp,baseDatap,sideStatus,side,x,y,unitType,isUnload);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// U͈͂̒B
// ĂȂ noMove=trueƂ
// ̒Ȃ counter=trueƂ
__fastcall FieldScreen::GetAttackRange(TRangeLayer *layer, const MapData *mapp,
    const BaseData *baseData, const UnitStatus *unitp,
    const TSideStatusArray& sideStatus,int side,int zx,int zy,bool noMove) const
{

    const UnitChip& unitInfo = baseData->GetUnitChipByType(unitp->Type);
    layer->InitRange();
    if(zx==-1)   //ԏԂł͍UłȂׁB
        return 0;
    if(unitInfo.SuperMissile){
        // X[p[~TC͑Ί͈̔͂ƂB
        GetNeighborRange(zx, zy, unitInfo.MinRange[0], unitInfo.MaxRange[0], layer);
    }else{
        // ԐڍUł͓̂ȂB
        if(noMove){
            for(int gun=0;gun<GUN_MAX;gun++){
                // e̎cʃ`FbNB
                if(!unitp->GunRest[gun]){
                    continue;
                }
                SelectAttackRange(layer, mapp, baseData, unitp, zx, zy, gun, sideStatus, side, noMove);
            }
        }
        else{
            for(int gun=0;gun<GUN_MAX;gun++){
                // e̎cʃ`FbNB
                if(!unitp->GunRest[gun]){
                    continue;
                }
                // ĂꍇAԐڍUΊ͎gpsiFCjB
                if(unitInfo.MinRange[gun] > 1)
                    continue;
                SelectAttackRange(layer, mapp, baseData, unitp, zx, zy, gun, sideStatus, side, noMove);
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::SelectAttackRange(TRangeLayer *layer, const MapData *mapp, 
    const BaseData *baseDatap,
    const UnitStatus *unitp, int zx, int zy, int gun, const TSideStatusArray& sideStatus, int side, bool noMove) const
{
    const UnitChip& unitInfo = baseDatap->GetUnitChipByType(unitp->Type);
    const int plistlen = NEIGHBOR_NEED_SIZE(16);
    POINT plist[plistlen];

    int r1 = unitInfo.MinRange[gun];
    int r2;
    if(noMove){
        r2 = unitInfo.MaxRange[gun] + 1;
    }else{
        r2 = 2;
    }
    int mw = mapp->GetWidth();
    int mh = mapp->GetHeight();
    int count = GetNeighborList(zx, zy, r1, r2, mw, mh, plist, plistlen);

    for(int pi=0;pi<count;pi++){
        int x = plist[pi].x;
        int y = plist[pi].y;
        const MapStatus& ground = mapp->GetMapStatus(x, y);
        // GjbgȂȂ΂Ƃ΂B
        if(!mapp->GetVisible(x, y) ||
           ground.Side==-1 ||
           ground.Side==side ||
           sideStatus[side].Friendly[ground.Side] > 0){
            continue;
        }
        int targettype = sideStatus[ground.Side].Unit[ground.UnitIndex].Type;
        int atk = unitInfo.Attack[gun][targettype];
        // RangePointɂǂ̉Ί킪g邩L^B
        if(atk){
            layer->GetRangeValue(x, y) |= (1<<gun);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//˒͈͂̒BAttackRangeSearch̊ȈՔŁB
//e͂̂ƂBɍŒ`ő˒𒲂ׂB
//˒͈͕\̂߂ɂ֐Ap~B
//p~ȐڍׂFixAttackRange()̃RgQƁB
// {̂TForm1::ShowUnitRange()ƔĂ̂Ŕp~ׂB}hNZ
__fastcall FieldScreen::FindAttackRange(TRangeLayer *layer,const BaseData *baseDatap,const UnitStatus *unitp)
{
//    int r1=1000,r2=0;
    const UnitChip& unitInfo = baseDatap->GetUnitChipByType(unitp->Type);

    layer->InitRange();
//    for(int i=0;i<GUN_MAX;i++){
//        if(unitInfo.GunMax[i]){
//            if(r2 < unitInfo.MaxRange[i])
//                r2 = unitInfo.MaxRange[i];
//            if(r1 > unitInfo.MinRange[i])
//                r1 = unitInfo.MinRange[i];
//        }
//    }
//    if(r2 == 0)
//        return 0;
//    // r1-r2 ͈̔͂ɃtO𗧂ĂB
//    GetNeighborRange(unitp->X, unitp->Y, r1, r2 + 1, layer);
    for(int i=0;i<GUN_MAX;i++){
        if(unitInfo.GunMax[i]){
            GetNeighborRange(unitp->X, unitp->Y, unitInfo.MinRange[i], unitInfo.MaxRange[i] + 1, layer);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//⋋͈͂̒B
//e⋋jbg̎͂ŁA⋋\ȃjbg鏊͑Să`FbNB
//RangePointɂ͕⋋tO̒lB
__fastcall FieldScreen::FindSupplyRange(TRangeLayer *layer, const MapData *mapp, const BaseData *baseDatap, const SideStatus *sidep, int side) const
{
    const UnitStatus *unitp;
    int x,y,num,i,n,type;

    layer->InitRange();
    for(num=0;num<sidep->UnitCount;num++){ //⋋jbgׂ̗𒲂ׂ
        unitp = &sidep->Unit[num];
        const UnitChip& unitInfo = baseDatap->GetUnitChipByType(unitp->Type);
        for(i=0;i<6;i++){
            x = unitp->X + NextDX[unitp->Y%2][i];
            y = unitp->Y + NextDY[i];
            if(x<0 || x>=mapp->GetWidth() || y<0 || y>=mapp->GetHeight())
                continue;
            int& rp = layer->GetRangeValue(x,y);
            const MapStatus& gnd = mapp->GetMapStatus(x, y);
            if(gnd.Side == side){
                n = gnd.UnitIndex;
                type = sidep->Unit[n].Type;
                //⋋\ȃjbgH
                rp |= unitInfo.SupplyFlag_Neighbor[type];
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::TraceRangeSimply(TRangeLayer *rangeLayer, const MapData *mapp, const UnitChip *unitInfop,
    int zx, int zy)
{
    int x,y,i,power,consume;
    int groundType;

    power = rangeLayer->GetRangeValue(zx,zy);
    for(i=0;i<6;i++){
        x = zx + NextDX[zy%2][i];
        y = zy + NextDY[i];
        if(x<0 || y<0 || x>=mapp->GetWidth() || y>=mapp->GetHeight())
            continue;
        const MapStatus& gnd = mapp->GetMapStatus(x, y);
        groundType = gnd.Type;
        if(!unitInfop->MoveLost[groundType])
            continue; //lOȂg[XȂ

        consume = unitInfop->MoveLost[groundType];

        int& rp = rangeLayer->GetRangeValue(x,y);
        if(power-consume > rp){
            rp = power-consume;
            TraceRangeSimply(rangeLayer, mapp, unitInfop, x, y);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//SẴjbg̎EBR̃jbg̎E_aB
// MapData::Visible ɂ̌ʂB
//__fastcall FieldScreen::FindVisibleAll(MapData *mapData, const BaseData *baseData, const SideStatus *sideStatus, int side) const
__fastcall FieldScreen::FindVisibleAll(MapData *mapData, const BaseData *baseData, const TSideStatusArray& sideStatusArray, int mySide) const
{
    //EB
    mapData->InitVisible(0);

    int sideCount = static_cast<int>(sideStatusArray.size());
    for(int side=0; side<sideCount; side++){
        const SideStatus& sideStatus = sideStatusArray[side];
        if(side != mySide && !sideStatus.Friendly[mySide]){
            continue;
        }

        // jbg̎Eg[X
        for(int i=0;i<sideStatus.UnitCount;i++){
            const UnitStatus& unit = sideStatus.Unit[i];
            if(unit.X != -1){
                const UnitChip& unitInfo = baseData->GetUnitChipByType(unit.Type);
                FindVisible(mapData, unit.X, unit.Y, unitInfo.Visibility+1, 1);
            }
        }

        int mw = mapData->GetWidth();
        int mh = mapData->GetHeight();
        for(int y=0;y<mh;y++){
            for(int x=0; x<mw; x++){
                const MapStatus& gnd = mapData->GetMapStatus(x, y);
                if(gnd.Owner == side){
                    const MapChip& gndInfo = baseData->GetMapChipByType(gnd.Type);
                    FindVisible(mapData, x, y, gndInfo.Visibility+1, 1);
                }
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//x,yɋ郆jbg̎E𒲍B
//E MapData::Visible  point ZB
__fastcall FieldScreen::FindVisible(MapData *mapData,int x,int y,int range,int point) const
{
    const int listsize = 1024;
    POINT plist[listsize];
    int len,px,py;

    len = GetNeighborList(x, y, 0, range, mapData->GetWidth(), mapData->GetHeight(), plist, listsize);
    for(int i=0;i<len;i++){
        const POINT& p = plist[i];
        mapData->GetVisible(p.x, p.y) += point;
    }
    return 0;
}
//---------------------------------------------------------------------------
//̎͂ɍU\ȓGjbg邩B 1,Ȃ 0
//͎̍WƏwcAjbg̎
//Vision=true:EO𖳎Ȃ false:
__fastcall FieldScreen::CirculationEnemy(const MapData *mapData,const BaseData *baseDatap,const TSideStatusArray& sideStatus,int zx,int zy,int side,int unitType,bool vision) const
{
    for(int i=0;i<6;i++){
        int x = zx+NextDX[zy%2][i];
        int y = zy+NextDY[i];
        if(x<0 || y<0 || x>=mapData->GetWidth() || y>=mapData->GetHeight())
            continue;
        if(vision){
            //ۂ̈ړpBE̒̃jbg͉߂ă`FbNȂB
            if(mapData->GetVisible(x, y))
                continue;
        }
        else{
            //ړ͈͎擾pBEOȂ狏Ȃ̂ƓB
            if(!mapData->GetVisible(x, y))
                continue;
        }

        const MapStatus& gnd = mapData->GetMapStatus(x, y);
        //ɍU\ȓGjbg邩`FbN
        if(gnd.Side!=-1 && side!=gnd.Side){
            const SideStatus *sidep = &sideStatus[gnd.Side];
            if(sidep->Friendly[side] <= 0){
                const UnitStatus& enemy = sidep->Unit[gnd.UnitIndex];
                const UnitChip& enemyInfo = baseDatap->GetUnitChipByType(enemy.Type);
                if(SelectGun(enemy, enemyInfo, unitType, 0xff, true) != -1)
                    return 1;
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::CallLuaFunction(lua_State *L, const char *func, double arg, double *ret) const
{
    lua_pushstring(L, func);   // ֐B
    lua_gettable(L, LUA_GLOBALSINDEX);
    if(lua_isnil(L, -1)){
        lua_pop(L, 1);
        AnsiString str;
        str.cat_sprintf("xF_[WvZő݂ȂLua֐ %s ĂяoƂ܂B", func);
        ShowMessage(str);
        return -1;
    }
    lua_pushnumber(L, arg);  // PԖڂ̈B
    lua_pcall(L, 1, 1, 0);
    if(lua_isnumber(L, -1)){
        *ret = lua_tonumber(L, -1);
        return 0;
    }
    else{
        // G[NꍇAG[bZ[WoB
        if(lua_isstring(L, -1)){
            ShowMessage(lua_tostring(L, -1));
        }
        else{
            // G[ł͂ȂAlȊOԂėxB
            ShowMessage("xF֐lԂ܂łB");
        }
        return -1;
    }
}
//---------------------------------------------------------------------------
//_[W̌vZB
//Ujbg̎ށEԋyсAUjbg̎ނ
//Ũ_[W߂B
//discrease=true Ȃ_[W͌iU󂯂jB
__fastcall FieldScreen::CalcDamage(const MapData *mapData, const BaseData *baseData, const UnitStatus *attackUnit, const UnitStatus *targetUnit,
    int *gunType,int gunFlag,bool discrease,bool ignoreLife,bool damageFix) const
{
    int damage,disDamage,effect=0;

    const UnitChip& unitInfoT = baseData->GetUnitChipByType(targetUnit->Type);
    if(unitInfoT.ANFType == UnitChip::Army){
        int gndType = mapData->GetMapStatus(targetUnit->X, targetUnit->Y).Type;
        effect = baseData->GetMapChipByType(gndType).Shield;
    }
    const UnitChip& unitInfoA = baseData->GetUnitChipByType(attackUnit->Type);
    *gunType = SelectGun(*attackUnit, unitInfoA, targetUnit->Type, gunFlag);
    if(*gunType == -1)
        return 0;
    damage = unitInfoA.Attack[*gunType][targetUnit->Type];

    if(baseData->GetLuaStateLevelUp() != NULL){
        lua_State *L = baseData->GetLuaStateLevelUp();
        double da=1.0, dd=1.0;
        if(!unitInfoA.LevelUpAttackFunc.empty()){
            CallLuaFunction(L, unitInfoA.LevelUpAttackFunc.c_str(), attackUnit->Level, &da);
        }
        if(!unitInfoT.LevelUpDamageFunc.empty()){
            CallLuaFunction(L, unitInfoT.LevelUpDamageFunc.c_str(), targetUnit->Level, &dd);
        }
        damage = static_cast<int>(da*damage*dd);
    }

    if(!ignoreLife){
        damage *= attackUnit->Life;
        damage /= 100;
    }
    //ɂ_[W̌B
    if(discrease){
        disDamage = damage/2;
        if(disDamage>10)
            disDamage=10;
        damage -= disDamage;
    }
    damage -= damage*effect/100; //n`ʁB
    if(damageFix && damage > targetUnit->Life)
        damage = targetUnit->Life;
    return damage;
}
//---------------------------------------------------------------------------
//\B\ȂΊCfbNXBs\Ȃ-1
__fastcall FieldScreen::CanCounter(const UnitStatus *attackUnit, const UnitStatus *targetUnit, const UnitChip& targetInfo) const
{
    int atMax=0, gunType=-1;

    if(targetInfo.SuperMissile)
        return -1;
    for(int gun=0;gun<GUN_MAX;gun++){
        //Œ˒Pȉ̉ΊjbgȂ甽\B
        if(!targetUnit->GunRest[gun] || targetInfo.MinRange[gun] > 1)
            continue;
        if(targetInfo.Attack[gun][attackUnit->Type] <= atMax)
            continue;
        if(IsNeighbor(targetUnit->X, targetUnit->Y,
                      attackUnit->X, attackUnit->Y,
                      targetInfo.MaxRange[gun])){
            atMax = targetInfo.Attack[gun][attackUnit->Type];
            gunType = gun;
        }
    }
    return gunType;
}
//---------------------------------------------------------------------------
// gpΊ̑I -1:gp\ȉΊ킪
// flagɂ͎gp\ȉΊBflag |= 1<<UsableGun
__fastcall FieldScreen::SelectGun(const UnitStatus& unit, const UnitChip& unitInfo, int targetType, int flag, bool isZOC) const
{
    int maxAtk=0,gunType=-1;

    // e򂪎cĂă_[W̑傫I
    for(int gun=0;gun<GUN_MAX;gun++){
        if(flag & (1<<gun)){
            if(isZOC && unitInfo.MinRange[gun]>1){
                continue;
            }
            if(unit.GunRest[gun] && maxAtk < unitInfo.Attack[gun][targetType]){
                maxAtk = unitInfo.Attack[gun][targetType];
                gunType = gun;
            }
        }
    }
    return gunType;
}
//---------------------------------------------------------------------------
// SWƔaw肵ÃwNXɂ~܂`߂B
__fastcall FieldScreen::GetCircleRect(TRect *rect,int cx,int cy,int radius,int w,int h)
{
    const int listsize = 256;
    POINT plist[listsize];
    int len,px,py;

    // ~̌`̃wNXXg̍Waċ߂ĂB
    // Ɛ^ʖڂɌ悭vZł邾낤APȕmƂƂŁB
    memset(rect,0,sizeof(TRect));
    len = GetNeighborList(cx,cy,radius,radius+1,w,h,plist,listsize);
    for(int i=0;i<len;i++){
        const POINT& p = plist[i];
        XY_MapToPhy(p.x, p.y, &px, &py);
        GetOrRect(rect,px,py,GraphDegree,GraphDegree);
    }
    return 0;
}
//---------------------------------------------------------------------------
//RangePoint>0̕ɕ`悷ƂƂA܂ދ`̈߂
//߂l͕`ӏ̐
__fastcall FieldScreen::GetDrawRect(const TRangeLayer *layer,TRect *r)
{
    int x,y,p,q,count=0;

    *r = Rect(10000,10000,0,0);
    int w = layer->GetWidth();
    int h = layer->GetHeight();
    for(y=0;y<h;y++){
        for(x=0;x<w;x++){
            if(layer->GetRangeValue(x, y)){
                XY_MapToPhy(x,y,&p,&q);
                p -= Viewport.LeftTop.x;
                q -= Viewport.LeftTop.y;
                GetOrRect(r,p,q,GraphDegree,GraphDegree);
                count++;
            }
        }
    }
    return count;
}
//---------------------------------------------------------------------------
//`ɋ`aB
__fastcall FieldScreen::GetOrRect(TRect *r,int x,int y,int w,int h)
{
    if(r->Left > x)
        r->Left = x;
    if(r->Top > y)
        r->Top = y;
    if(r->Right < x+w)
        r->Right = x+w;
    if(r->Bottom < y+h)
        r->Bottom = y+h;
    return 0;
}
//---------------------------------------------------------------------------
// imgctl.dll gTBitmapɉ摜ǂݍށBt@C͊gqK{B
__fastcall KS_LoadFromImgctl(Graphics::TBitmap *bmp, const char *file)
{
    HDIB hDIB = NULL;

    int len = strlen(file);
    const char *ext = &file[len-3];
    if(!strcmpi(ext,"bmp")){
        bmp->LoadFromFile(file);
        return 0;
    }
    else if(!strcmpi(ext,"png")){
        hDIB = PNGtoDIB(file);
    }
    else if(!strcmpi(ext,"jpg")){
        hDIB = JPGtoDIB(file);
    }
    if(!DIBto24Bit(hDIB))
        ShowMessage("DIB24bitɎs܂B");

    BITMAPINFO *pbmi;
    BYTE *pData;
    DWORD dwbmiSize = 0, dwDataSize = 0;  // 0Ă
    BOOL bRes;

    // KvȃTCY擾(֐͎̂s)
    GetDIB(hDIB, NULL, &dwbmiSize, NULL, &dwDataSize);

    // ̃TCYm
    pbmi = (LPBITMAPINFO)malloc(dwbmiSize);
    pData = (LPBYTE)malloc(dwDataSize);
    // hbgC̖ɁÃC̃oCgS̔{ɂ邽߂
    // lߕ悤B

    // ۂɎ擾
    bRes = GetDIB(hDIB, pbmi, &dwbmiSize, pData, &dwDataSize);
    if (!bRes) {
        free(pbmi);
        free(pData);
        ShowMessage("DIBe̎擾Ɏs܂B");
        return -1;
    }
    BITMAPINFOHEADER *bmiHead = &pbmi->bmiHeader;

    int w,h,padding;
    char *p = (char *)pData;
    bmp->PixelFormat = pf24bit;
    bmp->Width  = w = bmiHead->biWidth;
    bmp->Height = h = bmiHead->biHeight;
    padding = (w*3)%4;
    if(padding)
        padding = 4-padding;
    for(int y=0;y<h;y++){
        char *line = static_cast<char *>(bmp->ScanLine[h-y-1]);
        for(int x=0;x<w;x++){
            *line++ = *p++;
            *line++ = *p++;
            *line++ = *p++;
        }
        p+=padding;
    }
    free(pbmi);
    free(pData);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall KS_ResizeSideStatusArray(TSideStatusArray& sideStatus, int size)
{
    sideStatus.resize(size);
    for(int side=0;side<size;side++){
        sideStatus[side].Friendly.resize(size);
    }
    return 0;
}
//---------------------------------------------------------------------------
// jbg/n``CSVt@CTēǂݍށB
// ݂̃pXiŌɃt@C_CAOŊJfBNgj܂TA
// ɋǒn헪CXg[fBNgTB
__fastcall GBW_LoadBaseData(const char *file, BaseData *baseData, TKSOption *option, bool isGame)
{
    const char *csvfile = FILE_DEFAULTCSV;
    char path[MAX_PATH];

    if(file[0] != '\0')
        csvfile = file;
    if(KS_GetFilePath(path,csvfile,option) == -1)
        return -1;
    int i = baseData->LoadFromCSV(path);
    if(i != -1){
        if(isGame && baseData->LevelUpScriptFile[0] != '\0'){
            if(KS_GetFilePath(path, baseData->LevelUpScriptFile, option) != -1){
                lua_State *L = KSLua_LoadLua(path);
                if(L != NULL){
                    baseData->SetLuaStateLevelUp(L);
                }
            }
        }
    }
    return i;
}
//---------------------------------------------------------------------------
// BaseData̓eɏ]ăOtBbNǂݍށB
// GBW_LoadBaseData()ƓlÃ݂pXɖ΃CXg[tH_ŒTB
static __fastcall GBW_LoadGraphic(TKSImageData *GBWImage, BaseData *baseData, TKSOption *option, const MapData *mapData)
{
    // LqĂWő̂̂TA̕܂łǂݍށB
    int gndh=0;
    int gcount = baseData->GetGroundTypeCount();
    for(int num=0; num<gcount; num++){
        const MapChip& gndInfo = baseData->GetMapChipByType(num);
        int sides;
        if(gndInfo.IsBuilding){
            sides = baseData->Sides+1;
        }else{
            sides = 1;
        }
        for(int side=0; side<sides; side++){
            int gy = gndInfo.GraphicY[side];
            if(gndh < gy+1)
                gndh = gy+1;
        }
    }

    int unith=0;
    int tcount = baseData->GetUnitTypeCount();
    for(int num=0; num<tcount; num++){
        const UnitChip& unitInfo = baseData->GetUnitChipByType(num);
        for(int side=0;side<baseData->Sides;side++){
            int gy = unitInfo.GraphicY[side];
            if(unith < gy+1)
                unith = gy+1;
        }
    }

    char *defbmp=FILE_DEFAULTBMP, *file=baseData->BitmapFile;
    char path[MAX_PATH];

    if(file[0] == '\0')
        file = defbmp;
    if(!strcmp(file,"default.bmp"))
        strcpy(file,"default.png");
    if(KS_GetFilePath(path,file,option) == -1){
        return -1;
    }

    // wi摜̓ǂݍ݁B
    if(mapData->BGImageFile[0] != '\0'){
        KS_LoadFromImgctl(GBWImage->Bitmap_BGImageN, mapData->BGImageFile);
        if(!GBWImage->Bitmap_BGImageN->Empty){
            // kł쐬B
            int nw = GBWImage->Bitmap_BGImageN->Width;
            int nh = GBWImage->Bitmap_BGImageN->Height;
            GBWImage->Bitmap_BGImageS->Width = nw/2;
            GBWImage->Bitmap_BGImageS->Height = nh/2;
            GBWImage->Bitmap_BGImageS->Canvas->CopyRect(
                    TRect(0, 0, nw/2, nh/2), GBWImage->Bitmap_BGImageN->Canvas,
                    TRect(0, 0, nw, nh));
        }
    }

    return GBWImage->LoadFromFile(path,
        baseData->GroundGraphicX, baseData->GroundGraphicY, gndh,
        baseData->UnitGraphicX,baseData->UnitGraphicY, unith);
}
//---------------------------------------------------------------------------
// VXegpOtBbNǂݍށB
// GBW_LoadBaseData()ȂǂƓl̃pXsB
__fastcall GBW_LoadSystemGraphic(TKSImageData *GBWImage,TKSOption *option)
{
    const char *file=FILE_SYSTEMBMP;
    char path[MAX_PATH];

    if(KS_GetFilePath(path,file,option) == -1)
        return -1;
    return GBWImage->LoadSystemGraphic(path);
}
//---------------------------------------------------------------------------
__fastcall GBW_LoadBaseAll(const MapData *mapData, TKSImageData *GBWImage, BaseData *baseData, TKSOption *option, bool isGame)
{
    if(GBW_LoadBaseData(mapData->UnitDataFile, baseData, option, isGame) == -1){
        MessageBox(0,"CSV̓ǂݍ݂Ɏs܂B",0,MB_ICONSTOP|MB_OK);
        return -1;
    }else if(GBW_LoadGraphic(GBWImage, baseData, option, mapData) == -1){
        MessageBox(0,"摜̓ǂݍ݂Ɏs܂B",0,MB_ICONSTOP|MB_OK);
        return -1;
    }
    return 0;
}
//---------------------------------------------------------------------------
// {́CGfB^ʂ̃}bvZ[u֐B
__fastcall GBW_SaveGame(const char *file, const MapData *map, GameSituation *situation,
    TSideStatusArray& sideStatus, const BaseData *baseData)
{
    TDataTable *table = new TDataTable();
    char ctg[50];
    int side;

    table->SetCategory(CTG_SAVEPROPERTY);
    table->Put(KEY_SAVEVERSION, SAVEVERNUMBER);

    if(situation != NULL){
        table->SetCategory(CTG_SITUATION);
        situation->WriteText(table);
    }
    table->SetCategory(CTG_MAPDATA);
    map->WriteText(table);

    for(side=0;side<baseData->Sides;side++){
        sprintf(ctg,"%s%d",CTG_SIDESTATUS,side);
        table->SetCategory(ctg);
        sideStatus[side].WriteText(table, side);
    }

    table->SaveToFile(file);
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
// isGame==false ̏ꍇAGfB^ɂ郍[hłB
__fastcall GBW_LoadGame(const char *file, MapData **mapData, GameSituation *situation,
    TSideStatusArray& sideStatus,BaseData *baseData,TKSOption *option,TKSImageData *GBWImage, bool isGame)
{
    TDataTable *table = new TDataTable();
    char ctg[50];
    int side,ver=0;

    // w肳ꂽt@CtpX̏ꍇ́Ãt@C
    // ꏊJgfBNgɂB
    char title[MAX_PATH];
    if(GetFileTitle(file,title,MAX_PATH) == 0){
        int len_f = strlen(file);
        int len_t = strlen(title);
        if(len_t < len_f){
            char dir[MAX_PATH];
            strcpy(dir,file);
            dir[len_f-len_t-1] = '\0';
            SetCurrentDirectory(dir);
        }
    }

    table->LoadFromFile(file);

    table->GetCategory(CTG_SAVEPROPERTY);
    table->Get(KEY_SAVEVERSION,&ver);
    if(ver < 120){
        MessageBox(0,"ǒn헪f[^łȂA1.xx̃f[^łB",0,MB_ICONSTOP|MB_OK);
        return -1;
    }

    if(situation != NULL){
        table->GetCategory(CTG_SITUATION);
        situation->ReadText(table);
    }
    table->GetCategory(CTG_MAPDATA);
    int w,h;
    table->Get(KEY_MAPWIDTH, &w);
    table->Get(KEY_MAPHEIGHT, &h);
    MapData *map1 = new MapData(w, h);
    map1->ReadText(table);

    if(isGame && !map1->BGImageOnGame){
        map1->BGImageFile[0] = '\0';
    }

    GBW_LoadBaseAll(map1, GBWImage, baseData, option, isGame);

    KS_ResizeSideStatusArray(sideStatus, baseData->Sides);
    for(side=0;side<baseData->Sides;side++){
        sprintf(ctg,"%s%d",CTG_SIDESTATUS,side);
        table->GetCategory(ctg);
        sideStatus[side].ReadText(table, side);
        if(sideStatus[side].Friendly.size() < static_cast<unsigned>(baseData->Sides)){
            sideStatus[side].Friendly.resize(baseData->Sides);
        }
        sideStatus[side].Friendly[side] = 1;
    }
    delete table;

    // jbgyђn`ɑ΂AhcޔԍށB
    baseData->ApplyIDToAll(map1, sideStatus);
    // ݃jbg̏}bvɏށB
    GBW_PlaceUnitsToMap(map1,sideStatus,baseData->Sides);
    // Âo[Wł͎{݂łȂ̂Owner̒l܂Ă̂BȂB
    int mw = map1->GetWidth();
    int mh = map1->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0; x<mw; x++){
            MapStatus& gnd = map1->GetMapStatus(x, y);
            const MapChip& gndInfo = baseData->GetMapChipByType(gnd.Type);
            if(!gndInfo.IsBuilding){
                gnd.Owner = -2;
            }
        }
    }

    *mapData = map1;
    return 0;
}
//---------------------------------------------------------------------------
// }bvɁA݃jbg̏ށB
__fastcall GBW_PlaceUnitsToMap(MapData *map,TSideStatusArray& sideStatus,int sideMax)
{
    int side,num,zx,zy;

    for(side=0;side<sideMax;side++){
        for(num=0; num<sideStatus[side].UnitCount; num++){
            zx = sideStatus[side].Unit[num].X;
            zy = sideStatus[side].Unit[num].Y;
            if(zx != -1){ //ڂĂȂΔzu
                MapStatus& gnd = map->GetMapStatus(zx, zy);
                gnd.Side = side;
                gnd.UnitIndex = num;
            }
            /*else{
                sideStatus[side]->LoadUnit(gnd->Unit, num);
            }*/
        }
    }
    return 0;
}
//---------------------------------------------------------------------------

