//---------------------------------------------------------------------------
#include <vcl.h>
#include <time.h>
#pragma hdrstop

#include "gbwmail.h"
#include "nmail/nmail.h"
#include "../common/table.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm_Mail *Form_Mail;
//---------------------------------------------------------------------------
TMailPlayerList::TMailPlayerList(const char *path, TMailUser *muser)
{
    sprintf(MailPath,"%s\\Mail",path);
    MailUser = muser;
    NMailInitializeWinSock();
    NMailSetOption(NMAIL_OPTION_HEADER_MAX, MAIL_HEADERMAX);
    NMailSetOption(NMAIL_OPTION_BODY_MAX, MAIL_BODYMAX);
}
//---------------------------------------------------------------------------
TMailPlayerList::~TMailPlayerList(void)
{
    NMailEndWinSock();
}
//---------------------------------------------------------------------------
//tH_̖OXg^B߂l̓tH_Az񂪑Ȃ-1B
__fastcall TMailPlayerList::GetFolderList(char *folders[], int size)
{
    int i;

    if(size < PlayerMax)
        return -1;
    for(i=0;i<PlayerMax;i++)
        folders[i] = Player[i].Folder;
    return PlayerMax;
}
//---------------------------------------------------------------------------
//OtH_̃tpX^B
__fastcall TMailPlayerList::GetFolderPath(const char *dirname, char *path)
{
    sprintf(path,"%s\\%s",MailPath,dirname);
    return 0;
}
//---------------------------------------------------------------------------
//w肳ꂽpX̒fBNgSĒׁAvC[f[^镨
//sbNAbvB߂l͌vC[̐B
__fastcall TMailPlayerList::ReadMailFolder(void)
{
    WIN32_FIND_DATA fd;
    char filter[256];
    char pfile[256];
    HANDLE hFind;   //p̃nh

    PlayerMax = 0;
    if(CheckMailFolder() == -1)
        return -1;
    sprintf(filter, "%s\\*.*", MailPath);
    hFind = FindFirstFile(filter, &fd); //ŏ̃t@C
    if(hFind == INVALID_HANDLE_VALUE)
        return -1;

    do{ //MailtH_̃tH_ST
        if(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
            strcpy(Player[PlayerMax].Folder, fd.cFileName);
            sprintf(pfile, "%s\\%s\\profile.txt", MailPath, fd.cFileName);
            if(Player[PlayerMax].LoadFromFile(pfile) != -1)
                PlayerMax++;
            if(PlayerMax >= MAILPLAYER_MAX)
                break;
        }
    }while(FindNextFile(hFind,&fd));

    FindClose(hFind);  //nh
    return PlayerMax;
}
//---------------------------------------------------------------------------
//[tH_邩ǂmFāA΍A0ԂB
//tH_AtH_łȂA쐬Ɏs-1ԂB
__fastcall TMailPlayerList::CheckMailFolder(void)
{
    DWORD attrib;

    attrib = GetFileAttributes(MailPath);

    if((attrib==0xffffffff) && !CreateDirectory(MailPath,0))
        return -1;
    if(attrib | FILE_ATTRIBUTE_DIRECTORY)
        return 0;
    else
        return -1;
}
//---------------------------------------------------------------------------
//OtH_vC[NX̃|C^𓾂B
//ReadMailFolderɃtH_̖OύXE폜sĂȂOB
TMailPlayer* __fastcall TMailPlayerList::GetPlayer(char *dirname)
{
    int i;

    for(i=0;i<PlayerMax;i++)
        if(!strcmp(Player[i].Folder, dirname))
            break;
    if(i<PlayerMax)
        return &Player[i];
    else
        return 0;
}
//---------------------------------------------------------------------------
//[AhX烍OtH_𓾂B
//0AsȂ-1
__fastcall TMailPlayerList::GetFolderByAddress(char *dirname, const char *address)
{
    int i;

    for(i=0;i<PlayerMax;i++)
        if(!strcmp(Player[i].Address, address))
            break;
    if(i<PlayerMax){
        strcpy(dirname, Player[i].Folder);
        return 0;
    }
    else
        return -1;
}
//---------------------------------------------------------------------------
//OtH_w肵đΐ푊̏L^B
__fastcall TMailPlayerList::WritePlayerProfile(char *dirname)
{
    TMailPlayer *player;
    char path[MAX_PATH];

    player = GetPlayer(dirname);
    if(!player)
        return -1;
    GetFolderPath(dirname,path);
    strcat(path, "\\profile.txt");
    player->SaveToFile(path);
    return 0;
}
//---------------------------------------------------------------------------
//OtH_w肵đΐ푊̏ǂݍށBs-1
__fastcall TMailPlayerList::ReadPlayerProfile(char *dirname)
{
    TMailPlayer *player;
    char path[MAX_PATH];

    player = GetPlayer(dirname);
    if(!player)
        return -1;
    GetFolderPath(dirname,path);
    strcat(path, "\\profile.txt");
    player->LoadFromFile(path);
    return 0;
}
//---------------------------------------------------------------------------
//w肳ꂽOŐVvC[tH_쐬B
__fastcall TMailPlayerList::CreatePlayerFolder(char *dirname)
{
    char path[MAX_PATH];

    if(PlayerMax >= MAILPLAYER_MAX)
        return -1;
    Player[PlayerMax].Initialize();
    strcpy(Player[PlayerMax].Folder, dirname);
    PlayerMax++;
    GetFolderPath(dirname,path);
    if(!CreateDirectoryEx(MailPath,path,0))
        return -1;
    WritePlayerProfile(dirname);
    return 0;
}
//---------------------------------------------------------------------------
//OtH_B
__fastcall TMailPlayerList::RenamePlayerFolder(char *oldname,char *newname)
{
    char oldpath[MAX_PATH],newpath[MAX_PATH];

    GetFolderPath(oldname,oldpath);
    GetFolderPath(newname,newpath);
    if(rename(oldpath,newpath))
        return -1;
    return 0;
}
//---------------------------------------------------------------------------
//OtH_폜BTufBNgƎsB
__fastcall TMailPlayerList::DeletePlayerFolder(char *dirname)
{
    WIN32_FIND_DATA fd;
    HANDLE hFind;   //p̃nh
    char filter[MAX_PATH];
    char path[MAX_PATH];

    sprintf(filter, "%s\\%s\\*.*", MailPath, dirname);
    hFind = FindFirstFile(filter, &fd); //ŏ̃t@C
    if(hFind == INVALID_HANDLE_VALUE)
        return -1;

    do{ //폜tH_̃t@CST
        sprintf(path, "%s\\%s\\%s", MailPath, dirname, fd.cFileName);
        DeleteFile(path);
    }while(FindNextFile(hFind,&fd));
    FindClose(hFind);  //nh

    GetFolderPath(dirname,path);
    if(!RemoveDirectory(path))
        return -1;
    return 0;
}
//---------------------------------------------------------------------------
//OtH_w肵ă[𑗐MB0As-1
__fastcall TMailPlayerList::SendMail(char *dirname, const char *maptitle, char *body)
{
    TMailPlayer *player;
    char path[MAX_PATH],addfile[MAX_PATH],logfile[MAX_PATH],file[32];
    char subject[256],header[256]="",msg[256];
    int result;

    player = GetPlayer(dirname);
    if(!player)
        return -1;

    GetFolderPath(dirname,path);
    GetFolderPath("tmp.sav",addfile);

    sprintf(subject,"%s [%s]",MAIL_SUBJECT,maptitle);
    if(strcmp(MailUser->Address, MailUser->ReplyAddress))
        sprintf(header, "Reply-To: %s", MailUser->ReplyAddress);
    result = NMailSmtpSendMail(MailUser->SMTPServer,
                               player->Address, 0, 0,
                               MailUser->Address, subject,
                               body, header, addfile, 0);
    if(result != NMAIL_SUCCESS){
        sprintf(msg,"[MɎsFG[R[h %d",-result);
        ShowMessage(msg);
        return -1;
    }

    GetLogFileName(path,"s",file);
    //MbZ[WiATuWFNgA{jۑ
    sprintf(logfile,"%s\\%s.txt",path,file);
    FILE *fp = fopen(logfile,"w");
    if(!fp){
        ShowMessage("MO̕ۑɎs܂B");
        return 0;
    }
    fprintf(fp,"To: %s\n", player->Address);
    fprintf(fp,"Subject: %s\n", subject);
    fprintf(fp,"\n%s\n", body);
    fclose(fp);
    //Ytt@Cl[ĕۑ
    sprintf(logfile,"%s\\%s.sav",path,file);
    rename(addfile,logfile); 
    return 0;
}
//---------------------------------------------------------------------------
//OtH_w肵ă[MB
__fastcall TMailPlayerList::GetMail(char *dirname)
{
    SOCKET popsoc;
    char msg[256];
    char subject[256],date[128],from[128],header[MAIL_HEADERMAX],body[MAIL_BODYMAX];
    char savepath[MAX_PATH],path[MAX_PATH],file[MAX_PATH],addfile[MAX_PATH];
    char uidl[256];
    int mcount,result,i,start=1;
    TMailPlayer *player;

    player = GetPlayer(dirname);
    if(!player){
        ShowMessage("ۑtH_܂B");
        return -1;
    }
    GetFolderPath(dirname,savepath);

    popsoc = NMailPop3Connect(MailUser->POPServer);
    if(popsoc == INVALID_SOCKET){
        sprintf(msg,"[T[o %s ɐڑł܂łB",MailUser->POPServer);
        ShowMessage(msg);
        return -1;
    }
    mcount = NMailPop3Authenticate(popsoc, MailUser->POPUser, MailUser->POPPass, FALSE);
    if(mcount <= 0){
        NMailPop3Close(popsoc);
        if(mcount < 0){
            sprintf(msg,"F؂ɎsFG[R[h %d",-mcount);
            ShowMessage(msg);
        }
        return -1;
    }

    //OUIDL󕶎łȂΊebZ[WUIDLƔrA
    //vΓǂݎn߂郁bZ[Wԍi߂Biǂ΂j
    if(player->LastUIDL[0] != '\0'){
        for(i=1;i<=mcount;i++){
            if(NMailPop3GetUidl(popsoc,i,uidl,sizeof uidl) != NMAIL_SUCCESS)
                break;
            if(!strcmp(uidl, player->LastUIDL)){
                start = i+1;
                break;
            }
        }
    }

    //TuWFNgǒn헪̏o[ƈv΂_E[hB
    for(i=start;i<=mcount;i++){
        result = NMailPop3GetMailStatus(popsoc,i,subject,date,from,header,TRUE);
        if(result < 0){
            sprintf(msg,"[`FbNsFG[R[h %d",-result);
            ShowMessage(msg);
            break;
        }
        //̃AhX̃bZ[WIB
        if(strcmp(from,player->Address))
            continue;
        //TuWFNg̕Ŏn܂郁bZ[WIB
        if(strncmp(subject, MAIL_SUBJECT, (sizeof MAIL_SUBJECT)-1))
            continue;
        file[0] = '\0';
        result = NMailPop3GetMail(popsoc,i,subject,date,from,header,body,
                                  savepath,file);
        if(result < 0){
            sprintf(msg,"[擾sFG[R[h %d",-result);
            ShowMessage(msg);
            break;
        }
        //Ytt@CbZ[W͖
        if(file[0] == '\0'){
            ShowMessage("no file");
            continue;
        }
        //MBUIDLoĂB
        if(NMailPop3GetUidl(popsoc,i,uidl,sizeof uidl) == NMAIL_SUCCESS){
            strcpy(player->LastUIDL,uidl);
        }
        //Ytt@Cl[ĕۑ
        sprintf(addfile,"%s\\%s",savepath,file);
        GetLogFileName(savepath,"r",file);
        sprintf(path,"%s\\%s.sav",savepath,file);
        rename(addfile,path);
        //wb_ƃ{fBۑ
        sprintf(path,"%s\\%s.txt",savepath,file);
        if(SaveMail(path,header,body) == -1){
            ShowMessage("[̕ۑɎs܂B\n[̓T[o[Ɏc܂B");
            break;
        }
        if(!MailUser->SaveMessage)
            NMailPop3DeleteMail(popsoc,i);
    }
    NMailPop3Close(popsoc);
    WritePlayerProfile(dirname);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TMailPlayerList::SaveMail(char *path,char *header,char *body)
{
    FILE *fp;
    fp = fopen(path,"w");
    if(!fp)
        return -1;

//    fprintf(fp,"%s\n",header);
//    fprintf(fp,"%s\n",body);
    SaveTextLocalStyle(fp,header);
    fprintf(fp,"\n");
    SaveTextLocalStyle(fp,body);
    fclose(fp);
    return 0;
}
//---------------------------------------------------------------------------
//telnetsR[h̃eLXg[JsR[hŃt@CɏށB
//buff̓e͔j󂳂B
__fastcall TMailPlayerList::SaveTextLocalStyle(FILE *fp,char *buff)
{
    char *p=buff,*q=buff;

    for(;;p++){
        if(*p == '\r'){
            *p = '\0';
            fprintf(fp,"%s\n",q);
            p++;
            q = p+1;
        }
        else if(*p == '\0')
            break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//Ot@C߂B擪ɂheadtBgq͕tȂB
__fastcall TMailPlayerList::GetLogFileName(char *path,char *head,char *name)
{
    WIN32_FIND_DATA fd;
    char filter[MAX_PATH],scanarg[32];
    HANDLE hFind;   //p̃nh
    int index=0;

    sprintf(filter, "%s\\%s*.txt", path, head);
    sprintf(scanarg, "%s%%d.txt", head);
    hFind = FindFirstFile(filter, &fd); //ŏ̃t@C
    if(hFind != INVALID_HANDLE_VALUE){
        //Ot@C̍Ō̒ʂԍ𓾂B
        do{
            sscanf(fd.cFileName, scanarg, &index);
        }while(FindNextFile(hFind,&fd));
        FindClose(hFind);  //nh
    }
    sprintf(name, "%s%04d", head, index+1);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TMailPlayer::Initialize(void)
{
    strcpy(Name,"̖ݒ");
    strcpy(Address,"xxx@xxx.xxx");
    LastUIDL[0] = '\0';
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TMailPlayer::SaveToFile(char *file)
{
    TDataTable *table = new TDataTable();

    table->SetCategory(CTG_PROFILE);
    table->Put(KEY_NAME, Name);
    table->Put(KEY_ADDRESS, Address);
    table->Put(KEY_LASTUIDL, LastUIDL);
    if(table->SaveToFile(file) == -1)
        return -1;
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TMailPlayer::LoadFromFile(char *file)
{
    TDataTable *table = new TDataTable();

    if(table->LoadFromFile(file) == -1)
        return -1;
    table->GetCategory(CTG_PROFILE);
    table->Get(KEY_NAME, Name);
    table->Get(KEY_ADDRESS, Address);
    table->Get(KEY_LASTUIDL, LastUIDL);
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_Mail::TForm_Mail(TComponent* Owner)
    : TForm(Owner)
{
    Bitmap_Folder = new Graphics::TBitmap();

//    Bitmap_Folder->LoadFromResourceName(HInstance, "FOLDER");
}
//---------------------------------------------------------------------------
__fastcall TForm_Mail::~TForm_Mail(void)
{
    delete Bitmap_Folder;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::Button_NewClick(TObject *Sender)
{
    if(MailPlayerList->CreatePlayerFolder("VKΐ푊") == -1){
        ShowMessage("VKΐ푊̍쐬Ɏs܂B");
        return;
    }
    UpdateFolderList();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::Button_SaveClick(TObject *Sender)
{
    TMailPlayer *player;
    char dirname[MAX_PATH];

    //Xg̍ڂI΂ĂāAȂtH_IڂƈႦ
    //tH_̖OύXăXgXVB
    if(ListBox_Folder->ItemIndex != -1){
        strcpy(dirname,
            ListBox_Folder->Items->Strings[ListBox_Folder->ItemIndex].c_str());
        if(strcmp(dirname, Edit_Folder->Text.c_str())){
            MailPlayerList->RenamePlayerFolder(dirname, Edit_Folder->Text.c_str());
            strcpy(dirname, Edit_Folder->Text.c_str());
            UpdateFolderList();
        }
    }

    player = MailPlayerList->GetPlayer(dirname);
    if(!player)
        return;
    strcpy(player->Name, Edit_Name->Text.c_str());
    strcpy(player->Address, Edit_Address->Text.c_str());

    MailPlayerList->WritePlayerProfile(dirname);
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::Button_DeleteClick(TObject *Sender)
{
    char msg[256],dirname[MAX_PATH];

    if(ListBox_Folder->ItemIndex == -1)
        return;

    strcpy(dirname, ListBox_Folder->Items->Strings[ListBox_Folder->ItemIndex].c_str());
    sprintf(msg,"OtH_\"%s\"폜܂H",dirname);
    if(MessageDlg(msg, mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0)==mrNo)
        return;
    MailPlayerList->DeletePlayerFolder(dirname);
    UpdateFolderList();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::Button_GetMailClick(TObject *Sender)
{
    char dirname[64];

    Button_GetMail->Enabled = false;
    strcpy(dirname, Edit_Folder->Text.c_str());
    MailPlayerList->GetMail(dirname);
    UpdateProfile(dirname);
    Button_GetMail->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::Button_SendMailClick(TObject *Sender)
{
    char dirname[64];

    GetSelectedFolder(dirname);
    MailPlayerList->SendMail(dirname, SendMapTitle.c_str(), Memo_Message->Text.c_str());
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::Button_LoadGameClick(TObject *Sender)
{
    //IZ[ut@Cꎞt@CɃRs[B
    //Ō̈TRUEȂ̃t@C㏑ȂB
    CopyFile(SelectedSaveFile, StartFileName, FALSE);
    Result = true;
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::Button_StartGameClick(TObject *Sender)
{
    char dirname[64];
    TMailPlayer *player;

    GetSelectedFolder(dirname);
    player = MailPlayerList->GetPlayer(dirname);
    if(!player){
        ShowMessage("ۑtH_܂B");
        return;
    }
    if(player->Address[0] == '\0'){
        ShowMessage("̃[AhXݒ肳Ă܂B");
        return;
    }
    SelectedPlayer = player;
    Result = true;
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::Button_CancelClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::ListBox_FolderClick(TObject *Sender)
{
    char dirname[64];

    strcpy(dirname, ListBox_Folder->Items->Strings[ListBox_Folder->ItemIndex].c_str());
    UpdateProfile(dirname);
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::TabControl_MessageChange(TObject *Sender)
{
    char dirname[64];

    GetSelectedFolder(dirname);
    UpdateProfile(dirname);
}
//---------------------------------------------------------------------------
void __fastcall TForm_Mail::ListBox_MessageClick(TObject *Sender)
{
    char path[MAX_PATH],dirname[64],filename[32];

    GetSelectedFolder(dirname);
    MailPlayerList->GetFolderPath(dirname,path);
    sscanf(ListBox_Message->Items->Strings[ListBox_Message->ItemIndex].c_str(),
           "%s",filename);
    strcat(path, "\\");
    strcat(path, filename);
    Memo_Message->Lines->LoadFromFile(path);
    //gqtւ
    path[strlen(path)-3] = '\0';
    strcat(path,"sav");
    strcpy(SelectedSaveFile, path);
    Button_LoadGame->Enabled = true;
}
//---------------------------------------------------------------------------
//[tH_Xg̓eXVB
__fastcall TForm_Mail::UpdateFolderList(void)
{
    char *folders[64];
    int i,count;

    MailPlayerList->ReadMailFolder();
    count = MailPlayerList->GetFolderList(folders,64);
    ListBox_Folder->Clear();
    for(i=0;i<count;i++){
        ListBox_Folder->Items->Add(folders[i]);
    }
    if(count > 0 && Edit_Folder->Text.IsEmpty())
        Edit_Folder->Text = ListBox_Folder->Items->Strings[0];
    return 0;
}
//---------------------------------------------------------------------------
//vC[vt@C̕\eXVB
__fastcall TForm_Mail::UpdateProfile(char *dirname)
{
    TMailPlayer *player;
    char path[MAX_PATH];

    Edit_Folder->Text = dirname;
    player = MailPlayerList->GetPlayer(dirname);
    if(!player)
        return -1;
    MailPlayerList->GetFolderPath(dirname,path);
    Edit_Name->Text = player->Name;
    Edit_Address->Text = player->Address;
    if(Mode == startgame)
        Button_StartGame->Enabled = true;
    //tH_XgIȂ獀ڂTđIԂɂB
    if(ListBox_Folder->ItemIndex == -1){
        ListBox_Folder->ItemIndex = ListBox_Folder->Items->IndexOf(dirname);
    }

    WIN32_FIND_DATA fd;
    char filter[MAX_PATH],item[256];
    HANDLE hFind;   //p̃nh
    FILETIME localft;
    SYSTEMTIME localtm;

    ListBox_Message->Clear();
    if(TabControl_Message->TabIndex)
        sprintf(filter, "%s\\s*.txt", path);
    else
        sprintf(filter, "%s\\r*.txt", path);
    hFind = FindFirstFile(filter, &fd); //ŏ̃t@C
    if(hFind == INVALID_HANDLE_VALUE)
        return -1;

    do{
        FileTimeToLocalFileTime(&fd.ftCreationTime, &localft);
        FileTimeToSystemTime(&localft, &localtm);
        sprintf(item, "%s %04d/%02d/%02d %02d:%02d:%02d", fd.cFileName,
                localtm.wYear, localtm.wMonth, localtm.wDay,
                localtm.wHour, localtm.wMinute, localtm.wSecond);
        ListBox_Message->Items->Add(item);
    }while(FindNextFile(hFind,&fd));
    FindClose(hFind);  //nh

    return 0;
}
//---------------------------------------------------------------------------
//ݑI΂ĂfBNg𓾂B΋󕶎B
__fastcall TForm_Mail::GetSelectedFolder(char *dirname)
{
    strcpy(dirname, Edit_Folder->Text.c_str());
    return 0;
}
//---------------------------------------------------------------------------
//VK[ΐ̊Jnj[
__fastcall TForm_Mail::ShowStartGame(void)
{
    Caption = "[ΐ푊̐ݒEI";
    ListBox_Folder->Enabled = true;
    ListBox_Message->Enabled = false;
    Memo_Message->Enabled = false;

    Button_GetMail->Enabled = false;
    Button_SendMail->Enabled = false;
    Button_LoadGame->Enabled = false;
    Button_StartGame->Enabled = false;
    Button_Cancel->Enabled = false;
    Result = true;
    Mode = startgame;
    Edit_Folder->Text = "";
    UpdateFolderList();
    Memo_Message->Clear();
    return ShowModal();
}
//---------------------------------------------------------------------------
//[̑Mj[B̓}bvƑ̃[AhXB
__fastcall TForm_Mail::ShowSendMail(const string& maptitle, const char *address)
{
    char dirname[64];

    Caption = "[̑M";
    ListBox_Folder->Enabled = true;
    ListBox_Message->Enabled = false;
    Memo_Message->Enabled = true;
    Memo_Message->ReadOnly = false;

    Button_GetMail->Enabled = false;
    Button_SendMail->Enabled = true;
    Button_LoadGame->Enabled = false;
    Button_StartGame->Enabled = false;
    Button_Cancel->Enabled = false;
    SendMapTitle = maptitle;
    Result = true;
    Mode = sendmail;
    UpdateFolderList();

    if(MailPlayerList->GetFolderByAddress(dirname, address) == -1){
        ShowMessage("[AhXɑΉۑtH_܂B\nMj[tH_̐ݒsĉB");
        return -1;
    }
    UpdateProfile(dirname);
    Memo_Message->Lines->Text = "[{";
    return ShowModal();
}
//---------------------------------------------------------------------------
//[̃[hj[
__fastcall TForm_Mail::ShowLoadGame(void)
{
    Caption = "[̎ME[h";
    ListBox_Folder->Enabled = true;
    ListBox_Message->Enabled = true;
    Memo_Message->Enabled = true;
    Memo_Message->ReadOnly = true;

    Button_GetMail->Enabled = true;
    Button_SendMail->Enabled = false;
    Button_LoadGame->Enabled = false;
    Button_StartGame->Enabled = false;
    Button_Cancel->Enabled = true;
    Result = false;
    Mode = loadgame;
    MailPlayerList->GetFolderPath("tmp.sav",StartFileName);
    Edit_Folder->Text = "";
    UpdateFolderList();
    UpdateProfile(Edit_Folder->Text.c_str());
    Memo_Message->Clear();
    return ShowModal();
}
//---------------------------------------------------------------------------

