//---------------------------------------------------------------------------
#ifndef gbwmailH
#define gbwmailH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>

#include <stdio.h>
#include <string>
using namespace std;

#define MAILPLAYER_MAX 32
//[ΐ푊̃vt@CL[
#define CTG_PROFILE  "Profile"
#define KEY_NAME     "Name"
#define KEY_ADDRESS  "Address"
#define KEY_LASTUIDL "LastUIDL"

#define MAIL_SUBJECT "GBW Game Mail"
#define MAIL_HEADERMAX 1024
#define MAIL_BODYMAX 8192
//---------------------------------------------------------------------------
typedef struct{
    char Name[65];
    char Address[65];
    char ReplyAddress[65];
    char POPServer[65];
    char POPUser[65];
    char POPPass[65];
    char SMTPServer[65];
    char SMTPUser[65];
    bool SaveMessage;
}TMailUser;
//---------------------------------------------------------------------------
//
class TMailPlayer
{
private:
public:
    char Address[65];
    char Folder[33];
    char Name[33];
    char LastUIDL[256];     //ŌɎMbZ[WUIDL

    TMailPlayer(void){
    }
    __fastcall Initialize(void);
    __fastcall SaveToFile(char *);
    __fastcall LoadFromFile(char *);
};
//---------------------------------------------------------------------------
//
class TMailPlayerList
{
private:
    TMailPlayer Player[MAILPLAYER_MAX];
    int PlayerMax;
    char MailPath[MAX_PATH];     //[fBNg̃tpX
    TMailUser *MailUser;         //[T[o[g̐ݒ
    __fastcall SaveTextLocalStyle(FILE *,char *);
public:
    //ǒn헪̃CXg[pXn
    TMailPlayerList(const char *path, TMailUser *);
    ~TMailPlayerList(void);
    __fastcall Initialize(void);
    __fastcall GetFolderList(char *[],int);
    __fastcall GetFolderPath(const char *,char *);
    __fastcall ReadMailFolder(void);
    __fastcall CheckMailFolder(void);
    TMailPlayer* __fastcall GetPlayer(char *);
    __fastcall GetFolderByAddress(char *, const char *);
    __fastcall WritePlayerProfile(char *);
    __fastcall ReadPlayerProfile(char *);
    __fastcall CreatePlayerFolder(char *);
    __fastcall RenamePlayerFolder(char *,char *);
    __fastcall DeletePlayerFolder(char *);
    __fastcall SendMail(char *,const char *,char *);
    __fastcall GetMail(char *);
    __fastcall SaveMail(char *,char *,char *);
    __fastcall GetLogFileName(char *,char *,char *);
};
//---------------------------------------------------------------------------
enum TMailFormMode{startgame,sendmail,loadgame};
//---------------------------------------------------------------------------
class TForm_Mail : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TListBox *ListBox_Folder;
    TButton *Button_New;
    TButton *Button_Save;
    TButton *Button_Delete;
    TEdit *Edit_Address;
    TLabel *Label_Folder;
    TLabel *Label_Name;
    TEdit *Edit_Folder;
    TEdit *Edit_Name;
    TImage *Image_Map;
    TButton *Button_StartGame;
    TButton *Button_GetMail;
    TButton *Button_SendMail;
    TButton *Button_LoadGame;
    TButton *Button_Cancel;
    TTabControl *TabControl_Message;
    TListBox *ListBox_Message;
    TMemo *Memo_Message;
    void __fastcall Button_NewClick(TObject *Sender);
    void __fastcall Button_SaveClick(TObject *Sender);
    void __fastcall ListBox_FolderClick(TObject *Sender);
    void __fastcall Button_DeleteClick(TObject *Sender);
    void __fastcall Button_CancelClick(TObject *Sender);
    void __fastcall Button_StartGameClick(TObject *Sender);
    void __fastcall Button_SendMailClick(TObject *Sender);
    void __fastcall Button_GetMailClick(TObject *Sender);
    void __fastcall TabControl_MessageChange(TObject *Sender);
    void __fastcall ListBox_MessageClick(TObject *Sender);
    void __fastcall Button_LoadGameClick(TObject *Sender);
private:	// [U[錾
    Graphics::TBitmap *Bitmap_Folder;
    string SendMapTitle; //M[hŊJɃ}bv^Cg
    TMailFormMode Mode;
    char SelectedSaveFile[MAX_PATH];
    __fastcall GetSelectedFolder(char *);
    __fastcall UpdateFolderList(void);
    __fastcall UpdateProfile(char *);
public:		// [U[錾
    __fastcall TForm_Mail(TComponent* Owner);
    __fastcall ~TForm_Mail(void);
    __fastcall ShowStartGame(void);
    __fastcall ShowSendMail(const string& maptitle, const char *);
    __fastcall ShowLoadGame(void);
    TMailPlayerList *MailPlayerList;
    TMailPlayer *SelectedPlayer;
    bool Result;
//    char MailAddress[128];
    char StartFileName[MAX_PATH];
};
//---------------------------------------------------------------------------
extern PACKAGE TForm_Mail *Form_Mail;
//---------------------------------------------------------------------------
#endif
