#include <stdio.h>
#include <time.h>

#include "history.h"

//---------------------------------------------------------------------------
__fastcall THistoryList::Initialize(void)
{
    Count = 0;
    MaxCount = HISTORYLIST_MAX;
    memset(LastAccessTime,0,sizeof LastAccessTime);
    return 0;
}
//---------------------------------------------------------------------------
// 𕶎񃊃Xgւ̃|C^^Blen̓Xg̍ő咷B
// ߂l͊i[|C^̐B
__fastcall THistoryList::GetHistory(char *list[],int len)
{
    bool selected[HISTORYLIST_MAX];
    int i,count=0;
    // ̒ANZXVIŃXgɉĂB
    // Vv\[gɌA͍XPOxł邩悩낤B
    memset(selected,0,sizeof selected);
    for(;;){
        int maxtm=0,index=-1;
        for(i=0;i<HISTORYLIST_MAX;i++){
            if(LastAccessTime[i]>maxtm && !selected[i]){
                maxtm = LastAccessTime[i];
                index = i;
            }
        }
        if(index == -1)
            break;
        if(count == len)
            break;
        list[count] = HistoryString[index];
        count++;
        selected[index] = true;
    }
    return count;
}
//---------------------------------------------------------------------------
// ЂƂB𐔂MaxCount𒴂ꍇ͍łÂ폜B
__fastcall THistoryList::Add(const char *str)
{
    time_t tm = time(NULL);
    int i;

    // ɓ񂪂΁AŏIANZX̂ݍXVB
    for(i=0;i<HISTORYLIST_MAX;i++){
        if(LastAccessTime[i]>0 && !strcmp(str,HistoryString[i])){
            LastAccessTime[i] = (int)tm;
            return Count;
        }
    }

    if(Count == MaxCount){
        DeleteOldest();
    }
    for(i=0;i<HISTORYLIST_MAX;i++){
        if(!LastAccessTime[i]){
            LastAccessTime[i] = (int)tm;
            strcpy(HistoryString[i],str);
            Count++;
            return Count;
        }
    }
    // LastAccessTime̓eCountĂꍇBNȂ͂B
    return -1;
}
//---------------------------------------------------------------------------
// łÂЂƂ폜BΉȂB
__fastcall THistoryList::DeleteOldest(void)
{
    int index=-1,oldest=0;
    for(int i=0;i<HISTORYLIST_MAX;i++){
        if(LastAccessTime[i] > 0 &&
           (LastAccessTime[i] < oldest || !oldest)){
             oldest = LastAccessTime[i];
             index = i;
        }
    }
    if(index == -1)
        return -1;
    LastAccessTime[index] = 0;
    Count--;
    return 0;
}
//---------------------------------------------------------------------------
#define KEY_HL_LASTACCESS "LastAccessTime"
#define KEY_HL_STRING     "HistoryString"
// e[uɓeoB
// z̓e͑aAL^͘AȃCfbNXōsB
__fastcall THistoryList::SaveToTable(TDataTable *table)
{
    char key[64];
    int count=0;
    for(int i=0;i<HISTORYLIST_MAX;i++){
        if(LastAccessTime[i] > 0){
            sprintf(key,"%s%d",KEY_HL_LASTACCESS,count);
            table->Put(key,LastAccessTime[i]);
            sprintf(key,"%s%d",KEY_HL_STRING,count);
            table->Put(key,HistoryString[i]);
            count++;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall THistoryList::LoadFromTable(TDataTable *table)
{
    char key[64];
    int last,count=0;
    for(int i=0;i<HISTORYLIST_MAX;i++){
        // ڂLqĂǂݍށB
        sprintf(key,"%s%d",KEY_HL_LASTACCESS,count);
        if(table->Get(key,&last) == -1)
            break;
        LastAccessTime[i] = last;
        // ꉞA̕ǂ߂ȂꍇlB_oߕqB
        sprintf(key,"%s%d",KEY_HL_STRING,count);
        if(table->Get(key,HistoryString[count]) == -1){
            HistoryString[count][0] = '\0';
            LastAccessTime[i] = 0;
            break;
        }else{
            count++;
        }
    }
    Count = count;
    return 0;
}
