//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "kscheckattack.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_CheckAttack *Form_CheckAttack;
//---------------------------------------------------------------------------
__fastcall TForm_CheckAttack::TForm_CheckAttack(TComponent* Owner)
    : TForm(Owner), Map(2,1)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm_CheckAttack::FormConstrainedResize(TObject *Sender,
      int &MinWidth, int &MinHeight, int &MaxWidth, int &MaxHeight)
{
    MinWidth = ListBox_AttackUnit->Width + 16 + StringGrid_Damage->Width;
    MinHeight = 320;
}
//---------------------------------------------------------------------------
void __fastcall TForm_CheckAttack::FormCanResize(TObject *Sender,
      int &NewWidth, int &NewHeight, bool &Resize)
{
    ListBox_AttackUnit->Height = NewHeight - 143;
    Button_Check->Top = NewHeight - 88;
    Button_ReloadBaseData->Top = NewHeight - 56;
    Button_Close->Top = NewHeight - 56;
    ComboBox_GroundA->Top = ListBox_AttackUnit->Height + 7;
    ComboBox_GroundT->Top = ListBox_AttackUnit->Height + 7;
    Edit_LevelA->Top = ListBox_AttackUnit->Height + 31;
    Edit_LevelT->Top = ListBox_AttackUnit->Height + 31;
}
//---------------------------------------------------------------------------
void __fastcall TForm_CheckAttack::Button_CheckClick(TObject *Sender)
{
    if(ListBox_AttackUnit->ItemIndex == -1){
        ShowMessage("UjbgIŉB");
        return;
    }
    CheckAttackDamage();
}
//---------------------------------------------------------------------------
void __fastcall TForm_CheckAttack::Button_ReloadBaseDataClick(
      TObject *Sender)
{
    GBW_LoadBaseData(UnitDataFile, BaseDatap, Optionp, true);
    InitializeControl();
}
//---------------------------------------------------------------------------
void __fastcall TForm_CheckAttack::Button_CloseClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
__fastcall TForm_CheckAttack::Initialize(const FieldScreen *fs, BaseData *bd, TKSOption *option, const char *unitfile)
{
    FieldScreenp = fs;
    BaseDatap = bd;
    Optionp = option;
    UnitDataFile = unitfile;
    StringGrid_Damage->ColCount = GUN_MAX + 1;
    StringGrid_Damage->ColWidths[0] = 112;
    for(int i=1;i<=GUN_MAX;i++){
        StringGrid_Damage->ColWidths[i] = 76;
    }
    InitializeControl();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_CheckAttack::InitializeControl(void)
{
    int listindex = ListBox_AttackUnit->ItemIndex;
    int indexA = max(0, ComboBox_GroundA->ItemIndex);
    int indexT = max(0, ComboBox_GroundT->ItemIndex);
    ListBox_AttackUnit->Items->Clear();
    int tcount = BaseDatap->GetUnitTypeCount()-1;
    StringGrid_Damage->RowCount = tcount + 1;
    for(int unum=0; unum<tcount; unum++){
        const UnitChip& unitInfo = BaseDatap->GetUnitChipByType(unum);
        ListBox_AttackUnit->Items->Add(unitInfo.Name);
        StringGrid_Damage->Cells[0][unum+1] = unitInfo.Name;
    }
    int gcount = BaseDatap->GetGroundTypeCount()-1;
    for(int gnum=0; gnum<gcount; gnum++){
        const MapChip& gndInfo = BaseDatap->GetMapChipByType(gnum);
        AnsiString str;
        str.cat_sprintf("%6s %d%%", gndInfo.Name, gndInfo.Shield);
        ComboBox_GroundA->Items->Add(str);
        ComboBox_GroundT->Items->Add(str);
    }
    ListBox_AttackUnit->ItemIndex = listindex;
    ComboBox_GroundA->ItemIndex = indexA;
    ComboBox_GroundT->ItemIndex = indexT;
    if(Edit_LevelA->Text.ToIntDef(0) == 0){
        Edit_LevelA->Text = "0";
    }
    if(Edit_LevelT->Text.ToIntDef(0) == 0){
        Edit_LevelT->Text = "0";
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_CheckAttack::CheckAttackDamage(void)
{
    const UnitChip& unitInfoA = BaseDatap->GetUnitChipByType(ListBox_AttackUnit->ItemIndex);
    int gndTypeA = ComboBox_GroundA->ItemIndex;
    int gndTypeT = ComboBox_GroundT->ItemIndex;

    for(int gun=0;gun<GUN_MAX;gun++){
        if(unitInfoA.GunMax[gun]){
            StringGrid_Damage->Cells[gun+1][0] = unitInfoA.GunName[gun];
        }else{
            StringGrid_Damage->Cells[gun+1][0] = "";
        }
    }

    UnitStatus unitA;
    BaseDatap->InitializeUnitStatus(&unitA, 0, ListBox_AttackUnit->ItemIndex);
    unitA.X = 0;
    unitA.Y = 0;
    unitA.Level = Edit_LevelA->Text.ToIntDef(0);
    int tcount = BaseDatap->GetUnitTypeCount()-1;
    for(int unum=0; unum<tcount; unum++){
        UnitStatus unitT;
        BaseDatap->InitializeUnitStatus(&unitT, 1, unum);
        unitT.X = 1;
        unitT.Y = 0;
        unitT.Level = Edit_LevelT->Text.ToIntDef(0);
        Map.GetMapStatus(0, 0).Type = gndTypeA;
        Map.GetMapStatus(1, 0).Type = gndTypeT;
        for(int gun=0;gun<GUN_MAX;gun++){
            if(!unitInfoA.GunMax[gun]){
                StringGrid_Damage->Cells[gun+1][unum+1] = "";
                continue;
            }
            int gunType;
            int damage = FieldScreenp->CalcDamage(&Map, BaseDatap, &unitA, &unitT, &gunType, (1<<gun), false, false, false);
            StringGrid_Damage->Cells[gun+1][unum+1] = AnsiString(damage);
        }
    }

    return 0;
}
//---------------------------------------------------------------------------

