#include "ksdrawhdc.h"

static HMODULE hImgctl = NULL;
static DELETEDIB fpDeleteDIB = NULL;
static GETDIB fpGetDIB = NULL;
static TODIB fpToDIB = NULL;
static PASTEDIB fpPasteDIB = NULL;
static DIBTODC fpDIBtoDC = NULL;
static DIBTO24BIT fpDIBto24Bit;
static PNGTODIB fpPNGtoDIB;
static JPGTODIB fpJPGtoDIB;

// TCY(w,h)pixel(x,y)Wւ̃|C^̃}NB
#define PIXEL(pixel, w, h, x, y) ((pixel) + ((h) - (y) - 1)*(w) + (x))

//---------------------------------------------------------------------------
void KSDrawHDC_Init(void)
{
    hImgctl = LoadLibrary("System\\imgctl.dll");
    if(!hImgctl)
        return;
    fpGetDIB    = (GETDIB)   GetProcAddress(hImgctl, "GetDIB");
    fpToDIB     = (TODIB)    GetProcAddress(hImgctl, "ToDIB");
    fpDeleteDIB = (DELETEDIB)GetProcAddress(hImgctl, "DeleteDIB");
    fpDIBtoDC   = (DIBTODC)  GetProcAddress(hImgctl, "DIBtoDC");
    fpPasteDIB  = (PASTEDIB) GetProcAddress(hImgctl, "PasteDIB");
    fpDIBto24Bit= (DIBTO24BIT)GetProcAddress(hImgctl, "DIBto24Bit");
    fpPNGtoDIB =  (PNGTODIB)GetProcAddress(hImgctl, "PNGtoDIB");
    fpJPGtoDIB =  (JPGTODIB)GetProcAddress(hImgctl, "JPGtoDIB");
}
//---------------------------------------------------------------------------
void KSDrawHDC_End(void)
{
    if(hImgctl != NULL){
        FreeLibrary(hImgctl);
        hImgctl = NULL;
    }
}
//---------------------------------------------------------------------------
BOOL GetDIB(HDIBC hDIB, LPBITMAPINFO pbmi, DWORD *pdwbmiSize, LPVOID pvData, DWORD *pdwDataSize)
{
    return fpGetDIB(hDIB, pbmi, pdwbmiSize, pvData, pdwDataSize);
}
//---------------------------------------------------------------------------
HDIB ToDIB(const char *path)
{
    return fpToDIB(path);
}
//---------------------------------------------------------------------------
BOOL DeleteDIB(HDIB hDIB)
{
    return fpDeleteDIB(hDIB);
}
//---------------------------------------------------------------------------
BOOL PasteDIB(
    HDIB hDIBDest, long lXDest, long lYDest, long lWidth, long lHeight,
    HDIBC hDIBSrc, long lXSrc, long lYSrc, PASTEPROC pfnPasteProc,
    LPARAM lParam)
{
    return fpPasteDIB(hDIBDest, lXDest, lYDest, lWidth, lHeight, hDIBSrc, lXSrc, lYSrc, pfnPasteProc, lParam);
}
//---------------------------------------------------------------------------
BOOL DIBtoDC(
      HDC hdc, int nXDest, int nYDest, int nWidth, int nHeight,
      HDIBC hDIB, int nXSrc, int nYSrc, DWORD dwRop)
{
    return fpDIBtoDC(hdc, nXDest, nYDest, nWidth, nHeight, hDIB, nXSrc, nYSrc, dwRop);
}
//---------------------------------------------------------------------------
BOOL DIBto24Bit(HDIB hDIB)
{
    return fpDIBto24Bit(hDIB);
}
//---------------------------------------------------------------------------
HDIB PNGtoDIB(const char *file)
{
    return fpPNGtoDIB(file);
}
//---------------------------------------------------------------------------
HDIB JPGtoDIB(const char *file)
{
    return fpJPGtoDIB(file);
}
//---------------------------------------------------------------------------
// sNZ`]Balpha̍ől256ŁA̎sB
/*void CopyPixel32To32(LPDWORD lpdwDst, int dstWidth, int dstHeight, int dstX1, int dstY1,
    LPDWORD lpdwSrc, int srcX1, int srcY1, int srcX2, int srcY2, int alpha)
{
    // NbsOB
    if(x1 < 0){
        x1 = 0;
    }
    if(x2 >= width){
        x2 = width - 1;
    }
    if(y1 < 0){
        y1 = 0;
    }
    if(y2 >= height){
        y2 = height - 1;
    }
    if(x1 >= x2 || y1 >= y2){
        return;
    }
    if(alpha >= 256){
        for(int y=y1; y<y2; y++){
//            LPDWORD lpdw = lpdwPixel + (height - y - 1)*width + x1;
            LPDWORD lpdw = PIXEL(lpdwPixel, width, height, x1, y);
            for(int x=x1; x<x2; x++){
                *lpdw = color;
                lpdw++;
            }
        }
    }
    else{
        int r = ((color>>16) & 0xff)*alpha;
        int g = ((color>>8) & 0xff)*alpha;
        int b = (color & 0xff)*alpha;
        int d = 256-alpha;
        for(int y=y1; y<y2; y++){
//            LPDWORD lpdw = lpdwPixel + (height - y - 1)*width + x1;
            LPDWORD lpdw = PIXEL(lpdwPixel, width, height, x1, y);
            for(int x=x1; x<x2; x++){
                int dr = (((((*lpdw)>>16) & 0xff)*d)+r) & 0xff00;
                int dg = (((((*lpdw)>>8) & 0xff)*d)+g) & 0xff00;
                int db = ((((*lpdw) & 0xff)*d)+b) & 0xff00;
                // At@l|l8bitEVtgȂ΂Ȃ̂ŁAł܂Ƃ߂ĂB
                *lpdw = (dr<<8) | dg | (db>>8);
                lpdw++;
            }
        }
    }
}*/
//---------------------------------------------------------------------------
// ܂ދ``sBalpha̍ől256ŁA̎sB
void FillRectRGBA(LPDWORD lpdwPixel, int width, int height, int x1, int y1, int x2, int y2, COLORREF color, int alpha)
{
    // NbsOB
    if(x1 < 0){
        x1 = 0;
    }
    if(x2 >= width){
        x2 = width - 1;
    }
    if(y1 < 0){
        y1 = 0;
    }
    if(y2 >= height){
        y2 = height - 1;
    }
    if(x1 >= x2 || y1 >= y2){
        return;
    }
    if(alpha >= 256){
        for(int y=y1; y<y2; y++){
//            LPDWORD lpdw = lpdwPixel + (height - y - 1)*width + x1;
            LPDWORD lpdw = PIXEL(lpdwPixel, width, height, x1, y);
            for(int x=x1; x<x2; x++){
                *lpdw = color;
                lpdw++;
            }
        }
    }
    else{
        int r = ((color>>16) & 0xff)*alpha;
        int g = ((color>>8) & 0xff)*alpha;
        int b = (color & 0xff)*alpha;
        int d = 256-alpha;
        for(int y=y1; y<y2; y++){
//            LPDWORD lpdw = lpdwPixel + (height - y - 1)*width + x1;
            LPDWORD lpdw = PIXEL(lpdwPixel, width, height, x1, y);
            for(int x=x1; x<x2; x++){
                int dr = (((((*lpdw)>>16) & 0xff)*d)+r) & 0xff00;
                int dg = (((((*lpdw)>>8) & 0xff)*d)+g) & 0xff00;
                int db = ((((*lpdw) & 0xff)*d)+b) & 0xff00;
                // At@l|l8bitEVtgȂ΂Ȃ̂ŁAł܂Ƃ߂ĂB
                *lpdw = (dr<<8) | dg | (db>>8);
                lpdw++;
            }
        }
    }
}
//---------------------------------------------------------------------------
// ܂ދ``sBalpha̍ől256ŁA̎sB
void FrameRectRGBA(LPDWORD lpdwPixel, int width, int height, int x1, int y1, int x2, int y2, COLORREF color, int alpha)
{
    // NbsOB
    if(x1 < 0){
        x1 = 0;
    }
    if(x2 >= width){
        x2 = width - 1;
    }
    if(y1 < 0){
        y1 = 0;
    }
    if(y2 >= height){
        y2 = height - 1;
    }
    if(x1 >= x2 || y1 >= y2){
        return;
    }
    if(alpha >= 256){
        // c̐B
        for(int y=y1; y<y2; y++){
            *PIXEL(lpdwPixel, width, height, x1, y) = color;
            *PIXEL(lpdwPixel, width, height, x2-1, y) = color;
        }
        // ̐B
        for(int x=x1+1; x<x2-1; x++){
            *PIXEL(lpdwPixel, width, height, x, y1) = color;
            *PIXEL(lpdwPixel, width, height, x, y2-1) = color;
        }
    }
    else{
        int r = ((color>>16) & 0xff)*alpha;
        int g = ((color>>8) & 0xff)*alpha;
        int b = (color & 0xff)*alpha;
        int d = 256-alpha;
        for(int y=y1; y<y2; y++){
            for(int x=x1; x<x2; x++){
                // `̓ł̓[v΂ĂB蔲B
                if(x > x1 && y > y1 && x < x2-1 && y < y2-1)
                    continue;
                LPDWORD lpdw = PIXEL(lpdwPixel, width, height, x, y);
                int dr = (((((*lpdw)>>16) & 0xff)*d)+r) & 0xff00;
                int dg = (((((*lpdw)>>8) & 0xff)*d)+g) & 0xff00;
                int db = ((((*lpdw) & 0xff)*d)+b) & 0xff00;
                // At@l|l8bitEVtgȂ΂Ȃ̂ŁAł܂Ƃ߂ĂB
                *lpdw = (dr<<8) | dg | (db>>8);
            }
        }
    }
}
//---------------------------------------------------------------------------
// ks_window_rectangle()ŎgBgȂ̂Ȃ̂ŎcB
void DrawRectangle(HDC hdc, int x1, int y1, int x2, int y2, COLORREF lineColor, COLORREF inColor)
{
    HPEN hPen, hOldPen;
    HBRUSH hBrush, hOldBrush;

    hPen = CreatePen(PS_SOLID, 1, lineColor);
	if((inColor & 0xff000000) == 0){
        hBrush = CreateSolidBrush(inColor);
	}else{
        hBrush = (HBRUSH)GetStockObject(NULL_BRUSH);
	}
    hOldPen = (HPEN)SelectObject(hdc, hPen);
    hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);
    Rectangle(hdc, x1,y1,x2,y2);
    SelectObject(hdc, hOldPen);
    SelectObject(hdc, hOldBrush);
    DeleteObject(hPen);
	if((inColor & 0xff000000) == 0)
        DeleteObject(hBrush);
}
//---------------------------------------------------------------------------
void DrawString(HDC hdc, int x, int y, LPCSTR str, COLORREF charColor)
{
    int iBkMode;

    SetTextColor(hdc, charColor);
    iBkMode = GetBkMode(hdc);
    SetBkMode(hdc,TRANSPARENT);
    TextOut(hdc, x, y, str, strlen(str));
    SetBkMode(hdc,iBkMode);
}
//---------------------------------------------------------------------------
static HFONT CreateMyFont(HDC hdc, LPCTSTR face, int h)
{
    return CreateFont(h,    //tHg
        0,                    //
        0,                    //eLXg̊px
        0,                    //x[XCƂƂ̊px
        FW_REGULAR,            //tHg̏dij
        FALSE,                //C^bN
        FALSE,                //A_[C
        FALSE,                //ł
        SHIFTJIS_CHARSET,    //Zbg
        OUT_DEFAULT_PRECIS,    //o͐x
        CLIP_DEFAULT_PRECIS,//NbsOx
        PROOF_QUALITY,        //o͕i
        FIXED_PITCH | FF_MODERN,//sb`ƃt@~[
        face);    //̖
}
//---------------------------------------------------------------------------
void DrawString(HDC hdc, int x, int y, LPCSTR str, COLORREF charColor, int fontheight)
{
    int iBkMode;

    HFONT hFont = CreateMyFont(hdc, "lr SVbN", fontheight);
    HFONT hFontOld = SelectObject(hdc, hFont);
    SetTextColor(hdc, charColor);
    iBkMode = GetBkMode(hdc);
    SetBkMode(hdc,TRANSPARENT);
    TextOut(hdc, x, y, str, strlen(str));
    SetBkMode(hdc,iBkMode);
    SelectObject(hdc, hFontOld);
    DeleteObject(hFont);
}
//---------------------------------------------------------------------------
/*void CopyDIB24ToDIB32(LPDWORD lpdwDst, int dstw, int dsth, int dstx, int dsty, LPBYTE lpbSrc, int srcw, int srch, RECT srcRect)
{
    LPDWORD lpdw = lpdwDst + (height - y)*width + x1;
}*/
//---------------------------------------------------------------------------
