//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ksevent.h"
#include "ksscript.h"
#include "kslua.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_Event *Form_Event;
//---------------------------------------------------------------------------
__fastcall TForm_Event::TForm_Event(TComponent* Owner)
    : TForm(Owner), hdcBuffer(NULL), hbmpBuffer(NULL)
{
    Canvas->Pen->Style = psSolid;
    Canvas->Brush->Style = bsSolid;
    Canvas->Font->Height = 17;
    Canvas->Font->Pitch = fpFixed;
    ControlStyle = ControlStyle << csOpaque;
//    DoubleBuffered = true;
    MouseDowned = false;
    MouseClicked = false;
}
//---------------------------------------------------------------------------
__fastcall TForm_Event::~TForm_Event(void)
{
    FinalizeSurface();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Event::Form_EventMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    MouseDowned = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Event::Form_EventClick(TObject *Sender)
{
    MouseClicked = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Event::Form_EventMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    MouseLastX = X;
    MouseLastY = Y;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Event::Form_EventPaint(TObject *Sender)
{
    if(ABitmap != NULL){
        KSLua_OnPaint();
        TRect r(0, 0, ClientWidth, ClientHeight);
        Canvas->CopyRect(r, ABitmap->Canvas, r);
    }
    else{
        Script_OnPaint();
        HDC hdc = GetDC(Handle);
        BitBlt(hdc, 0, 0, ClientWidth, ClientHeight, hdcBuffer, 0, 0, SRCCOPY);
        ReleaseDC(Handle, hdc);
    }
}
//---------------------------------------------------------------------------
__fastcall TForm_Event::InitializeSurface(bool useABitmap)
{
    RECT r;

    ::GetClientRect(Handle, &r);
    if(useABitmap){
        ABitmap = new TABitmap();
        ABitmap->Width = r.right - r.left;
        ABitmap->Height = r.bottom - r.top;
    }
    else{
        HDC hdc = GetDC(Handle);
        BITMAPINFO biBMP;
        ZeroMemory(&biBMP, sizeof(biBMP));
        biBMP.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
        biBMP.bmiHeader.biBitCount = 32;
        biBMP.bmiHeader.biPlanes = 1;
        biBMP.bmiHeader.biWidth = BufferWidth = r.right - r.left;
        biBMP.bmiHeader.biHeight = BufferHeight = r.bottom - r.top;
        hbmpBuffer = CreateDIBSection(NULL, &biBMP, DIB_RGB_COLORS, (void **)(&lpdwPixel), NULL, 0);
        hdcBuffer = CreateCompatibleDC(hdc);
        SelectObject(hdcBuffer, hbmpBuffer);
        ReleaseDC(Handle, hdc);
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_Event::FinalizeSurface(void)
{
    if(hdcBuffer != NULL){
        DeleteDC(hdcBuffer);
        hdcBuffer = NULL;
    }
    if(hbmpBuffer != NULL){
        DeleteObject(hbmpBuffer);
        hbmpBuffer = NULL;
    }
    if(ABitmap != NULL){
        delete ABitmap;
        ABitmap = NULL;
    }
    return 0;
}
//---------------------------------------------------------------------------
