//---------------------------------------------------------------------------
#ifndef messagerectH
#define messagerectH
//---------------------------------------------------------------------------
#include <windows.h>
#include <vector>
#include <string>
using namespace std;

// bZ[W\̈̏B
class TMessageRectangle{
private:
    RECT ViewPort;         // bZ[Wo͂̈
    vector<string> Lines;  // \̕B
    string FontName;
    int FontHeight;
    COLORREF FontColor;
    COLORREF BGColor;
    int BGAlpha;
public:
    TMessageRectangle(void) :FontHeight(16), BGAlpha(0){
    }
    void SetViewPort(const RECT& r) { ViewPort = r; };
    void SetViewPort(int x1, int y1, int x2, int y2) { SetRect(&ViewPort, x1, y1, x2, y2); };
    const RECT& GetViewPort(void) const { return ViewPort; };
    int GetLineCount(void) const { return Lines.size(); };
    const string& GetLineAt(int index) const { return Lines[index]; };
    void SetFontName(const string& fname) { FontName = fname; };
    void SetFontHeight(int h) { FontHeight = h; };
    int GetFontHeight(void) const { return FontHeight; };
    void SetFontColor(const COLORREF& cl) { FontColor = cl; };
    const COLORREF& GetFontColor(void) const { return FontColor; };
    void SetBGColor(const COLORREF& cl) { BGColor = cl; };
    const COLORREF& GetBGColor(void) const { return BGColor; };
    void SetBGAlpha(const int& alpha) { BGAlpha = alpha; };
    int GetBGAlpha(void) const { return BGAlpha; };
    void AppendLine(const char *str);
    void ClearLine(void);
};

#endif
//---------------------------------------------------------------------------
